#include "IAEngine.h"
#include "definition.h"
#include "physicEngine.h"
#include "weaponEngine.h"
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>

shipIA shipIAList[2];
int countIA = 0;

void MoveIA(shipIA * currentIA);
void AttackIA(shipIA * currentIA);

void TickIA()
{
    for(int i = 0; i < countIA ; i++)
    {
        MoveIA(shipIAList+i);
        AttackIA(shipIAList+i);
    }
}

void TEMP_SETUP_IA()
{
    shipIAList[0].posX = 1000;
    shipIAList[0].posY = 1000;
    shipIAList[0].target = -1;
    shipIAList[0].direction = 0;
    shipIAList[0].health = 100;
    shipIAList[0].state = 1;

    shipIAList[1].posX = 1050;
    shipIAList[1].posY = 1000;
    shipIAList[1].target = 0;
    shipIAList[1].direction = 0;
    shipIAList[1].health = 100;
    shipIAList[1].state = 0;
    countIA = 1;
}
void FollowIA(shipIA * currentIA, int posX, int posY);
void EscapeIA(shipIA * currentIA, int posX, int posY);

void MoveIA(shipIA * currentIA)
{

    if(currentIA->state == 0)
    {
        if(currentIA->target == -1) // target est le player
            FollowIA(currentIA,playerX,playerY);
        else
            FollowIA(currentIA,shipIAList[currentIA->target].posX,shipIAList[currentIA->target].posY);
    }

    if(currentIA->state == 1)
    {
        if(currentIA->target == -1) // target est le player
            EscapeIA(currentIA,playerX,playerY);
        else
            EscapeIA(currentIA,shipIAList[currentIA->target].posX,shipIAList[currentIA->target].posY);
    }


}

void FollowIA(shipIA * currentIA, int posX, int posY)
{
  //  rotation = 0;
    int multiX;
    int multiY;
    int distanceX = abs(posX - currentIA->posX);
    int distanceY = abs(posY - currentIA->posY);
    if(posX < currentIA->posX) multiX = -1;
    else multiX = 1;
    if(posY < currentIA->posY) multiY = -1;
    else multiY = 1;

    currentIA->direction = DirectionAngle(currentIA->posX,currentIA->posY,posX,posY);

    if(distanceX < MIN_IA_FOLLOW_DISTANCE && distanceY < MIN_IA_FOLLOW_DISTANCE) return;

    if(distanceX > distanceY)
    {
        currentIA->speedX += IA_SPEED*multiX;
        currentIA->speedY += distanceY*IA_SPEED/distanceX*multiX;
    }
    else
    {
        currentIA->speedY += IA_SPEED*multiY;
        currentIA->speedX += distanceX*IA_SPEED/distanceY*multiX;
    }
}
void UpdateIARandom(shipIA * currentIA,int factor,int timeout)
{
    currentIA->randomTime--;

    factor += 1;

    if(currentIA->randomTime <= 0)
    {
        currentIA->randomNumber = (rand()%factor)-(factor/2);

        currentIA->randomTime = timeout;
    }
}
int clampSigned(int x)
{
    if(x >= 1) return 1;

    if(x <= 1) return -1;

    return 0;
}


void EscapeIA(shipIA * currentIA, int posX, int posY)
{
    int direction = currentIA->direction;
    int speedAddX;
    int speedAddY;
    //Randomiser - rend le comportement de fuite plus alatoire

    direction = DirectionAngle(posX,posY,currentIA->posX,currentIA->posY);

    if(abs(posX - currentIA->posX) > MIN_IA_ESCAPE_DISTANCE || abs(posY - currentIA->posY) > MIN_IA_ESCAPE_DISTANCE) return;


    UpdateIARandom(currentIA,ESCAPE_RANDOM_FACTOR,ESCAPE_RANDOM_TIME);

    if(currentIA->collision != -1)
    {
        direction += currentIA->collision;
        if(currentIA->collision > 7)
            currentIA->collision -= 8;
    }

    direction += currentIA->randomNumber;

    DirectionToPoint(direction,&speedAddX,&speedAddY);

    if(PointLineCollisionAlgorythm(currentIA->posX+10,currentIA->posY+10,speedAddX,speedAddY,5,4))
    {
        printf("COLLISION ---------------------\n");
        currentIA->collision++;
    }
    else
    {
        currentIA->collision = -1;
    }

    currentIA->direction = direction;
    currentIA->speedX += speedAddX*IA_SPEED;
    currentIA->speedY += speedAddY*IA_SPEED;
}

void KillIA(int id) // TMP-------------------------------
{
    shipIAList[id].posX = -50;
    shipIAList[id].posY = -50;
    shipIAList[id].health = 100;
}

void DamageIA(int id, int damage)
{
    shipIAList[id].health -= damage;
    if(shipIAList[id].health <= 0)
    {
        KillIA(id);
    }
}

void AttackIA(shipIA * currentIA)
{
    if(currentIA->state == 0) // attaque
    {
        FireLaser(currentIA->posX,currentIA->posY,currentIA->direction,1);
    }
}
