#ifndef CALCULATOR_H
#define CALCULATOR_H


#ifdef PC_INTERFACE

int Bfile_OpenFile(const char *filename, int mode);
int Bfile_ReadFile(int HANDLE, void *buf, int size, int readpos);
int Bfile_WriteFile(int HANDLE, const void *buf, int size);
int Bfile_CloseFile(int HANDLE);
int Bfile_CreateFile(const char *filename, int size);
int Bfile_DeleteFile(const char *filename);

#include <SFML/Graphics.hpp>
#include <SFML/Window.hpp>

#define KEY_CTRL_UP sf::Keyboard::Up
#define KEY_CTRL_DOWN sf::Keyboard::Down
#define KEY_CTRL_LEFT sf::Keyboard::Left
#define KEY_CTRL_RIGHT sf::Keyboard::Right
#define KEY_CTRL_SHIFT sf::Keyboard::RAlt


#define KEY_CHAR_0 sf::Keyboard::Numpad0
#define KEY_CHAR_8 sf::Keyboard::Numpad8
#define KEY_CHAR_2 sf::Keyboard::Numpad2
#define KEY_CHAR_4 sf::Keyboard::Numpad4
#define KEY_CHAR_6 sf::Keyboard::Numpad6
#define KEY_CHAR_7 sf::Keyboard::Numpad7
#define KEY_CHAR_9 sf::Keyboard::Numpad9
#define KEY_CHAR_1 sf::Keyboard::Numpad1
#define KEY_CHAR_3 sf::Keyboard::Numpad3
#define KEY_CHAR_5 sf::Keyboard::Numpad5

#define KEY_CTRL_F1 sf::Keyboard::F1
#define KEY_CTRL_F2 sf::Keyboard::F2

#define KEY_CTRL_F5 sf::Keyboard::F5
#define KEY_CTRL_F6 sf::Keyboard::F6


#define KEY_CTRL_EXIT sf::Keyboard::Escape

#define KEY_CTRL_EXE sf::Keyboard::Return

#define KEY_CHAR_PLUS sf::Keyboard::Add

#define KEY_CTRL_MENU sf::Keyboard::RControl

extern char RAW_CALCULATOR_VRAM[1024];

extern sf::RenderWindow * screenWindow;

void PrintXY(int x, int y,const unsigned char  * newText, int unimplemented);
#define ML_clear_vram Bdisp_AllClr_VRAM
void Bdisp_AllClr_VRAM();
#define ML_display_vram Bdisp_PutDisp_DD
void Bdisp_PutDisp_DD();
#define ML_pixel Bdisp_SetPoint_VRAM
void Bdisp_SetPoint_VRAM(int x, int y, int color);
void ML_line(int x1, int y1, int x2, int y2, char color);
void ML_horizontal_line(int y, int x1, int x2, int color);
void ML_vertical_line(int x, int y1, int y2, int color);
void ML_bmp_or_cl(const unsigned char *bmp, int x, int y, int width, int height);
int TickPCEvent();
int IsKeyDown(sf::Keyboard::Key);
void Debug_Grey_Draw(int x, int y, int value,int minValue,int maxValue);

void ML_circle(int x, int y, int radius, int color);
void ML_filled_circle(int x, int y, int radius, int color);

void Debug_Display_Window();
void Debug_Clear_Window();
int RTC_getTicks();

void InitCalculator();

#define MODsprintf sprintf

extern int randCompter;


#else



#define KEY_CHAR_0 71
#define KEY_CHAR_1 72
#define KEY_CHAR_2 62
#define KEY_CHAR_3 52
#define KEY_CHAR_4 73
#define KEY_CHAR_5 63
#define KEY_CHAR_6 53
#define KEY_CHAR_7 74
#define KEY_CHAR_8 64
#define KEY_CHAR_9 54
#define KEY_CHAR_DP 61
#define KEY_CHAR_EXP 51
#define KEY_CHAR_PMINUS 41
#define KEY_CHAR_PLUS 42
#define KEY_CHAR_MINUS 32
#define KEY_CHAR_MULT 43
#define KEY_CHAR_DIV 33
#define KEY_CHAR_FRAC 75
#define KEY_CHAR_LPAR 55
#define KEY_CHAR_RPAR 45
#define KEY_CHAR_COMMA 35
#define KEY_CHAR_STORE 25
#define KEY_CHAR_LOG 66
#define KEY_CHAR_LN 56
#define KEY_CHAR_SIN 46
#define KEY_CHAR_COS 36
#define KEY_CHAR_TAN 26
#define KEY_CHAR_SQUARE 67
#define KEY_CHAR_POW 57
#define KEY_CTRL_EXE 31
#define KEY_CTRL_DEL 44
#define KEY_CTRL_AC 32
#define KEY_CTRL_FD 65
#define KEY_CTRL_EXIT 47
#define KEY_CTRL_SHIFT 78
#define KEY_CTRL_ALPHA 77
#define KEY_CTRL_OPTN 68
#define KEY_CTRL_VARS 58
#define KEY_CTRL_UP 28
#define KEY_CTRL_DOWN 37
#define KEY_CTRL_LEFT 38
#define KEY_CTRL_RIGHT 27
#define KEY_CTRL_F1 79
#define KEY_CTRL_F2 69
#define KEY_CTRL_F3 59
#define KEY_CTRL_F4 49
#define KEY_CTRL_F5 39
#define KEY_CTRL_F6 29
#define KEY_CTRL_MENU 48

extern "C"
{
    #include <fxlib.h>
}


#include <MonochromeLib.h>
#include <stdlib.h>
#include <string.h>
#include <syscall.h>

#define max(a,b) (a > b ? a : b)
#define min(a,b) (a > b ? b : a)


void printf(...);

#define MODsprintf printf


//FIXME-------------------


#define RTC_getTicks() (0)


#define itoa(a,b,c) (0)


unsigned char KeyDown(unsigned char keycode);

#define IsKeyDown(x) KeyDown(x)
#define IsKeyUp(x) !KeyDown(x)

extern int randCompter;

#endif

void ReverseVramRectangle(int x1, int y1, int x2, int y2);

#define cell(a) (((int)(a)) != (a) ? (((int)(a))+ (a>0 ? +1 : -1)   ) : ((int)(a)))

#define max(a,b) (a > b ? a : b)

#define _OPENMODE_READ              0x01
#define _OPENMODE_READ_SHARE        0x80
#define _OPENMODE_WRITE             0x02
#define _OPENMODE_READWRITE         0x03
#define _OPENMODE_READWRITE_SHARE   0x83

#endif // CALCULATOR_H
