#include "calculator.h"



#include "gameEngine.h"



#ifdef PC_INTERFACE
#include <iostream>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <windows.h>
#endif // PC_INTERFACE


#include "worldEngine.h"
#include "renderEngine.h"
#include "definition.h"
#include "physicEngine.h"
#include "shipEngine.h"
#include "weaponEngine.h"
#include "guiEngine.h"
#include "gameEngine.h"
#include "ship.h"
#include "saveEngine.h"

const unsigned char universeTextTexture[]={
	0x0, 0x0, 0x0, 0x0, 0x0, 0x1f,
	0x45, 0xef, 0x47, 0x11, 0x33, 0xdf,
	0x45, 0x29, 0x44, 0x9b, 0x4a, 0x5f,
	0x45, 0x29, 0x44, 0x95, 0x4a, 0x5f,
	0x45, 0x2f, 0x44, 0x91, 0x7b, 0xdf,
	0x55, 0x2c, 0x44, 0x91, 0x4a, 0x1f,
	0x6d, 0x2a, 0x44, 0x91, 0x4a, 0x1f,
	0x45, 0xe9, 0x77, 0x11, 0x4a, 0x1f,
	0x0, 0x0, 0x0, 0x0, 0x0, 0x1f,
	0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
};

const unsigned char solarTextTexture[]={
	0x0, 0x0, 0x0, 0x0, 0x0, 0x1f,
	0x7b, 0xd0, 0xcf, 0x11, 0x33, 0xdf,
	0x42, 0x51, 0x29, 0x1b, 0x4a, 0x5f,
	0x42, 0x51, 0x29, 0x15, 0x4a, 0x5f,
	0x7a, 0x51, 0xef, 0x11, 0x7b, 0xdf,
	0xa, 0x51, 0x2c, 0x11, 0x4a, 0x1f,
	0xa, 0x51, 0x2a, 0x11, 0x4a, 0x1f,
	0x7b, 0xdd, 0x29, 0x11, 0x4a, 0x1f,
	0x0, 0x0, 0x0, 0x0, 0x0, 0x1f,
	0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
};

using namespace std;



int cameraX;
int cameraY;
int playerShipId;

int saveSeed;

int planetSystemX;
int planetSystemY;
int planetSectorId;

int playerCash;


void SolarMap(int systemX, int systemY)
{
    planet * planetList = (planet *)0;
    int planetCount;

    int selectedPlanet = 0;

    GeneratePlanetSector(&planetList,&planetCount,systemX,systemY);

    while(!planetList[selectedPlanet].exist)
    {
        selectedPlanet++;
        if(selectedPlanet >= planetCount) selectedPlanet = 0;
    }

    while(IsKeyDown(KEY_CTRL_EXE)) Sleep(5);

    while (!IsKeyDown(KEY_CTRL_EXIT) && !IsKeyDown(KEY_CTRL_MENU))// 1
    {
        Bdisp_AllClr_VRAM();

        ML_filled_circle(-25,32,30,1);

        for(int i = 0 ; i < planetCount ; i++)
        {
            if(!planetList[i].exist) continue;

            ML_filled_circle(planetList[i].posX,32,planetList[i].rayon,1);
            ML_circle(-25,32,25+planetList[i].posX,1);
            if(planetList[i].haveAsteroid)
                ML_circle(planetList[i].posX,32,planetList[i].rayon+ASTEROID_RENDER_RAYON,1);
            if(0 && i == selectedPlanet)
            {
                ML_horizontal_line(32 -planetList[i].distanceRayon -2, planetList[i].posX -planetList[i].distanceRayon -2, planetList[i].posX +planetList[i].distanceRayon +2, 1);
                ML_horizontal_line(32 +planetList[i].distanceRayon +2, planetList[i].posX -planetList[i].distanceRayon -2, planetList[i].posX +planetList[i].distanceRayon +2, 1);
                ML_vertical_line(planetList[i].posX -planetList[i].distanceRayon -2, 32 -planetList[i].distanceRayon -2, 32 +planetList[i].distanceRayon +2, 1);
                ML_vertical_line(planetList[i].posX +planetList[i].distanceRayon +2, 32 -planetList[i].distanceRayon -2, 32 +planetList[i].distanceRayon +2, 1);
            }
            //Bdisp_SetPoint_VRAM(planetSector[i].posX,32,1);
        }

        //printf("Selected %d at %d\n",selectedPlanet,planetSector[selectedPlanet].posX);

        if(IsKeyDown(KEY_CTRL_EXE))
        {
            zoneSeed = planetList[selectedPlanet].planetSeed;
            ReloadAllSector();

            printf("switching to planet with seed %d\n",zoneSeed);

            while(IsKeyDown(KEY_CTRL_EXE)) Sleep(5);
        }

        if(IsKeyDown(KEY_CTRL_RIGHT))
        {
            int newMax = -1;
            int newId = -1;
            for(int i = 0 ; i < planetCount ; i++)
            {
                if(planetList[i].exist)
                {
                    if(planetList[i].posX > planetList[selectedPlanet].posX)
                    {
                        if(planetList[i].posX < newMax || newMax == -1)
                        {
                            newId = i;
                            newMax = planetList[i].posX;
                        }
                    }
                }
            }

            if(newId == -1)
            {
                int newMin = planetList[selectedPlanet].posX;
                for(int i = 0 ; i < planetCount ; i++)
                {
                    if(planetList[i].exist)
                    {
                        if(planetList[i].posX < newMin)
                        {
                                newId = i;
                                newMin = planetList[i].posX;
                        }
                    }
                }
            }

            if(newId != -1)
                selectedPlanet = newId;


            while(IsKeyDown(KEY_CTRL_RIGHT)) Sleep(5);
        }
        if(IsKeyDown(KEY_CTRL_LEFT))
        {
            int newMin = -1;
            int newId = -1;
            for(int i = 0 ; i < planetCount ; i++)
            {
                if(planetList[i].exist)
                {
                    if(planetList[i].posX < planetList[selectedPlanet].posX)
                    {
                        if(planetList[i].posX > newMin || newMin == -1)
                        {
                            newId = i;
                            newMin = planetList[i].posX;
                        }
                    }
                }
            }

            if(newId == -1)
            {
                int newMax = planetList[selectedPlanet].posX;
                for(int i = 0 ; i < planetCount ; i++)
                {
                    if(planetList[i].exist)
                    {
                        if(planetList[i].posX > newMax)
                        {
                                newId = i;
                                newMax = planetList[i].posX;
                        }
                    }
                }
            }
            if(newId != -1)
                selectedPlanet = newId;

            while(IsKeyDown(KEY_CTRL_LEFT)) Sleep(5);
        }

        SimpleRectangle(0,0,43,9,0);
        ML_bmp_or_cl(solarTextTexture,0,0,44,10);

        Bdisp_PutDisp_DD();

        #ifdef PC_INTERFACE
        TickPCEvent();
        #endif // PC_INTERFACE

        Sleep(10);
    }
    free(planetList);

    while (IsKeyDown(KEY_CTRL_EXIT) || IsKeyDown(KEY_CTRL_MENU)) Sleep(5);
}

void SystemMap()
{
    int systemCameraX = planetSystemX*SYSTEM_DISTANCE - 64;

    int systemCameraY = planetSystemY*SYSTEM_DISTANCE - 32;

    int selectX;
    int selectY;


    while(IsKeyDown(KEY_CTRL_MENU)) Sleep(5);

    while (!IsKeyDown(KEY_CTRL_EXIT) && !IsKeyDown(KEY_CTRL_MENU))// 1
    {
        Bdisp_AllClr_VRAM();

// -1 et +1 pour s'assurer que le systme est dessiner mme si l'on n'en voit qu'un bout
// /!\   TAILLE_SYSTEM < MAX_SYSTEM_SLIDE NECESSAIRE !!
        int startX = (systemCameraX-MAX_SYSTEM_SLIDE)/SYSTEM_DISTANCE-1;
        int endX = (systemCameraX+128+MAX_SYSTEM_SLIDE)/SYSTEM_DISTANCE+1+1;
        int startY = (systemCameraY-MAX_SYSTEM_SLIDE)/SYSTEM_DISTANCE-1;
        int endY = (systemCameraY+64+MAX_SYSTEM_SLIDE)/SYSTEM_DISTANCE+1+1;

        int slideX = 0;
        int slideY = 0;


        for(int x = max(0,startX) ; x < endX ; x++)
        {
            for(int y = max(0,startY) ; y < endY ; y++)
            {
                GetSystemSlide(x,y,&slideX,&slideY);

                int posX = x*SYSTEM_DISTANCE-systemCameraX+slideX;
                int posY = y*SYSTEM_DISTANCE-systemCameraY+slideY;
                if(posX > 53 && posX < 73 && posY > 21 && posY < 41)
                {
                    ML_horizontal_line(posY -4 -2, posX -4 -2, posX +4 +2, 1);
                    ML_horizontal_line(posY +4 +2, posX -4 -2, posX +4 +2, 1);
                    ML_vertical_line(posX -4 -2, posY -4 -2, posY +4 +2, 1);
                    ML_vertical_line(posX +4 + 2, posY -4 -2, posY +4 +2, 1);
                    // ce point est au "centre" de l'cran
                    selectX = x;
                    selectY = y;
                }

                //ML_pixel(x*SYSTEM_DISTANCE-systemCameraX,y*SYSTEM_DISTANCE-systemCameraY,1);
                //ML_line(x*SYSTEM_DISTANCE-systemCameraX+slideX,y*SYSTEM_DISTANCE-systemCameraY+slideY,x*SYSTEM_DISTANCE-systemCameraX,y*SYSTEM_DISTANCE-systemCameraY,1);
                //Bdisp_SetPoint_VRAM(x*SYSTEM_DISTANCE-systemCameraX+slideX,y*SYSTEM_DISTANCE-systemCameraY+slideY,1);
                ML_filled_circle(posX,posY,4,1);
                //printf("Point at %d %d (raw %d %d)\n",x*SYSTEM_DISTANCE-systemCameraX+slideX,y*SYSTEM_DISTANCE-systemCameraY+slideY,x*SYSTEM_DISTANCE+slideX,y*SYSTEM_DISTANCE+slideY);
            }
        }


        if(IsKeyDown(KEY_CTRL_UP))
            systemCameraY--;
        if(IsKeyDown(KEY_CTRL_DOWN))
            systemCameraY++;
        if(IsKeyDown(KEY_CTRL_LEFT))
            systemCameraX--;
        if(IsKeyDown(KEY_CTRL_RIGHT))
            systemCameraX++;


        if(IsKeyDown(KEY_CTRL_EXE))
        {
            SolarMap(selectX,selectY);
        }
        SimpleRectangle(0,0,43,9,0);
        ML_bmp_or_cl(universeTextTexture,0,0,44,10);


        Bdisp_PutDisp_DD();

        #ifdef PC_INTERFACE
        TickPCEvent();
        #endif // PC_INTERFACE

        Sleep(10);
    }

    while(IsKeyDown(KEY_CTRL_EXIT) || IsKeyDown(KEY_CTRL_MENU)) Sleep(5);
}



int Game()
{
    //TMP DEBUG----------------------
    zoneSeed = 1234;
    //FIN---------------------

    randCompter = 1;


    int lastSecondTick = RTC_getTicks();
    int fpsCount = 0;


    int angle = 0;

    int cameraFollowShipId = 0;

    char text[50];



    Bdisp_AllClr_VRAM();

    if(InitShipEngine()) return 1;

    playerShipId = SpawnPlayer();

    printf("Got Ship %d \n",playerShipId);

    cameraFollowShipId = playerShipId;

    ReloadAllSector();

    ResetStarPoint();

    char debugChar[50];

    cameraX = shipList[cameraFollowShipId].posX-64+shipDefinition[shipList[cameraFollowShipId].type].half;
    cameraY = shipList[cameraFollowShipId].posY-32+shipDefinition[shipList[cameraFollowShipId].type].half;

    int starTickLoop = 0;

    int LastCameraX = cameraX;
    int LastCameraY = cameraY;

    int iconMode = 0;

    while (!IsKeyDown(KEY_CTRL_EXIT))
    {
        randCompter++;
        if(randCompter > 65535)
            randCompter = 1;

        int * currentX = &shipList[playerShipId].posX;

        int * currentY = &shipList[playerShipId].posY;

        int currentHalf = shipDefinition[shipList[cameraFollowShipId].type].half;

        int * currentDirection = &shipList[playerShipId].direction;

        Bdisp_AllClr_VRAM();


        TickPhysic();

        printf("%d\n",currentHalf);

        starTickLoop++;

        if(starTickLoop == LOOP_STAR_POINT_TICK_DIVI)
        {
            TickStarPoint(cameraX-LastCameraX, cameraY-LastCameraY);
            LastCameraX = cameraX;
            LastCameraY = cameraY;
            starTickLoop = 0;
        }
        cameraX = shipList[cameraFollowShipId].posX-64+currentHalf;
        cameraY = shipList[cameraFollowShipId].posY-32+currentHalf;

        *currentDirection = (angle+90+22)/45;

        TickIASpawn(playerShipId);

        TickShip();


        TickSector(cameraX,cameraY);

        RenderStarPoint();

        RenderSector();

        RenderShip();

        DrawGui(cameraFollowShipId, iconMode);


     //   printf("ship %d groupe %d is targeting %d\n",cameraFollowShipId,shipList[cameraFollowShipId].groupe,shipList[cameraFollowShipId].target);

        #ifdef PC_INTERFACE
        MODsprintf(text,"Ecran Spassus PC | %d;%d;%d;%d | %d | %d",currentSectorList[0],currentSectorList[1],currentSectorList[2],currentSectorList[3], *currentX/MAX_X_SECTOR, sectorObjectCount);
        screenWindow->setTitle(text);
        #endif


        MODsprintf(debugChar, "X%d Y%d",shipList[cameraFollowShipId].posX,shipList[cameraFollowShipId].posY);
   //     printf("%s\n",debugChar);


    //    printf("x:%d y:%d\n",cameraX,cameraY);



        if(IsKeyDown(KEY_CTRL_MENU))
           SystemMap();


        if(IsKeyDown(KEY_CHAR_8))
            MoveShip(shipList+playerShipId, 0);

        if(IsKeyDown(KEY_CHAR_2))
            MoveShip(shipList+playerShipId, 4);

        if(IsKeyDown(KEY_CHAR_6))
            MoveShip(shipList+playerShipId, 2);

        if(IsKeyDown(KEY_CHAR_4))
            MoveShip(shipList+playerShipId, -2);

        if(GAME_ALLOW_SPECTATE && IsKeyDown(KEY_CTRL_F1))
        {
            int beginId = cameraFollowShipId;

            do
            {
                cameraFollowShipId++;
                if(cameraFollowShipId >= MAX_SHIP) cameraFollowShipId = 0;
            } while(shipList[cameraFollowShipId].exist == 0 && cameraFollowShipId != beginId);

            while(IsKeyDown(KEY_CTRL_F1)) Sleep(5);
        }
        if(GAME_ALLOW_SPECTATE && IsKeyDown(KEY_CTRL_F2))
        {
            int beginId = cameraFollowShipId;

            do
            {
                cameraFollowShipId--;
                if(cameraFollowShipId < 0) cameraFollowShipId = MAX_SHIP-1;
            } while(shipList[cameraFollowShipId].exist == 0 && cameraFollowShipId != beginId);

            while(IsKeyDown(KEY_CTRL_F2)) Sleep(5);
        }

        if(IsKeyDown(KEY_CTRL_F5))
        {
            SaveGame();
            while(IsKeyDown(KEY_CTRL_F5)) Sleep(5);
        }

        if(IsKeyDown(KEY_CTRL_F6))
        {
            LoadGame();
            ResetStarPoint();
            while(IsKeyDown(KEY_CTRL_F6)) Sleep(5);
        }

        if(IsKeyDown(KEY_CTRL_SHIFT))
        {
            iconMode++;
            if(iconMode > 2)
                iconMode = 0;
            while(IsKeyDown(KEY_CTRL_SHIFT)) Sleep(5);
        }

        if(IsKeyDown(KEY_CTRL_EXE))
        {
            FireShip(playerShipId);
            printf("fire\n");
        }


        if(IsKeyDown(KEY_CHAR_7)) angle-=10;

        if(IsKeyDown(KEY_CHAR_9)) angle+=10;


        if(IsKeyDown(KEY_CHAR_5) && shipList[playerShipId].speedX < 10 && shipList[playerShipId].speedY < 10)
        {
            int objectId = -1;
            for(int i = 0 ; i < sectorObjectCount ; i++)
            {
                if(CollisionBoxPoint(sectorObject[i].posX,sectorObject[i].posY,sectorObject[i].sizeX,sectorObject[i].sizeY,*currentX+currentHalf,*currentY+currentHalf))
                {
                    objectId = i;
                }
            }

            if(objectId != -1)
            {
                if(sectorObject[objectId].type == 0)
                {
                    ShopGui(objectId*GetSectorId(shipList[playerShipId].posX,shipList[playerShipId].posX),playerShipId);
                }
                if(sectorObject[objectId].type == 1)
                {
                    shipList[playerShipId].type += 1;
                    if(shipList[playerShipId].type > 1)
                        shipList[playerShipId].type = 0;
                }
                while(IsKeyDown(KEY_CHAR_5)) Sleep(5);
            }

        }

        if(IsKeyDown(KEY_CHAR_PLUS))
        {
            BoostShip(shipList+playerShipId,10);
        }


        if(angle > 359) angle-= 360;

        if(angle < 0) angle+= 360;

        fpsCount++;

      if(lastSecondTick +128 <= RTC_getTicks())
        {
            lastSecondTick = RTC_getTicks();
            itoa(fpsCount,text,5);
            fpsCount = 0;
            #ifdef PC_INTERFACE
                printf("fps: %s\n",text);
            #else
                locate(1,1);
                Print((const unsigned char *)text);
            #endif // PC_INTERFACE
        }


        Bdisp_PutDisp_DD();

        #ifdef PC_INTERFACE
        TickPCEvent();
        #endif // PC_INTERFACE


        #ifndef PC_INTERACE
        Sleep(30);
        #endif
    }

    return 0;

}

