


#include "calculator.h"

#include "item.h"
#include "ship.h"
#include "worldObject.h"

#include "itemTexture.h"
#include "shipTexture.h"
#include "worldTexture.h"


#ifdef PC_INTERFACE
#include <windows.h>
#include <math.h>
#include <iostream>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#else


#include <fxlib.h>


#define __KEYBIOS_H__
#include "fxlib.h"



#ifndef OS2Change
#define OS2Change
#ifndef OS2Change_GetOS2
#define OS2Change_GetOS2
typedef int(*sc_i2cp2sip)(char*, char*, short int*, short int*);
const unsigned int sc0015[] = { 0xD201D002, 0x422B0009, 0x80010070, 0x0015 };
#define GlibGetOSVersionInfo (*(sc_i2cp2sip)sc0015)
int OSVersionAsInt(void)
{
char mainversion;
char minorversion;
short release;
short build;
GlibGetOSVersionInfo( &mainversion, &minorversion, &release, &build );
return ( ( mainversion << 24 ) & 0xFF000000 ) | ( ( minorversion << 16 ) & 0x00FF0000 ) | ( release & 0x0000FFFF );
}
#define isOS2 (OSVersionAsInt() >= 0x02020000)
#define OS2(x,y) ((OSVersionAsInt() >= 0x02020000)?y:x)
#endif
#ifndef OS2Change_Keyboard
#define OS2Change_Keyboard
void delay(void)
{
char i;
for (i=0; i<5; i++){};
}
unsigned char CheckKeyRow(unsigned char code)
{
unsigned char result=0;
short*PORTB_CTRL=(short*)0xA4000102;
short*PORTM_CTRL=(short*)0xA4000118;
char*PORTB=(char*)0xA4000122;
char*PORTM=(char*)0xA4000138;
char*PORTA=(char*)0xA4000120;
short smask;
char cmask;
unsigned char column, row;
column = code>>4;
row = code &0x0F;
smask = 0x0003 << (( row %8)*2);
cmask = ~( 1 << ( row %8) );
if(row <8)
{
  *PORTB_CTRL = 0xAAAA ^ smask;
  *PORTM_CTRL = (*PORTM_CTRL & 0xFF00 ) | 0x00AA;
  delay();
  *PORTB = cmask;
  *PORTM = (*PORTM & 0xF0 ) | 0x0F;
}
else
{
  *PORTB_CTRL = 0xAAAA;
  *PORTM_CTRL = ((*PORTM_CTRL & 0xFF00 ) | 0x00AA)  ^ smask;
  delay();
  *PORTB = 0xFF;
  *PORTM = (*PORTM & 0xF0 ) | cmask;
}

delay();
result = (~(*PORTA))>>column & 1;
delay();
*PORTB_CTRL = 0xAAAA;
*PORTM_CTRL = (*PORTM_CTRL & 0xFF00 ) | 0x00AA;
delay();
*PORTB_CTRL = 0x5555;
*PORTM_CTRL = (*PORTM_CTRL & 0xFF00 ) | 0x0055;
delay();

return result;
}

unsigned char KeyDown(unsigned char keycode)
{
unsigned short key[8];
const unsigned short* keyboardregister = (unsigned short*)0xA44B0000;
if(isOS2)
{
  unsigned char row = keycode%10;
  memcpy(key, keyboardregister, sizeof(unsigned short) << 3);

  return (0 != (key[row >> 1] & 1 << keycode / 10 - 1 + ((row & 1) << 3)));
}
else
{
  return CheckKeyRow((keycode % 10) + ((keycode / 10 - 1) << 4));
}
}
unsigned char GetKeyMod(unsigned int *key)
{
unsigned char x, ret;

ret = GetKey(key);

for(x = 0; x < 80; x++)
{
  if(KeyDown(x))
  {
   *key = x;
   break;
  }
}
return ret;
}

//#define GetKey(x) GetKeyMod(x)
#endif
#endif


//Thanks to Simon Lothar for this function
typedef char*(*sc_cpv)(void);
const unsigned int sc0135[] = { 0xD201D002, 0x422B0009, 0x80010070, 0x0135 };
#define ML_vram_adress (*(sc_cpv)sc0135)

#include "syscall.h"

#endif // PC_INTERFACE


using namespace std;

#include "gameEngine.h"
#include "saveEngine.h"

const unsigned char mainMenuTexture[]={
	0x80, 0x40, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x2, 0x1,
	0x40, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x2,
	0x21, 0x0, 0xf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf8, 0x0, 0x84,
	0x12, 0x0, 0x8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x8, 0x0, 0x48,
	0xc, 0x0, 0x8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x8, 0x0, 0x30,
	0x8, 0x0, 0x8, 0xff, 0x8f, 0xe0, 0x70, 0x1f, 0xf1, 0xff, 0x8, 0x10, 0xff, 0x88, 0x0, 0x10,
	0x10, 0x0, 0x8, 0x80, 0x8, 0x20, 0xd8, 0x10, 0x1, 0x0, 0x8, 0x10, 0x80, 0x8, 0x0, 0x8,
	0x20, 0x0, 0x8, 0x80, 0x8, 0x20, 0xa8, 0x10, 0x1, 0x0, 0x8, 0x10, 0x80, 0x8, 0x0, 0x4,
	0x40, 0x0, 0x8, 0x80, 0x8, 0x20, 0xa8, 0x10, 0x1, 0x0, 0x8, 0x10, 0x80, 0x8, 0x0, 0x2,
	0x81, 0xf0, 0x8, 0x80, 0xf, 0xe0, 0xa8, 0x10, 0x1, 0x0, 0x8, 0x10, 0x80, 0x8, 0x0, 0x1,
	0x1, 0xf8, 0x8, 0xff, 0x88, 0x0, 0xf8, 0x1f, 0xf1, 0xff, 0x8, 0x10, 0xff, 0x88, 0x0, 0x0,
	0x1, 0xf8, 0x8, 0x0, 0x88, 0x1, 0xfc, 0x0, 0x10, 0x1, 0x8, 0x10, 0x0, 0x88, 0x0, 0x0,
	0x0, 0x30, 0x8, 0x0, 0x88, 0x1, 0xfc, 0x0, 0x10, 0x1, 0x8, 0x10, 0x0, 0x88, 0x0, 0x0,
	0x7, 0xff, 0x88, 0x0, 0x88, 0x3, 0xfe, 0x0, 0x10, 0x1, 0x8, 0x10, 0x0, 0x88, 0x0, 0x0,
	0xf, 0xf8, 0xc8, 0xff, 0x88, 0x3, 0xfe, 0x1f, 0xf1, 0xff, 0xf, 0xf0, 0xff, 0x88, 0x0, 0x0,
	0xf, 0xff, 0x48, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x8, 0x0, 0x0,
	0xf, 0xff, 0x48, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x8, 0x0, 0x0,
	0xf, 0xff, 0x4f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf8, 0x0, 0x0,
	0xf, 0xf8, 0xc0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
	0x7, 0xff, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
	0x0, 0x30, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
	0x1, 0xf8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
	0x1, 0xf8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
	0x1, 0xf0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
	0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
	0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
	0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
	0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
	0x0, 0x0, 0x0, 0x0, 0x0, 0x1f, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
	0x0, 0x0, 0x0, 0x0, 0x0, 0x1f, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
	0x0, 0x0, 0x0, 0x0, 0x0, 0x1f, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
	0x0, 0x3, 0xe0, 0x0, 0x0, 0x3, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
	0x0, 0x3, 0xf0, 0x0, 0x0, 0x7f, 0xf8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
	0x0, 0x3, 0xf0, 0x0, 0x0, 0xff, 0x8c, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
	0x0, 0x0, 0x60, 0x0, 0x0, 0xff, 0xf4, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
	0x0, 0xf, 0xff, 0x0, 0x0, 0xff, 0xf4, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
	0x0, 0x1f, 0xf1, 0x80, 0x0, 0xff, 0xf4, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
	0x0, 0x1f, 0xfe, 0x80, 0x0, 0xff, 0x8c, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
	0x0, 0x1f, 0xfe, 0x80, 0x0, 0x7f, 0xf8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
	0x0, 0x1f, 0xfe, 0x80, 0x0, 0x3, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
	0x0, 0x1f, 0xf1, 0x80, 0x0, 0x1f, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
	0x0, 0xf, 0xff, 0x0, 0x0, 0x1f, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
	0x0, 0x0, 0x60, 0x0, 0x0, 0x1f, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
	0x0, 0x3, 0xf0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
	0x0, 0x3, 0xf0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
	0x0, 0x3, 0xe0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
	0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
	0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
	0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
	0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
	0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
	0x0, 0x3, 0xff, 0xff, 0xff, 0xff, 0xfe, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
	0x0, 0x2, 0x0, 0x0, 0x0, 0x0, 0x2, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
	0x0, 0x2, 0x8, 0x70, 0x18, 0x85, 0xf2, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
	0x80, 0x2, 0x18, 0x88, 0x24, 0xc5, 0x2, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1,
	0x40, 0x2, 0x28, 0x88, 0x24, 0xa5, 0x2, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x2,
	0x20, 0x2, 0x48, 0x88, 0x24, 0xa5, 0x2, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x4,
	0x10, 0x2, 0x8, 0x88, 0x42, 0xa5, 0xf2, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x8,
	0x8, 0x2, 0x8, 0x88, 0x7e, 0x94, 0x12, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x10,
	0xc, 0x2, 0x8, 0x88, 0x42, 0x94, 0x12, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x30,
	0x12, 0x2, 0x8, 0x88, 0x42, 0x94, 0x12, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x48,
	0x21, 0x2, 0x8, 0x88, 0x42, 0x8c, 0x12, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x84,
	0x40, 0x82, 0x8, 0x70, 0x42, 0x85, 0xf2, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x2,
	0x80, 0x42, 0x0, 0x0, 0x0, 0x0, 0x2, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x2, 0x1,
};

const unsigned char menuSlideTexture[]={
	0x85, 0xf4, 0x4, 0x3f, 0x10, 0x44, 0x7f,
	0xc5, 0x4, 0x4, 0x20, 0x28, 0xaa, 0x4f,
	0xa5, 0x4, 0x44, 0x20, 0x28, 0x92, 0x4f,
	0xa5, 0xf2, 0x48, 0x27, 0x28, 0x92, 0x7f,
	0x95, 0x2, 0xa8, 0x21, 0x7d, 0x1, 0x4f,
	0x95, 0x2, 0xa8, 0x21, 0x45, 0x1, 0x4f,
	0x8d, 0x2, 0xa8, 0x21, 0x45, 0x1, 0x4f,
	0x85, 0xf1, 0x10, 0x3f, 0x45, 0x1, 0x7f,
	0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xf,
	0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xf,
	0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xf,
	0x87, 0xc4, 0x78, 0x3f, 0x10, 0x44, 0x7f,
	0x84, 0x4a, 0x44, 0x20, 0x28, 0xaa, 0x4f,
	0x84, 0x4a, 0x44, 0x20, 0x28, 0x92, 0x4f,
	0x84, 0x4a, 0x44, 0x27, 0x28, 0x92, 0x7f,
	0x84, 0x5f, 0x44, 0x21, 0x7d, 0x1, 0x4f,
	0x84, 0x51, 0x44, 0x21, 0x45, 0x1, 0x4f,
	0x84, 0x51, 0x44, 0x21, 0x45, 0x1, 0x4f,
	0xf7, 0xd1, 0x78, 0x3f, 0x45, 0x1, 0x7f,
	0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xf,
	0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xf,
	0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xf,
	0xf7, 0x9e, 0xe7, 0x7d, 0xe0, 0x0, 0xf,
	0x84, 0x50, 0x90, 0x11, 0x0, 0x0, 0xf,
	0x84, 0x50, 0x92, 0x11, 0x0, 0x0, 0xf,
	0x87, 0x9e, 0x92, 0x11, 0xe0, 0x0, 0xf,
	0x86, 0x10, 0x92, 0x10, 0x20, 0x0, 0xf,
	0x85, 0x10, 0x92, 0x10, 0x20, 0x0, 0xf,
	0x84, 0x90, 0x92, 0x10, 0x20, 0x0, 0xf,
	0xf4, 0x5e, 0xe2, 0x11, 0xe0, 0x0, 0xf,
};

const unsigned char creditTexture[]={
	0x4, 0x0, 0x8f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf8, 0x40, 0x8,
	0x2, 0x1, 0x8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x8, 0x20, 0x10,
	0x1, 0x2, 0x8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x8, 0x10, 0x20,
	0x0, 0xfc, 0x8, 0xff, 0x8f, 0xe0, 0x70, 0x1f, 0xf1, 0xff, 0x8, 0x10, 0xff, 0x88, 0xf, 0xc0,
	0x1, 0x2, 0x8, 0x80, 0x8, 0x20, 0xd8, 0x10, 0x1, 0x0, 0x8, 0x10, 0x80, 0x8, 0x10, 0x20,
	0x2, 0x1, 0x8, 0x80, 0x8, 0x20, 0xa8, 0x10, 0x1, 0x0, 0x8, 0x10, 0x80, 0x8, 0x20, 0x10,
	0x4, 0x0, 0x88, 0x80, 0x8, 0x20, 0xa8, 0x10, 0x1, 0x0, 0x8, 0x10, 0x80, 0x8, 0x40, 0x8,
	0xf8, 0x0, 0x78, 0x80, 0xf, 0xe0, 0xa8, 0x10, 0x1, 0x0, 0x8, 0x10, 0x80, 0xf, 0x80, 0x7,
	0x4, 0x0, 0x88, 0xff, 0x88, 0x0, 0xf8, 0x1f, 0xf1, 0xff, 0x8, 0x10, 0xff, 0x88, 0x40, 0x8,
	0x2, 0x1, 0x8, 0x0, 0x88, 0x1, 0xfc, 0x0, 0x10, 0x1, 0x8, 0x10, 0x0, 0x88, 0x20, 0x10,
	0x1, 0x2, 0x8, 0x0, 0x88, 0x1, 0xfc, 0x0, 0x10, 0x1, 0x8, 0x10, 0x0, 0x88, 0x10, 0x20,
	0x0, 0xfc, 0x8, 0x0, 0x88, 0x3, 0xfe, 0x0, 0x10, 0x1, 0x8, 0x10, 0x0, 0x88, 0xf, 0xc0,
	0x1, 0x2, 0x8, 0xff, 0x88, 0x3, 0xfe, 0x1f, 0xf1, 0xff, 0xf, 0xf0, 0xff, 0x88, 0x10, 0x20,
	0x2, 0x1, 0x8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x8, 0x20, 0x10,
	0x4, 0x0, 0x88, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x8, 0x40, 0x8,
	0xf8, 0x0, 0x7f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x80, 0x7,
	0x4, 0x0, 0x81, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xa0, 0x40, 0x8,
	0x2, 0x1, 0x1, 0x0, 0x41, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x40, 0x20, 0x10,
	0x1, 0x2, 0x2, 0x0, 0x61, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x20, 0x10, 0x20,
	0x0, 0xfc, 0x4, 0x0, 0x51, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x10, 0xf, 0xc0,
	0x1, 0x2, 0x8, 0x0, 0x51, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x8, 0x10, 0x20,
	0x2, 0x1, 0x10, 0x0, 0x51, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x4, 0x20, 0x10,
	0x4, 0x0, 0xa0, 0x0, 0x51, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x2, 0x40, 0x8,
	0xf8, 0x0, 0x40, 0x0, 0x49, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x80, 0x7,
	0x4, 0x0, 0x80, 0x0, 0x49, 0x3c, 0xf3, 0xcf, 0x9f, 0x1e, 0x49, 0x0, 0x0, 0x0, 0xc0, 0x8,
	0x2, 0x1, 0x0, 0x0, 0x49, 0x20, 0x82, 0x8, 0x84, 0x12, 0x9, 0x0, 0x0, 0x0, 0x60, 0x10,
	0x1, 0x2, 0x0, 0x0, 0x49, 0x20, 0x82, 0x8, 0x84, 0x12, 0x4d, 0x0, 0x0, 0x0, 0x30, 0x20,
	0x0, 0xfc, 0x0, 0x0, 0x49, 0x20, 0x82, 0x8, 0x84, 0x1e, 0x4d, 0x0, 0x0, 0x0, 0x1f, 0xc0,
	0x1, 0x8, 0x0, 0x0, 0x45, 0x3c, 0xf3, 0xc8, 0x84, 0x18, 0x4d, 0x0, 0x0, 0x0, 0x8, 0x20,
	0x2, 0x10, 0x0, 0x0, 0x45, 0x20, 0x10, 0x48, 0x84, 0x14, 0x4b, 0x0, 0x0, 0x0, 0x4, 0x10,
	0x4, 0x20, 0x0, 0x0, 0x45, 0x20, 0x10, 0x48, 0x84, 0x14, 0x4b, 0x0, 0x0, 0x0, 0x2, 0x8,
	0xf8, 0x40, 0x0, 0x0, 0x43, 0x20, 0x10, 0x48, 0x84, 0x14, 0x4b, 0x0, 0x0, 0x0, 0x1, 0x7,
	0x4, 0x80, 0x0, 0x0, 0x41, 0x3c, 0xf3, 0xcf, 0x84, 0x12, 0x49, 0x0, 0x0, 0x0, 0x0, 0x88,
	0x3, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50,
	0x2, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x20,
	0x4, 0x0, 0x0, 0x0, 0x0, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x10,
	0x8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x8,
	0x10, 0x0, 0xfa, 0x1e, 0x8b, 0xdf, 0x78, 0x1e, 0xf7, 0xaf, 0x80, 0x5f, 0x3d, 0x17, 0x80, 0x4,
	0x20, 0x0, 0x8a, 0x12, 0xca, 0x4, 0x40, 0x10, 0x94, 0x8, 0x80, 0xd1, 0x25, 0x94, 0x0, 0x2,
	0xf0, 0x0, 0x8a, 0x12, 0xca, 0x4, 0x40, 0x10, 0x94, 0x28, 0x81, 0x51, 0x25, 0x94, 0x0, 0x1,
	0x8, 0x0, 0xfa, 0x1e, 0xca, 0x4, 0x40, 0x10, 0xf4, 0x28, 0x80, 0x51, 0x25, 0x94, 0x0, 0x2,
	0x4, 0x0, 0x82, 0x12, 0xab, 0xc4, 0x78, 0x10, 0x97, 0xa8, 0x80, 0x51, 0x3d, 0x57, 0x80, 0x4,
	0x2, 0x0, 0x82, 0x12, 0x9a, 0x4, 0x40, 0x10, 0x90, 0xa8, 0x80, 0x51, 0x25, 0x30, 0x80, 0x8,
	0x1, 0x0, 0x82, 0x12, 0x9a, 0x4, 0x40, 0x10, 0x90, 0xa8, 0x80, 0x51, 0x25, 0x30, 0x80, 0x10,
	0x1, 0x80, 0x82, 0x12, 0x9a, 0x4, 0x40, 0x10, 0x90, 0xa8, 0x80, 0x51, 0x25, 0x30, 0x80, 0x20,
	0x2, 0x40, 0x83, 0xd2, 0x8b, 0xc4, 0x78, 0x1e, 0x97, 0xaf, 0x80, 0x5f, 0x25, 0x17, 0x80, 0x50,
	0x4, 0x20, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x88,
	0xf8, 0x10, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x7,
	0x4, 0x8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x2, 0x8,
	0x2, 0x4, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x4, 0x10,
	0x1, 0x2, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x8, 0x20,
	0x0, 0xfd, 0x0, 0x0, 0x0, 0x0, 0x7e, 0x3f, 0x84, 0x80, 0x0, 0x0, 0x0, 0x0, 0x1f, 0xc0,
	0x1, 0x2, 0x80, 0x0, 0x0, 0x0, 0x2, 0x20, 0x8c, 0x80, 0x0, 0x0, 0x0, 0x0, 0x30, 0x20,
	0x2, 0x1, 0x40, 0x0, 0x0, 0x0, 0x2, 0x20, 0x94, 0x80, 0x0, 0x0, 0x0, 0x0, 0x60, 0x10,
	0x4, 0x0, 0xa0, 0x0, 0x0, 0x0, 0x2, 0x20, 0xa4, 0x80, 0x0, 0x0, 0x0, 0x0, 0xc0, 0x8,
	0xf8, 0x0, 0x70, 0x0, 0x0, 0x0, 0x2, 0x20, 0x84, 0x90, 0x0, 0x0, 0x0, 0x1, 0x80, 0x7,
	0x4, 0x0, 0x88, 0x0, 0x0, 0x0, 0x7e, 0x20, 0x84, 0x90, 0x0, 0x0, 0x0, 0x2, 0x40, 0x8,
	0x2, 0x1, 0x4, 0x0, 0x0, 0x0, 0x40, 0x20, 0x84, 0xfc, 0x0, 0x0, 0x0, 0x4, 0x20, 0x10,
	0x1, 0x2, 0x2, 0x0, 0x0, 0x0, 0x40, 0x20, 0x84, 0x10, 0x0, 0x0, 0x0, 0x8, 0x10, 0x20,
	0x0, 0xfc, 0x1, 0x0, 0x0, 0x0, 0x40, 0x20, 0x84, 0x10, 0x0, 0x0, 0x0, 0x10, 0xf, 0xc0,
	0x1, 0x2, 0x0, 0x80, 0x0, 0x0, 0x40, 0x20, 0x84, 0x10, 0x0, 0x0, 0x0, 0x20, 0x10, 0x20,
	0x2, 0x1, 0x0, 0xc0, 0x0, 0x0, 0x7e, 0x3f, 0x84, 0x10, 0x0, 0x0, 0x0, 0x40, 0x20, 0x10,
	0x4, 0x0, 0x81, 0x20, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xa0, 0x40, 0x8,
	0xf8, 0x0, 0x7e, 0x10, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x1f, 0x80, 0x7,
};



void ShowCredits()
{
    while(!IsKeyDown(KEY_CTRL_EXE) && !IsKeyDown(KEY_CTRL_EXIT))
    {
        Bdisp_AllClr_VRAM();

        ML_bmp_or_cl(creditTexture,0,0,128,64);


        Bdisp_PutDisp_DD();

        #ifdef PC_INTERFACE
        TickPCEvent();
        #endif

        Sleep(10);
    }
}

void HideOutsideRect(int posX, int posY, int sizeX, int sizeY)
{
    for(int x = 0 ; x < 128 ; x++)
        for(int y = 0 ; y < 64 ; y++)
        {
            if(x < posX || y < posY || x > posX+sizeX || y > posY+sizeY)
                ML_pixel(x,y,0);
            else if(x < posX+1 || y < posY+1 || x > posX+sizeX-1 || y > posY+sizeY-1)
                ML_pixel(x,y,1);
        }
}
void SolarMap(int systemX, int systemY);

void GameMenu()
{

    int cursor = 0;


    while(!IsKeyDown(KEY_CTRL_EXIT))
    {
        Bdisp_AllClr_VRAM();

        ML_bmp_or_cl(menuSlideTexture,60,32-(cursor*11),52,30);
        HideOutsideRect(57,19,57,64);

        ML_bmp_or_cl(mainMenuTexture,0,0,128,64);


        if(IsKeyDown(KEY_CTRL_UP))
        {
            cursor--;
            while(IsKeyDown(KEY_CTRL_UP)) Sleep(5);
        }
        if(IsKeyDown(KEY_CTRL_DOWN))
        {
            cursor++;
            while(IsKeyDown(KEY_CTRL_DOWN)) Sleep(5);
        }


        if(cursor > 2) cursor = 2;
        if(cursor < 0) cursor = 0;

        Bdisp_PutDisp_DD();

        #ifdef PC_INTERFACE
        TickPCEvent();
        #endif // PC_INTERFACE

        if(IsKeyDown(KEY_CTRL_EXE))
        {
            while(IsKeyDown(KEY_CTRL_EXE)) Sleep(5);
            if(cursor == 0)
            {
                saveSeed = 1234;
                Game();
            }
            if(cursor == 1)
            {
                saveSeed = 1234;
                LoadGame();
                Game();
            }
            if(cursor == 2) ShowCredits();
            while(IsKeyDown(KEY_CTRL_EXIT) || IsKeyDown(KEY_CTRL_EXE)) Sleep(5);
        }

        Sleep(10);
    }
    while(IsKeyDown(KEY_CTRL_EXE)) Sleep(5);

}

int main()
{

    setitemDefinition();
    setshipDefinition();
    setobjectDefinition();

    setitemTexture();
    setshipTexture();
    setworldTexture();

    #ifdef PC_INTERFACE
    InitCalculator();

    #else
    #endif
    Bdisp_AllClr_VRAM();

    Bdisp_SetPoint_VRAM(0,0,1);

    Bdisp_PutDisp_DD();


    GameMenu();



    return 0;
}
