#include "calculator.h"


#include "renderEngine.h"

#include "ship.h"
#include "shipTexture.h"
#include "shipEngine.h"
#include "physicEngine.h"
#include "worldTexture.h"

#include "worldEngine.h"


#ifdef PC_INTERFACE
#include <stdio.h>
#include <windows.h>
#endif

#include <stdlib.h>

starPoint starPointList[STAR_POINT_COUNT];


void RenderSector()
{

 //   printf("PRESENT : [");

    for(int i = 0 ; i < sectorObjectCount ; i++)
    {

           if(sectorObject[i].posX-cameraX > 127 ||
           sectorObject[i].posY-cameraY > 64 ||
           sectorObject[i].posX-cameraX+sectorObject[i].sizeX < 0 ||
           sectorObject[i].posY-cameraY+sectorObject[i].sizeY < 0) continue;


       // if(cameraX > 10000)
       //     Sleep(1000);


        DrawSprite8bit(worldTexture[sectorObject[i].texture],sectorObject[i].posX-cameraX,sectorObject[i].posY-cameraY,sectorObject[i].sizeX,sectorObject[i].sizeY,0);

    }

}


void RenderAShip(int id,int x,int y,int rotation8,int type)
{
    if(x+shipDefinition[type].size < 0 || y+shipDefinition[type].size < 0 || x > 127 || y > 63) return;

    //rotation+=22;

   // if(rotation > 359) rotation -=360;
    if(rotation8 > 7) rotation8 -=8;

    //int rotation8 = (rotation*8/360);
    if(rotation8%2 == 0) // rotation sur 8 crans est pair donc image droite
    {
            DrawSprite8bit(shipTexture[(shipDefinition[type].texture)*2],x,y,19,19,rotation8/2);
    }
    else
    {
            DrawSprite8bit(shipTexture[(shipDefinition[type].texture)*2+1],x,y,19,19,(rotation8-1)/2);
    }

}

void RenderShip()
{

    for(int i = 0; i < MAX_SHIP ; i++)
    {
        if(shipList[i].exist)
        {
            RenderAShip(1+i,shipList[i].posX-cameraX,shipList[i].posY-cameraY,shipList[i].direction,shipList[i].type);
        }
    }


}

void DrawEmptyRectangle(int x1, int y1, int x2, int y2)
{
  //  ML_rectangle(x1+1,y1+1,x2-1,y2-1,0);
    ML_vertical_line(x2,y1,y2,1);
    ML_vertical_line(x1,y1,y2,1);
    ML_horizontal_line(y1,x1,x2,1);
    ML_horizontal_line(y2,x1,x2,1);

}

void DrawSprite8bit(const unsigned char * image, int posX, int posY,int sizeX, int sizeY, int mirror)
{
    if(mirror == 0)
    {
        for(int x = 0 ; x < sizeX ; x++)
        {
            for(int y = 0 ; y < sizeY ; y++)
            {
                if(image[x+y*sizeX] == 1)
                {
                    ML_pixel(x+posX,y+posY,1);
                }
                else if(image[x+y*sizeX] == 2)
                {
                    ML_pixel(x+posX,y+posY,0);
                }
            }
        }
    }

    if(mirror == 1)
    {
        for(int x = 0 ; x < sizeX ; x++)
        {
            for(int y = 0 ; y < sizeY ; y++)
            {
                if(image[x*sizeX+y] == 1)
                {
                    ML_pixel((sizeX-x-1)+posX,y+posY,1);
                }
                else if(image[x*sizeX+y] == 2)
                {
                    ML_pixel((sizeX-x-1)+posX,y+posY,0);
                }
            }
        }
    }
    if(mirror == 2)
    {
        for(int x = 0 ; x < sizeX ; x++)
        {
            for(int y = 0 ; y < sizeY ; y++)
            {
                if(image[x+y*sizeX] == 1)
                {
                    ML_pixel((sizeX-x-1)+posX,(sizeY-y-1)+posY,1);
                }
                else if(image[x+y*sizeX] == 2)
                {
                    ML_pixel((sizeX-x-1)+posX,(sizeY-y-1)+posY,0);
                }
            }
        }
    }
    if(mirror == 3)
    {
        for(int x = 0 ; x < sizeX ; x++)
        {
            for(int y = 0 ; y < sizeY ; y++)
            {
                if(image[x*sizeX+y] == 1)
                {
                    ML_pixel(x+posX,(sizeY-y-1)+posY,1);
                }
                else if(image[x*sizeX+y] == 2)
                {
                    ML_pixel(x+posX,(sizeY-y-1)+posY,0);
                }
            }
        }
    }
}



void SimpleRectangle(int x1, int y1, int x2, int y2, char fill_color)
{

	int i;
	if(x1 > x2)
	{
		i = x1;
		x1 = x2;
		x2 = i;
	}
	if(y1 > y2)
	{
		i = y1;
		y1 = y2;
		y2 = i;
	}
    for(i=y1 ; i<=y2 ; i++)
        ML_horizontal_line(i, x1, x2, fill_color);

}


void TickStarPoint(int moveX, int moveY)
{
    for(int i = 0 ; i < STAR_POINT_COUNT ; i++)
    {
        int randNum = randCompter*i;
        starPointList[i].posX -= moveX / STAR_POINT_DIVI;
        starPointList[i].posY -= moveY / STAR_POINT_DIVI;
        int side = -1;

        if((starPointList[i].posX < 0|| starPointList[i].posX > 127) && (starPointList[i].posY < 0|| starPointList[i].posY > 63))
        {
            side = randNum%2;
        }
        else if(starPointList[i].posX < 0|| starPointList[i].posX > 127)
        {
            side = 0;
        }
        else if(starPointList[i].posY < 0|| starPointList[i].posY > 63)
        {
            side = 1;
        }


        if(side == 0)
        {
            starPointList[i].posX = starPointList[i].posX < 0 ? 127+randNum%MAX_STAR_POINT_HIDE : 0-randNum%MAX_STAR_POINT_HIDE;
            starPointList[i].posY = (randNum*347)%64;
        }
        else if (side == 1)
        {
            starPointList[i].posX = (randNum*28)%128;
            starPointList[i].posY = starPointList[i].posY < 0 ? 63+randNum%MAX_STAR_POINT_HIDE : 0-randNum%MAX_STAR_POINT_HIDE;
        }
    }
}
void RenderStarPoint()
{
    for(int i = 0 ; i < STAR_POINT_COUNT ; i++)
        ML_pixel(starPointList[i].posX,starPointList[i].posY,1);
}

int ResetStarPoint()
{
    for(int i = 0 ; i < STAR_POINT_COUNT ; i++)
    {
        int randNum = randCompter*i*42;
        starPointList[i].posY = (randNum*347)%64;
        starPointList[i].posX = (randNum*659)%128;
    }
}
