#ifndef _IAENGINE_H_
#define _IAENGINE_H_


class ship
{
    public:
        int type;
        int posX;
        int posY;
        int health;
        int speedX;
        int speedY;
        int direction;
        int target;
        int state; // 0 = attaque, 1 = fuite
        int randomNumber;
        int randomTime;
        int collision; // 0 = bien, 1 = direction collision
        int boostState; // 0 = 0 pas de boost, -1 par tick
        int heat;
        int exist;
        int groupe;
        int targetUpdateCounter;
        int fuel;
        int escape;
        int overheat;
};

        //PRIVATE
        void MoveShip(ship * currentShip, int directionAdd);
        void EscapeIA(ship * currentIA, int posX, int posY);
        void FollowIA(ship * currentIA, int posX, int posY);
        void UpdateIARandom(ship * currentIA,int factor,int timeout);
        void AttackIA(ship * currentIA, int currentShipId);
        void KillIA(int id, int sourceId);
        void DeleteShip(int shipId);
        void FindNextTarget(ship * currentIA);
        void MoveIAForward(ship * currentIA);
        void SlowShip(ship * currentIA);

        //PUBLIC
        int InitShipEngine();
        void DamageShip(int id, int damage, int sourceId);
        void TickIASpawn(int playerId);
        void TickShip();
        int SpawnPlayer();
        void BoostShip(ship * currentShip, int boostDuration);
        void FireShip(int source);
        int CreateShip(int newType, int newPosX, int newPosY, int newTarget, int newState, int newGroupe);


        extern ship * shipList;
#endif //_IAENGINE_H_
