
#include "worldEngine.h"
#include "worldObject.h"
#include "physicEngine.h"
#include "item.h"

#ifdef PC_INTERFACE
#include <stdlib.h>
#include <stdio.h>
#include <windows.h>
#endif

#include "calculator.h"

int currentSector;

int currentSectorList[4];

int zoneSeed;

Object * sectorObject;
int sectorObjectCount;

int intHash( int a)
{
    a = (a+0x7ed55d16) + (a<<12);
    a = (a^0xc761c23c) ^ (a>>19);
    a = (a+0x165667b1) + (a<<5);
    a = (a+0xd3a2646c) ^ (a<<9);
    a = (a+0xfd7046c5) + (a<<3);
    a = (a^0xb55a4f09) ^ (a>>16);
    return a;
}

int IsSectorInScreen(int id, int sectorList[4])
{
    if(sectorList[0] == id) return 0;
    if(sectorList[1] == id) return 1;
    if(sectorList[2] == id) return 2;
    if(sectorList[3] == id) return 3;

    return -1;
}
void DrawEmptyRectangle(int X,int Y, int X2, int Y2);
void TickSector(int posX, int posY)
{
    int newSectorList[4];
    for(int x = 0 ; x < 2 ; x++)
        for(int y = 0 ; y < 2 ; y++)
            newSectorList[x+y*2] = ((posX+(x*128))/SIZE_X_SECTOR)+((posY+(y*64))/SIZE_Y_SECTOR)*MAX_X_SECTOR;

    for(int x = 0 ; x < 2 ; x++)
        for(int y = 0 ; y < 2 ; y++)
        {
       // printf("carr  %d %d %d %d    %d %d\n",(newSectorList[x+y*2]%MAX_X_SECTOR)*SIZE_X_SECTOR-cameraX,(newSectorList[x+y*2]/MAX_X_SECTOR)*SIZE_Y_SECTOR-cameraY,(newSectorList[x+y*2]%MAX_X_SECTOR)*SIZE_X_SECTOR+SIZE_X_SECTOR-cameraX,(newSectorList[x+y*2]/MAX_X_SECTOR)*SIZE_Y_SECTOR+SIZE_X_SECTOR-cameraY,cameraX, cameraY);
            if(currentSectorList[x+y*2] != newSectorList[x+y*2])
            {

                printf("Corner %d;%d changed from sector %d to %d\n",x,y,currentSectorList[x+y*2],newSectorList[x+y*2]);

                //Sleep(1000);
                // un nouveau secteur est dtect

                if(currentSectorList[x+y*2] != -1)
                {
                    if(IsSectorInScreen(currentSectorList[x+y*2],newSectorList) == -1)
                        DeleteSector(currentSectorList[x+y*2]);
                }

                if(!IsSectorLoaded(newSectorList[x+y*2]))
                {
                    LoadSector(newSectorList[x+y*2]);
                }

                currentSectorList[x+y*2] = newSectorList[x+y*2];

            }
        }


        int result = CollisionPointWorld(cameraX+64,cameraY+32);
        if(result != -1)
        {
            printf("Object-----%d  %d %d   %d\n",result,sectorObject[result].posX,sectorObject[result].posY,sectorObject[result].sector);
        }

}

void LoadSector(int sectorId)
{
    int objectToGenerate = GenerateSectorObjectCount(sectorId);

    printf("Object To Generate: %d\n",objectToGenerate);

    if(objectToGenerate == 0) return;


    // LE REALLOC EST L'ERREUR !!! IL FAIT CRASH EN DEBUG ET CREER L'IMPOSSIBLE EN RELEASE

    printf("Size To alloc : %d + %d = %d * %d\n",objectToGenerate,sectorObjectCount,(objectToGenerate+sectorObjectCount),sizeof(Object));




    Object * newPointer = (Object *) realloc(sectorObject,sizeof(Object)*(objectToGenerate+sectorObjectCount)); // on redimmensionne

    sectorObject = newPointer;


//    newPointer[0].id = -1;


    #ifdef PC_INTERFACE
    if(sectorObject == NULL)
    {
        printf("Out Of Memory");
        exit(1);
    }
    #else
    if(sectorObject == (Object *)0)
    {
        ML_clear_vram();
        locate(1,1);
        Print((const unsigned char *)"OUT OF MEMORY");
        ML_display_vram();
        Sleep(500000);
    }
    #endif
    GenerateObject(sectorId);
}



int IsSectorLoaded(int sectorId)
{
    for(int i = 0; i < sectorObjectCount ; i++)
    {
        if(sectorObject[i].sector == sectorId) return 1;
    }
    return 0;
}

void DeleteSector(int sectorId)
{
    int removeSlide = 0;
    int toDelete = 0;
    for(int i = 0; i < sectorObjectCount ; i++)
    {
        if(sectorObject[i].sector != sectorId)
        {
         //   printf("Good One found at %d\n",i);
         //   Sleep(100);
            sectorObject[removeSlide] = sectorObject[i];
            removeSlide++;
        }
        else
        {
         //   printf("Bad One found at %d\n",i);
         //   Sleep(50);
            toDelete++;
        }
    }
    sectorObjectCount -= toDelete;

    printf("REMOVED %d from sector %d\n",toDelete,sectorId);
}

int GenerateSectorObjectCount(int sectorId)
{
    int code = intHash(sectorId * zoneSeed);

    return (abs(code%MAX_OBJECT_SECTOR)+1);
}
void GenerateObject(int sectorId)
{
    int impossibleCount = 0;
    int code = intHash(sectorId * zoneSeed);
    int objectCount = GenerateSectorObjectCount(sectorId);
    //UTILISATION DE seed

    printf("Generating Sector %d...",sectorId);

    int sectorXAdd = (sectorId%MAX_X_SECTOR)*SIZE_X_SECTOR;
    int sectorYAdd = (sectorId/MAX_X_SECTOR)*SIZE_Y_SECTOR;


    for(int i = 0 ; i < objectCount ; i++)
    {
       // printf("Generating object %d\n",i);
        int currentObjectId = sectorObjectCount;
        int xMulti = 48;
        int yMulti = 12;
        int tryCount = 0;
        int impossibleToPlace = 0;
        int x = abs(intHash(code*i*xMulti)%SIZE_X_SECTOR) + sectorXAdd; // 12 et 48 pour changer, ils n'ont pas d'importance, tant qu'il sont diffrent!
        int y = abs(intHash(code*i*yMulti)%SIZE_Y_SECTOR) + sectorYAdd;
        int type = abs(intHash(code*i*24)%EXISTING_OBJECT_TYPE);
        int sizeX = objectDefinition[type].sizeX;
        int sizeY = objectDefinition[type].sizeY;
        while(1)
        {
            if(IsUsedZone(x,y,sizeX,sizeY,sectorXAdd,sectorYAdd) == -1) break;
            tryCount++;
            xMulti++;
            yMulti++;
            x = abs(intHash(code*i*xMulti)%SIZE_X_SECTOR) + sectorXAdd; // 12 et 48 pour changer, ils n'ont pas d'importance, tant qu'il sont diffrent!
            y = abs(intHash(code*i*yMulti)%SIZE_Y_SECTOR) + sectorYAdd;
            printf("try at %d %d n%d\n",x,y,tryCount);
         //   Sleep(500);

            if(tryCount > 5000)
            {
                impossibleToPlace = 1;
                impossibleCount++;
                break;
            }
        }
        if(impossibleToPlace) continue;

      //  printf("ADD X %d  Y %d\n",(currentSector%MAX_X_SECTOR)*SIZE_X_SECTOR,(currentSector/MAX_X_SECTOR)*SIZE_Y_SECTOR);
        sectorObject[currentObjectId].posX = x;
        sectorObject[currentObjectId].posY = y;


        printf("using %d %d\n",x-sectorXAdd,y-sectorYAdd);


      //  printf("---POS X %d  Y %d\n",sectorObject[i].posX,sectorObject[i].posY);
        sectorObject[currentObjectId].type = type;
        sectorObject[currentObjectId].id = 0;
        sectorObject[currentObjectId].sizeX = sizeX;
        sectorObject[currentObjectId].sizeY = sizeY;
        sectorObject[currentObjectId].sector = sectorId;
        sectorObject[currentObjectId].texture = objectDefinition[type].texture;
        sectorObjectCount++;

    }
    printf("[DONE] %d impossible\n",impossibleCount);

    return;
}
int IsUsedZone(int x, int y, int sizeX, int sizeY, int sectorPosX, int sectorPosY) // Vrifie aussi que le carr est dans le secteur
{
  //  return 1;

    int usedZone = -1;

    if(x-sectorPosX < 0 || y-sectorPosY < 0 || x-sectorPosX+sizeX > SIZE_X_SECTOR || y-sectorPosY+sizeY > SIZE_Y_SECTOR) return 0; // hors du secteur

    for(int i = 0 ; i < sectorObjectCount ; i++)
    {
        if(! ((x+sizeX) < sectorObject[i].posX ||
             (y+sizeY) < sectorObject[i].posY ||
             (x) > sectorObject[i].posX+sectorObject[i].sizeX ||
             (y) > sectorObject[i].posY+sectorObject[i].sizeY )  )
        usedZone = -1;//i;
    }

    return usedZone;
}

void GeneratePlanetSector(planet ** planetList,int * planetCount, int sectorX, int sectorY)
{
    int sectorId = sectorX + sectorY*MAX_X_PLANET_SECTOR;
    *planetCount = (abs(intHash(sectorId*saveSeed)%MAX_PLANET_IN_SECTOR)+1);


    planet * newPointer;

    newPointer = (planet *)malloc(sizeof(planet)*(*planetCount));

    if(newPointer == (planet *)0)
    {
        printf("Memory ERROR !\n");
        return; // ERREUR MEMOIRE
    }

    *planetList = newPointer;

    printf("%d planet in sector %d\n",*planetCount,sectorId);

    int posX;
    int type;
    int rayon;
    int distanceRayon;
    int haveAsteroid;


    int multiplier = 12;
    int code;
    int codeSeed;

    int tryCount;
    int exist;

    for(int i = 0 ; i < *planetCount ; i++)
    {
        tryCount = 0;
        exist = 1;
        do
        {
            multiplier++;
            codeSeed = (i+1)*multiplier*(sectorId+1)*saveSeed;
            code = abs(intHash(codeSeed));

            rayon = (code%(MAX_PLANET_RAYON-MIN_PLANET_RAYON+1))+MIN_PLANET_RAYON   ;
            haveAsteroid = code%(PLANET_ASTEROID_CHANCE+1) == PLANET_ASTEROID_CHANCE/2 ? 1 : 0;


            distanceRayon = rayon + haveAsteroid*ASTEROID_RENDER_RAYON;

            posX = (code%(128-distanceRayon*2-MIN_PLANET_DIST*2))+distanceRayon+MIN_PLANET_DIST;
            type = code%MAX_PLANET_TYPE+1;
            int free = 1;

            for(int z = 0 ; z < i ; z++)
            {
                if(!(posX+distanceRayon+MIN_PLANET_DIST < (*planetList)[z].posX-(*planetList)[z].distanceRayon || posX-distanceRayon-MIN_PLANET_DIST-MIN_PLANET_DIST > (*planetList)[z].posX+(*planetList)[z].distanceRayon))
                    free = 0;
            }
            if(free) break;
      //      printf("NO FREE code %d seed %d pos %d %d\n",code,codeSeed,posX,posY);
            tryCount++;
            if(tryCount >= MAX_PLANET_TRY)
            {
                exist = 0; // trop d'essai, on considre la planette comme inexistante
                break;
            }

        }
        while(1);

        (*planetList)[i].exist = exist;

        (*planetList)[i].posX = posX;
        (*planetList)[i].type = type;
        (*planetList)[i].haveAsteroid = haveAsteroid;
        (*planetList)[i].rayon = rayon;
        (*planetList)[i].distanceRayon = distanceRayon;
        (*planetList)[i].planetSeed = abs(intHash(sectorId*i));
        printf("planet %d at %d with rayon %d asteroid %d & distanceRayon %d\n",i,posX,rayon,haveAsteroid,distanceRayon);

    }

}
void GetSystemSlide(int x,int y,int * slideX,int * slideY)
{
    int sectorId = x + y*MAX_X_PLANET_SECTOR;

    int codeSeed = (sectorId+1)*saveSeed;
    int codeX = abs(intHash(codeSeed*48));
    int codeY = abs(intHash(codeSeed*12));

    *slideX = (codeX%(MAX_SYSTEM_SLIDE*2+1))-MAX_SYSTEM_SLIDE;
    *slideY = (codeY%(MAX_SYSTEM_SLIDE*2+1))-MAX_SYSTEM_SLIDE;
}



void GenerateShopItemList(item ** itemList, int * itemCount, int shopKey)
{
    *itemCount = (abs(intHash(shopKey*saveSeed)%MAX_ITEM_PER_SHOP)+1);

    if(*itemCount > MAX_ITEM_TYPE)
    {
        printf("MORE OBJECT THAN TYPE !!!  \n");
        Sleep(50000);
    }


    item * newPointer;

    newPointer = (item *)malloc(sizeof(item)*(*itemCount));

    if(newPointer == (item *)0)
    {
        printf("Memory ERROR !\n");
        return; // ERREUR MEMOIRE
    }

    *itemList = newPointer;

    printf("%d object in shop %d\n",*itemCount,shopKey);

    int type;
    int priceDifference;


    int multiplier = 47;
    int tryCount;
    int codeSeed;
    int code;
    int loop;

    for(int i = 0 ; i < *itemCount ; i++)
    {
        tryCount = 0;
        loop = 1;
        do
        {
            multiplier++;
            codeSeed = (i+1)*multiplier*(shopKey+1)*saveSeed;
            code = abs(intHash(codeSeed));

            type = code%(MAX_ITEM_TYPE);
            priceDifference = (code%(MAX_PRICE_DIFFERENCE*2+1)) - MAX_PRICE_DIFFERENCE;


            int free = 1;
            for(int z = 0 ; z < i ; z++)
            {
                if((*itemList)[z].type == type)
                    free = 0;
            }
            if(free) loop = 0;

        }
        while(loop);

        (*itemList)[i].type = type;

        (*itemList)[i].price = itemDefinition[type].price+priceDifference;
    }

}

int GetSectorId(int x, int y)
{
    return x/SIZE_X_SECTOR + (y/SIZE_Y_SECTOR)*MAX_X_SECTOR;
}

void ReloadAllSector()
{
    for(int i = 0 ; i < 4 ; i++)
        currentSectorList[i] = -1;

    sectorObjectCount = 0;
}

