#include "worldGenerator.h"
#include <stdlib.h>
#include <stdio.h>

#include <windows.h>

int currentSector = 0;

int currentSectorList[4] = {-1,-1,-1,-1};

int seed = 1234;

Object * sectorObject = NULL;
int sectorObjectCount = 0;

int intHash( int a)
{
    a = (a+0x7ed55d16) + (a<<12);
    a = (a^0xc761c23c) ^ (a>>19);
    a = (a+0x165667b1) + (a<<5);
    a = (a+0xd3a2646c) ^ (a<<9);
    a = (a+0xfd7046c5) + (a<<3);
    a = (a^0xb55a4f09) ^ (a>>16);
    return a;
}

int IsSectorInScreen(int id)
{
    if(currentSectorList[0] == id) return 0;
    if(currentSectorList[1] == id) return 1;
    if(currentSectorList[2] == id) return 2;
    if(currentSectorList[3] == id) return 3;

    return -1;
}
void TickSector(int posX, int posY)
{
    int newSector;
    int oldSector;
    int isFirstContact = 1;
    for(int x = 0 ; x < 2 ; x++)
        for(int y = 0 ; y < 2 ; y++)
        {
        //    printf("TESTING X%d Y%d\n",(posX+(x*128)),(posY+(y*64)));
            if(currentSectorList[x+y*2] != ((posX+(x*128))/SIZE_X_SECTOR)+((posY+(y*64))/SIZE_X_SECTOR)*MAX_X_SECTOR)
            {
                newSector = ((posX+(x*128))/SIZE_X_SECTOR)+((posY+(y*64))/SIZE_X_SECTOR)*MAX_X_SECTOR;
                oldSector = currentSectorList[x+y*2];

                printf("Corner %d;%d changed from sector %d to %d\n",x,y,oldSector,newSector);

                if(IsSectorInScreen(newSector) != -1)
                    isFirstContact = 0;


                //Sleep(1000);
                // un nouveau secteur est dtect

                currentSectorList[x+y*2] = newSector;

                if(oldSector != -1)
                    ClearSector(oldSector);

                if(isFirstContact)
                    LoadSector(newSector);
            }
        }
}

void LoadSector(int sectorId)
{
    int objectToGenerate = GenerateSectorObjectCount(sectorId);

    printf("Object To Generate: %d\n",objectToGenerate);

    if(objectToGenerate == 0) return;


    // LE REALLOC EST L'ERREUR !!! IL FAIT CRASH EN DEBUG ET CREER L'IMPOSSIBLE EN RELEASE

    printf("Size To alloc : %d + %d = %d * %d\n",objectToGenerate,sectorObjectCount,(objectToGenerate+sectorObjectCount),sizeof(Object));




    Object * newPointer = (Object *) realloc(sectorObject,sizeof(Object)*(objectToGenerate+sectorObjectCount)); // on redimmensionne


    if(sectorObject != NULL && newPointer != sectorObject)
    {
  //      free(sectorObject);
    }


    sectorObject = newPointer;


//    newPointer[0].id = -1;



    if(sectorObject == NULL)
    {
        printf("OUT OF MEMORY\n");
        Sleep(500000);
    }

    GenerateObject(sectorId);
}

void ClearSector(int sectorId)
{
    int removeSlide = 0;
    int toDelete = 0;
    if(IsSectorInScreen(sectorId) > -1)
    {
        printf("Can't delete, corner %d is using it ! \n",IsSectorInScreen(sectorId));
        return; // le secteur est dans l'cran, pourquoi le supprimer ?
    }
    else
    {
        printf("DELETING %d\n",sectorId);
    }
    for(int i = 0; i < sectorObjectCount ; i++)
    {
        if(sectorObject[i].sector != sectorId)
        {
         //   printf("Good One found at %d\n",i);
         //   Sleep(100);
            sectorObject[removeSlide] = sectorObject[i];
            removeSlide++;
        }
        else
        {
         //   printf("Bad One found at %d\n",i);
         //   Sleep(50);
            toDelete++;
        }
    }
    sectorObjectCount -= toDelete;

    printf("REMOVED %d\n",toDelete);
}

int GenerateSectorObjectCount(int sectorId)
{
    int code = intHash(sectorId * seed);

    return (abs(code%MAX_OBJECT_SECTOR)+1);
}
void GenerateObject(int sectorId)
{
    int impossibleCount = 0;
    int code = intHash(sectorId * seed);
    int objectCount = GenerateSectorObjectCount(sectorId);
    //UTILISATION DE seed

    printf("Generating Sector %d...",sectorId);

    int sectorXAdd = (sectorId%MAX_X_SECTOR)*SIZE_X_SECTOR;
    int sectorYAdd = (sectorId/MAX_X_SECTOR)*SIZE_Y_SECTOR;

    for(int i = 0 ; i < objectCount ; i++)
    {
       // printf("Generating object %d\n",i);
        int currentObjectId = sectorObjectCount;
        int xMulti = 48;
        int yMulti = 12;
        int tryCount = 0;
        int impossibleToPlace = 0;
        int x = abs(intHash(code*currentObjectId*xMulti)%SIZE_X_SECTOR) + sectorXAdd; // 12 et 48 pour changer, ils n'ont pas d'importance, tant qu'il sont diffrent!
        int y = abs(intHash(code*currentObjectId*yMulti)%SIZE_Y_SECTOR) + sectorYAdd;
        int sizeX = abs(intHash(code*currentObjectId*56)%MAX_SIZE_X_OBJECT);
        int sizeY = abs(intHash(code*currentObjectId*24)%MAX_SIZE_Y_OBJECT);
        sizeX = 10;
        sizeY = 10;
        while(1)
        {
            if(IsUsedZone(x,y,sizeX,sizeY,sectorXAdd,sectorYAdd) == 0) break;
            tryCount++;
            xMulti++;
            yMulti++;
            x = abs(intHash(code*currentObjectId*xMulti)%SIZE_X_SECTOR) + sectorXAdd; // 12 et 48 pour changer, ils n'ont pas d'importance, tant qu'il sont diffrent!
            y = abs(intHash(code*currentObjectId*yMulti)%SIZE_Y_SECTOR) + sectorYAdd;
            printf("try at %d %d n%d\n",x,y,tryCount);
         //   Sleep(500);

            if(tryCount > 5000)
            {
                impossibleToPlace = 1;
                impossibleCount++;
                break;
            }
        }
        if(impossibleToPlace) continue;

      //  printf("ADD X %d  Y %d\n",(currentSector%MAX_X_SECTOR)*SIZE_X_SECTOR,(currentSector/MAX_X_SECTOR)*SIZE_Y_SECTOR);
        sectorObject[currentObjectId].posX = x;
        sectorObject[currentObjectId].posY = y;

      //  printf("---POS X %d  Y %d\n",sectorObject[i].posX,sectorObject[i].posY);
        sectorObject[currentObjectId].id = 0;
        sectorObject[currentObjectId].sizeX = sizeX;
        sectorObject[currentObjectId].sizeY = sizeY;
        sectorObject[currentObjectId].sector = sectorId;
        sectorObjectCount++;

        /*
        sectorObject[i].sizeX = 0;
        sectorObject[i].sizeY = 0;
        sectorObject[i].sector = sectorId;
        sectorObjectCount++;
        */
    }
    printf("[DONE] %d impossible\n",impossibleCount);

    return;
}
int IsUsedZone(int x, int y, int sizeX, int sizeY, int sectorX, int sectorY) // Vrifie aussi que le carr est dans le secteur
{
  //  return 1;

    int usedZone = 0;

    if(x < sectorX || y < sectorY || x+sizeX >= sectorX+SIZE_X_SECTOR || y+sizeY >= sectorY+SIZE_Y_SECTOR) return 0; // hors du secteur

    for(int i = 0 ; i < sectorObjectCount ; i++)
    {
        if(! ((x+sizeX) < sectorObject[i].posX ||
             (y+sizeY) < sectorObject[i].posY ||
             (x) > sectorObject[i].posX+sectorObject[i].sizeX ||
             (y) > sectorObject[i].posY+sectorObject[i].sizeY )  )
        usedZone = i;
    }
  return usedZone;
}
