extern "C"
{
#include "fxlib.h"
#include "LibText.h"
#include "usefull.h"
#include "math.h"
#include "syscall.h"
}

#include "generateur.h"
#include "MonochromeLib.h"
#include "donjon.h"
#include "PNJ.h"
#include "ennemi.h"
#include "etreVivant.h"
#include "heros.h"
#include "string.h"
#include "graphisme.h"
#include "donnees.h"
#include "log.h"
#include "objet.h"
#include "options.h"
#include "allie.h"
#include "sauvegarde.h"

#define DISTANCE_MAX_TOUR 2
#define TOUR_HEROS 1
#define TOUR_ENNEMI 2
#define PRECISION_SECONDE 100000

/************************************

Classe maitresse : elle gere le donjon, et donc tout ce qui se trouve dedans, le heros, les ennemis, les objets.

************************************/

/********************************

fonctions recurrentes (comme les brosses a chiottes :p )
elles sont toujours appelees a chaque frame

********************************/



void Donjon::endFrame(int FPS)
{
framePasse += PRECISION_SECONDE/FPS;
if(framePasse >= PRECISION_SECONDE){tempsJoue++;framePasse = 0;}

}

int Donjon::startFrame()
{
if(!heros.getVivant())menu = MENU_GAME_OVER;
if(resetDemande)return 1;
frame++;
momentScrolling++;
if(momentScrolling>15000)momentScrolling = 0;

if(ville)for(int i = 0;i<tailleY;i++)for(int j=0;j<tailleX;j++)map[j+i*tailleX] = (map[j+i*tailleX]&MASQUE_N_VISION & MASQUE_N_ETRE_VIVANT) | VISIBLE;
else for(int i = 0;i<tailleY;i++)for(int j=0;j<tailleX;j++)map[j+i*tailleX] =  (map[j+i*tailleX] & MASQUE_N_ETRE_VIVANT)|INVISIBLE;  //on remet le brouillard sur tout l'etage



for(int i = 0;i<nombreEtreVivant;i++)
    {
    if(etreVivant[i]->getVivant())
        {
        int j = ((etreVivant[i]->getX()+4)/TAILLE_MAX)+((etreVivant[i]->getY()+4)/TAILLE_MAX)*tailleX;
if(j>tailleX*tailleY)j = tailleX*tailleY;
        map[j] |=MASQUE_ETRE_VIVANT;

        }
    etreVivant[i]->frame();
    }
heros.refreshCara();
return 0;
}



void Donjon::refreshBrouillard()
{
if(ville)return;
int caseX=(heros.getX()+TAILLE_MAX/2)/TAILLE_MAX;
int caseY=(heros.getY()+TAILLE_MAX/2)/TAILLE_MAX;
int tile = quelleCase(caseX,caseY);//evidemment, le mot cle case ne marche pas
int visionRafraichir = heros.getCDV()+1;
int CDVCarre = heros.getCDV()*heros.getCDV();

if((tile&MASQUE_ID) <= PORTE_FERMEE)
    {
    for(int i = max(0,caseY-visionRafraichir);i<min(tailleY,caseY+visionRafraichir);i++)
    for(int j = max(0,caseX-visionRafraichir);j<min(tailleX,caseX+visionRafraichir);j++)
        {
        int distanceX = abs(caseY-i);
        int distanceY = abs(caseX-j);
        if((distanceX*distanceX + distanceY*distanceY)-1 <=CDVCarre)
            {
            map[j+i*tailleX] = (map[j+i*tailleX]&MASQUE_N_VISION) | VISIBLE;
            }
        else
            {
            map[j+i*tailleX] |=INVISIBLE;//gere a la fois le cas brouillard et invisible
            }
        }
    }
//if(tile == MUR)erreur("vous etes dans un mur !");
if((tile&MASQUE_ID) >= SALLE)
    {
    int startX = caseX;
    int startY = caseY;
	int tailleSalleX=2;
	int tailleSalleY=2;

    while((map[startX+startY*tailleX]&MASQUE_ID)>=SALLE)startX--;
    startX++;
    while((map[startX+startY*tailleX]&MASQUE_ID)>=SALLE)startY--;
    startY++;

 while((map[(startX+tailleSalleX)+startY*tailleX]&MASQUE_ID)>=SALLE)tailleSalleX++;

 while((map[(startX)+(startY+tailleSalleY)*tailleX]&MASQUE_ID)>=SALLE)tailleSalleY++;


    for(int i = startY-1;i<startY+tailleSalleY+1;i++)
    for(int j = startX-1;j<startX+tailleSalleX+1;j++)
        map[j+i*tailleX] = (map[j+i*tailleX]&MASQUE_N_VISION) | VISIBLE;
    }

if(key_down(K_DEL))
	{

etreVivant[1]->debug();

}

}



void Donjon::tour()
{
if(tourActuel == TOUR_HEROS)
    {
    int flag =1;
   for(int i = 0;i<nombreEnnemi;i++)if(ennemi[i].tourEnCours() && ennemi[i].getVivant())flag = 0;
    if(flag)input();
    }
else
    {
    if(heros.tourEnCours())return;
    else
        {
        for(int i = 0;i<nombreObjet;i++)
            {
            if(objet[i].getX()==heros.getX() && objet[i].getY()==heros.getY())heros.ramasser(&objet[i]);
            }
        if((quelleCase(heros.getX()/TAILLE_MAX,heros.getY()/TAILLE_MAX)&MASQUE_ID)==ESCALIER_SUIVANT)genererEtage();//on ne fait l'action qu'une fois que le heros a fini de bouger
        if((quelleCase(heros.getX()/TAILLE_MAX,heros.getY()/TAILLE_MAX)&MASQUE_ID)==SORTIE_VILLE){menu<<=8;menu+=MENU_CHOIX_DESTINATION;}
        for(int i = 0;i<nombreEnnemi;i++)
            {
            if(ennemi[i].getVivant())
                {
                unsigned int choix = ennemi[i].IA(map,tailleX,tailleY,&heros);
                if((choix & IA_MASQUE_CHOIX) == IA_DEPLACEMENT)deplacement(&ennemi[i],(char)(choix&3));
                if((choix & IA_MASQUE_CHOIX) == IA_ATK)ennemi[i].attaquer(&heros,(char)(choix&3));
                }
            }
        tourActuel=TOUR_HEROS;
        }
    }
}



void Donjon::afficherMap()
{

reglerZoom();

cameraX = heros.getX()-(tailleFenetreX*TAILLE_MAX/tailleSprite)/2+tailleSprite/2;
cameraY = heros.getY()-(tailleFenetreY*TAILLE_MAX/tailleSprite)/2+tailleSprite/2;

//cameraX = min(max(cameraX,0),tailleX*TAILLE_MAX);
//cameraY = min(max(cameraY,0),tailleY*TAILLE_MAX);

for(int i = 0;i<nombreObjet;i++)objet[i].afficher(fenetreX,fenetreY,cameraX,cameraY,tailleSprite);



for(int i = 0;i<nombreEtreVivant;i++)afficherEtreVivant(etreVivant[i]);
for(int i = 0;i<nombreEtreVivant;i++)afficherInfoEtreVivant(etreVivant[i]);
for(int i = 0;i<nombreEtreVivant;i++)afficherSortEtreVivant(etreVivant[i]);



for(int j = cameraY/TAILLE_MAX-1;(j-cameraY/TAILLE_MAX-1<tailleFenetreY/tailleSprite+1)&&j<=tailleY;j++)
for(int i = cameraX/TAILLE_MAX-1;(i-cameraX/TAILLE_MAX-1<tailleFenetreX/tailleSprite+1)&&i<=tailleX;i++)
    {
    int tile = quelleCase(i,j);
    int masque = tile&MASQUE_VISION;
    int X=i*tailleSprite-cameraX/(TAILLE_MAX/tailleSprite)+fenetreX;
    int Y=j*tailleSprite-cameraY/(TAILLE_MAX/tailleSprite)+fenetreY;
    if(masque == INVISIBLE)ML_rectangle(X,Y,X+tailleSprite-1,Y+tailleSprite-1,0,ML_BLACK,ML_BLACK);
    else
        {
        if(masque == BROUILLARD)ML_rectangle(X,Y,X+tailleSprite-1,Y+tailleSprite-1,0,ML_CHECKER,ML_CHECKER);
        if((tile&MASQUE_ID) == MUR)
            {
            int para = 0;
            if((quelleCase(i+1,j)&MASQUE_ID) == MUR)para++;
            ML_rectangle(X,Y,X+tailleSprite-1,Y+tailleSprite-1,1,ML_BLACK,ML_TRANSPARENT);

            }
        if((tile&MASQUE_ID) == PORTE_FERMEE)afficherSpriteMap(PORTE_FERMEE,X,Y,tailleSprite);
        if((tile&MASQUE_ID) == ESCALIER_SUIVANT)ML_rectangle(X+1,Y+1,X+tailleSprite-2,Y+tailleSprite-2,1,ML_BLACK,ML_TRANSPARENT);

        }
    }

ML_rectangle(fenetreX-129,fenetreY-128,fenetreX+tailleFenetreX+128,fenetreY+tailleFenetreY+128,128,ML_WHITE,ML_TRANSPARENT);
ML_rectangle(fenetreX-2,fenetreY-1,fenetreX+tailleFenetreX,fenetreY+tailleFenetreY,1,ML_BLACK,ML_TRANSPARENT);

/*
String posX("posX:");
posX+=heros.getX();
Txt_Text(posX.getStr(),0,6,TXT_MINISD,TXT_OR);
String posY("posY:");
posY+=heros.getY();
Txt_Text(posY.getStr(),0,12,TXT_MINISD,TXT_OR);
String tile("zoom:");
tile+=tailleSprite;
Txt_Text(tile.getStr(),0,18,TXT_MINISD,TXT_OR);
String camX("camX:");
camX+=cameraX;
Txt_Text(camX.getStr(),0,24,TXT_MINISD,TXT_OR);
String camY("camY:");
camY+=cameraY;
Txt_Text(camY.getStr(),0,30,TXT_MINISD,TXT_OR);
ennemi[0].afficherPos();
*/

heros.afficherHUD(0,0,20,40,HUD);
afficherMiniCarte(HUD[12],HUD[15],HUD[13],HUD[14]);
if(menu)gererMenu();
afficherLog(HUD[16],HUD[17],50,HUD[18]);
}



/*********************

fonctions dependantes (la drogue c'est mal !)
elles dependent des fonctions recurentes pour s'effectuer a chaque frame, mais peuvent etre effectuer a chaque frame pendant longtemps

**********************/



void Donjon::afficherMiniCarte(int X,int Y,int tailleXT,int tailleYT)
{
ML_rectangle(X,Y,X+tailleXT,Y+tailleYT,0,ML_BLACK,ML_BLACK);

int caseX = min(tailleX,max(0,(heros.getX()/TAILLE_MAX)-(tailleXT/2)));
int caseY = min(tailleY,max(0,(heros.getY()/TAILLE_MAX)-(tailleYT/2)));
int finX = min(tailleX-caseX,tailleXT);
int finY = min(tailleY-caseY,tailleYT);
for(int i = 0;i<finX;i++,caseX++)
    {
    for(int j = 0;j<finY;j++,caseY++)
        {
        int tile = map[caseX+caseY*tailleX];//quelleCase(caseX,caseY);
        if(!(((tile& MASQUE_ID)==MUR) ||((tile& MASQUE_VISION)==INVISIBLE)))ML_pixel(X+i,Y+j,ML_WHITE);
        if(frame&8)if(((tile& MASQUE_ID)==ESCALIER_SUIVANT))ML_pixel(X+i,Y+j,ML_BLACK);
        }
    caseY-=finY;
    }
}

void Donjon::gererMenu()
{
int menuActif = menu&MENU_ACTIF_MASQUE;


actionMenu(menuActif);

if(menuActif != MENU_OPTIONS_LAYOUT || modificationTouche == -1)
for(int i = 3;i>-1;i--)if((menu>>(i*8))&MENU_ACTIF_MASQUE)afficherMenu((menu>>(i*8))&MENU_ACTIF_MASQUE);//on recupere les menu dans l'ordre d'empilage

if(menuRetour)
    {
    unsigned char sort[30];
    unsigned char colonne[30];
    unsigned char lien[30];
    unsigned char nombreSort = loadArbreCompetence(arbreCompetence,sort,colonne,lien);
    if(menuActif == MENU_ACHAT_SORT)
        {
        menuX = colonne[modificationTouche];
        if(colonne[modificationTouche-2] == menuX)menuY = 3;
        else if(colonne[modificationTouche-1] == menuX)menuY = 2;
        else menuY = 1;
        }

    modificationTouche = -1;
    nouvelleCategorie = 0;
    if(menuActif != MENU_ACHAT_SORT)nouvellePrecision = 0;
    menu>>=8;
    }
menuRetour = 0;
menuOk = 0;

}


void Donjon::actionMenu(unsigned char lequel)
{

unsigned char valeurCategorie[8]=
{
0x80,  //1xxxxxxx => 0->127
0x40,  //01xxxxxx => 0->63
0x20,  //001xxxxx => 0->31
0x08,  //00001yxx => x=0->3 y=0/1
0x04,  //000001xx => 0->3
0x03,  //00000011
0x02,  //00000010
0x01   //00000001
};

unsigned char maxPrecision[8]=
{
0x7F,
0x3F,
0x1F,
0x07,
0x03,
0,
0,
0
};
unsigned char touches[50] = {
K_F1,K_F2,K_F3,K_F4,K_F5,K_F6,
K_SHIFT,K_OPTN,K_VARS,K_MENU,
K_LEFT,K_UP,K_RIGHT,K_DOWN,
K_ALPHA,K_SQUARE,K_POW,K_EXIT,
K_XT,K_LOG,K_LN,K_SIN,
K_COS,K_TAN,K_FRAC,K_FD,
K_LPAR,K_RPAR,K_COMMA,K_STORE,
K_7,K_8,K_9,K_DEL,
K_AC,K_4,K_5,K_6,//AC a un probleme on dirait...
K_MULT,K_DIV,K_1,K_2,
K_3,K_PLUS,K_MINUS,K_0,
K_DP,K_EXP,K_PMINUS,K_EXE};

unsigned char sort[15];
unsigned char colonne[15];
unsigned char lien[15];
unsigned char nombreSort;


if(lequel == MENU_INVENTAIRE_ITEM)return;
else switch(lequel)
    {
    case MENU_PRINCIPAL:
        if(menuY>7)menuY=7;
        if(menuOk){menu<<=8;menu+=menuY+MENU_ENCYCLOPEDIE_BASE;if(menuY == 7)menu = 0;}

        break;

    case MENU_CHOIX_RACE:
        unsigned char suite[10]={K_UP,K_UP,K_DOWN,K_DOWN,K_LEFT,K_RIGHT,K_LEFT,K_RIGHT,K_LOG,K_XT};
        if(!(codeKonami&1) && key_down(suite[codeKonami>>1]))codeKonami++;
        if(codeKonami&1 && !key_down(suite[codeKonami>>1]))codeKonami++;
        menuRetour = 0;
        if(menuOk)
            {
            heros.choixRace(menuY);
            menu=MENU_SCENARIO;
            }
        break;

    case MENU_SCENARIO:
        if(menuOk)menuRetour = 1;
        if(!nouvelleCategorie)menuRetour=0;

        break;

    case MENU_OPTIONS :
        if(menuY>6)menuY=6;
         if(menuOk){menu<<=8;menu+=menuY+MENU_OPTIONS_MAP_TOUCHE;if(menuY == 7)menu = 0;}
        break;

    case MENU_CHOIX_DESTINATION :
        if(menuY>=NOMBRE_LIEUX)menuY=NOMBRE_LIEUX-1;
        if(menuOk){menu = 0;demarrerDonjon(menuY);}
        if(menuRetour)deplacement(&heros,BAS);
        break;

    case MENU_OPTIONS_ICONE:
        if(menuY>4)menuY=4;
        if(menuOk)Options::setIcone(menuY);
        break;

    case MENU_OPTIONS_FENETRE:
        if(menuY>4)menuY=4;
        if(menuOk)Options::setFenetre(menuY);
        break;

    case MENU_OPTIONS_VITESSE:
        if(menuY>10)menuY=10;
        if(menuOk)
            {
            if(menuY<=3)Options::setVitesse(menuY);
            else if(menuY !=4)Options::setFPS(menuY-4);
            }
        break;


    case MENU_OPTIONS_FONT:
        if(menuY>5)menuY=5;
        if(menuY == 5 && menuOk)Options::setDouxScrolling(1-Options::getDouxScrolling());
        else if(menuOk)Options::setFont(menuY);
        break;

    case MENU_OPTIONS_ZOOM:
        menuRetour = 1;
        if(menuY>2)menuY=2;
        if(menuX>1)menuX=1;
        if(menuOk)
            {
            if(menuX)Options::setCamera(menuY);
            else Options::setZoom(menuY);
            }
        break;



    case MENU_ACHAT_FORGERON:

        if(menuX == 0)
            {
            if(menuY>NOMBRE_OBJET-2)menuY=NOMBRE_OBJET-2;
            dialogueEnCours = menuY;
            if(menuOk)menuX = 1;
            }
        else
            {
            if(menuY>1)menuY = 1;
            if(menuOk)
                {
                if(menuY == 0)
                    {
                    int cout = getCoutObjet(dialogueEnCours+1);
                    if(heros.payer(cout) == -1)heros.recevoirObjet(dialogueEnCours+1);
                    }
                menuX = 0;
                }
            }
        break;

    case MENU_SORT :

        nombreSort = loadArbreCompetence(arbreCompetence,sort,colonne,lien);
        if(menuY)
            {
            modificationTouche = 0;
            if(menuX>colonne[nombreSort-1])menuX--;
            for(int i = 0;i<nombreSort;i++)if(colonne[i] == menuX){modificationTouche = i;break;}
            for(int i = 0;i<menuY-1 && colonne[modificationTouche+1] == menuX;i++)modificationTouche++;
            }
        else
            {
            if(modificationTouche == -1)
                {
                if(menuX>1)arbreCompetence++;
                if(menuX<1)arbreCompetence--;
                }
            menuX = 1;
            modificationTouche = -1;
            arbreCompetence = (arbreCompetence+NOMBRE_ARBRE)%NOMBRE_ARBRE;
            }
        if(menuY>3)menuY = 3;
        if(menuX>4)menuX = 4;
        if(menuOk){menu<<=8;menu+=MENU_ACHAT_SORT;}
        break;

    case MENU_ACHAT_SORT:

        nombreSort = loadArbreCompetence(arbreCompetence,sort,colonne,lien);
        if(menuY>1)menuY = 1;
        if(menuX>1)nouvelleCategorie++;
        else if(menuX<1)nouvelleCategorie--;
        nouvelleCategorie = max(0,min(nouvelleCategorie,9));
        menuX = 1;
        if(menuOk)
            {
            if(menuY == 0)
                {
                if(!heros.connaitSort(sort[modificationTouche]))
                    {
                    if(heros.getPointCompetence())
                        {
                        int flag = 1;
                        for(int i = 1;i<=lien[0];i++)
                            {
                            if((lien[i]&0xF) == modificationTouche && !heros.connaitSort(sort[(lien[i]&0xF0)>>4]))flag = 0;
                            }
                        if(flag)heros.apprendreSort(sort[modificationTouche]);
                        else nouvellePrecision = PAS_DISPONIBLE;
                        }
                    else nouvellePrecision = PAS_POINT_COMPETENCE;

                    }
                else;
                    //TODO : slot sort rapide
                }
            menuRetour = 2;
            menuOk = 0;
            }

        break;

     case MENU_FIN_DONJON:
         if(gainFinDonjon){gainFinDonjon--;
         heros.recevoirXPCompetence();}
         menuRetour = 0;
         if(menuOk && !gainFinDonjon){ville = 1;genererEtage();menuRetour = 1;}
         break;

     case MENU_OPTIONS_LAYOUT:
        if(modificationTouche == -1)
            {
            if(menuY>2)menuY = 2;
            if(menuOk)
                {
                modificationTouche = menuY;
                nouvelleCategorie = 0;
                menuY = 1;
                menuX = 1;
                menuOk = 0;
                }
            }
        else if(modificationTouche == 0)
            {
            if(menuX>1)fenetreX++;
            if(menuX<1)fenetreX--;
            menuX = 1;

            if(menuY>1)tailleFenetreX++;
            if(menuY<1)tailleFenetreX--;
            menuY = 1;
            if(menuOk)modificationTouche+=10;
            }
        else if(modificationTouche == 10)
            {
            if(menuX>1)fenetreY++;
            if(menuX<1)fenetreY--;
            menuX = 1;

            if(menuY>1)tailleFenetreY++;
            if(menuY<1)tailleFenetreY--;
            menuY = 1;
            if(menuOk)modificationTouche = -1;
            }
        else if(modificationTouche==1)
            {
            int a = (nouvelleCategorie>>1)*3;
            if((nouvelleCategorie&1))
                {
                if(menuX>1)HUD[a+1]++;
                if(menuX<1)HUD[a+1]--;
                }
            else
                {
                if(menuX>1)HUD[a]++;
                if(menuX<1)HUD[a]--;
                }
            menuX = 1;
            if(nouvelleCategorie != 8)
                {
                if(menuY>1)HUD[a+2]++;
                if(menuY<1)HUD[a+2]--;
                }
            else
                {
                if(menuY>1)HUD[a+3]++;
                if(menuY<1)HUD[a+3]--;
                }
            menuY = 1;

            if(menuOk)nouvelleCategorie++;
            if(nouvelleCategorie>9)modificationTouche = -1;
            }
        else
            {
            log("je suis un log d'exemple",LOG_INFO);
            if(nouvelleCategorie == 0)
                {
                if(menuX>1)HUD[16]++;
                if(menuX<1)HUD[16]--;
                if(menuY>1)HUD[17]++;
                if(menuY<1)HUD[17]--;
                }
            else
                {
                if(menuX>1 && HUD[18]<4)HUD[18]++;
                if(menuX<1 && HUD[18])HUD[18]--;
                if(menuY>1)HUD[19]++;
                if(menuY<1 && HUD[19])HUD[19]--;
                if(HUD[19]<1)log("je suis un log de debug",LOG_DEBUG);
                if(HUD[19]<2)log("je suis un log de warning",LOG_WARNING);
                if(HUD[19]<3)log("je suis un log d'info",LOG_INFO);
                if(HUD[19]<4)log("je suis un log verbeux",LOG_VERBOSE);
                }
            menuX = 1;
            menuY = 1;

            if(menuOk)nouvelleCategorie++;
            if(nouvelleCategorie>1)modificationTouche = -1;
            }

        break;

    case MENU_ACHAT_AUBERGE:
        if(menuY>1)menuY = 1;
        if(menuOk && menuY == 0)menu = MENU_AUBERGE;
        if(menuOk && menuY == 1)menuRetour =1;

        break;

    case MENU_OPTIONS_MAP_TOUCHE:
        if(menuY == 0 && menuOk)
            {
            modificationTouche = -1;
            while(modificationTouche==-1)
                {
                modificationTouche = -2;
                for(int i = 0;i<50;i++)
                    if(key_down(touches[i]))
                        modificationTouche = -1;
                }
            while(modificationTouche==-2)
                for(int i = 0;i<50;i++)
                    if(key_down(touches[i]))
                        modificationTouche = i;
            }
        if(menuX != 1)
            {
            if(menuY==1)nouvelleCategorie+=menuX-1;
            if(menuY==2)nouvellePrecision+=menuX-1;
            nouvelleCategorie = min(max(0,nouvelleCategorie),7);
            nouvellePrecision = min(max(0,nouvellePrecision),maxPrecision[nouvelleCategorie]);
            }
        if(menuOk && menuY == 3)
            {
            menuRetour = 1;
            configurationTouche[modificationTouche] = valeurCategorie[nouvelleCategorie]|nouvellePrecision;
            }
        menuX = 1;
        break;


  /*  case MENU_ENCYCLOPEDIE_BASE:
            if(menuY>3)menuY=3;
            menu=MENU_ENCYCLOPEDIE_MONSTRE_BASE;
            //if(menuOk){menu<<=8;}
        break;*/

    case MENU_GAME_OVER:
        if(menuOk)resetDemande = 1;
        menuRetour =0;
        break;

case MENU_ENCYCLOPEDIE_BASE:
    case MENU_ENCYCLOPEDIE_MONSTRE_BASE:
        if(menuX>1)menuY+=5;
        if(menuX<1)
            {
            if(menuY<5)menuY = 0;
            else menuY-=5;
            }
        if(menuY>15)menuY = 15;
        menuX = 1;
        break;
default : break;
    }
}

void Donjon::afficherMenu(unsigned char lequel)
{





unsigned char nomTouche[50][7]={
"F1","F2","F3","F4","F5","F6",
"shift","optn","vars","menu",
"gauche","haut","droite","bas",
"alpha","carre","^","exit",
"x t","log","ln","sin",
"cos","tan","a b/c","f<=>d",
"(",")",",","->",
"7","8","9","del",
"AC","4","5","6",
"x","/","1","2",
"3","+","-","0",
".","x10","(-)","exe"
};

unsigned char sort[15];
unsigned char colonne[15];
unsigned char lien[15];
unsigned char nombreSort = loadArbreCompetence(arbreCompetence,sort,colonne,lien);
unsigned char precisionObjet[10] = {0};

String string("");
String fleche("\001");


if(lequel == MENU_INVENTAIRE_ITEM){heros.gererInventaire(menuX,menuY,menuOk,momentScrolling,momentScrolling2) ;return;}
switch(lequel)
    {


    case MENU_CHOIX_RACE:

        unsigned char caracteristiques[11][7]=
        {
        {10,10,10,10,10,10,10},
        {12,9,12,11,9,8,9},
        {8,12,8,9,12,12,9},
        {11,8,12,12,7,8,12},
        {9,12,12,8,12,8,9},
        {11,10,10,12,8,12,7},
        {11,9,9,11,9,9,12},
        {13,5,13,11,5,9,12},
        {12,12,12,12,12,12,12},
        {13,13,13,13,13,13,13},
        {15,15,15,15,15,15,15}
        };
        unsigned char vide[10];
        unsigned char nomCara[7][10]={"vie    :","mana   :","force  :","vigueur:","intel. :","mental :","chance :"};
        fenetre(WINDOW_FULL);
        int nombreEntree = 9;
        string+="quelle race voulez vous etre ?\nhumain\nnain\nelfe\norque\ntiffelin\ndrakeide\natlante\ntroll";
        if(nouvelleCategorie == 0)
            {
            nouvelleCategorie = 3;
            if(readFile("shadow","cre",vide))nouvelleCategorie = 1;
            if(readFile("shadow","end",vide))nouvelleCategorie = 2;
            }

        if(codeKonami > 18){string+="\nheros\nguerrier spatial\nDodormeur";nombreEntree+=3;}
        else if(nouvelleCategorie == 1){string+="\nheros\nguerrier spatial";nombreEntree+=2;}
        else if(nouvelleCategorie == 2){string+="\nheros";nombreEntree++;}

        if(menuY>nombreEntree-2)menuY = nombreEntree-2;
        string.afficherMenuDeroulant(6,6,70,58,menuY+1,momentScrolling,nombreEntree,1);
        string.~String();
        for(int i = 0;i<7;i++)
            {
            string+=nomCara[i];
            string+=caracteristiques[menuY][i];
            string+="\n";
            }
        string.afficherRetour(75,6);
        fenetre(WINDOW_FULL,0);
        break;

    case MENU_PRINCIPAL:
        fenetre(WINDOW_MENU);
        string+="Encyclopedie\nInventaire\nSort\nHeros\nOptions\nSauver\nQuitter\nretour";
        string.afficherMenuDeroulant(70,6,122,58,menuY,momentScrolling,8);
        fenetre(WINDOW_MENU,0);
        break;

    case MENU_QUITTER : reset_calc();

    case MENU_SAUVER :
        launchSauvegarde();
        endSauvegarde(memoire(SAUVEGARDE,numeroFichier));
        unsigned int key;
        GetKey(&key);//LePhenixNoir va etre content ^^
        menuRetour = 1;
        break;

    case MENU_OPTIONS_LAYOUT:
        if(modificationTouche == -1)
            {
            fenetre(WINDOW_FULL);
            string+="que voulez vous modifier?\nfenetre de jeu\ninformations\naffichage du log";
            string.afficherMenuDeroulant(5,5,120,60,menuY+1,momentScrolling,4,1,1);
            fenetre(WINDOW_FULL,0);
            }
        break;

    case MENU_ACHAT_SORT:



        fenetre(WINDOW_OUI_NON);
        if(!heros.connaitSort(sort[modificationTouche]))string+="acheter";
        else {string+="slot ";string+=nouvelleCategorie;}
        string+="\nretour";
        string.afficherMenuDeroulant(81,19,120,33,menuY,momentScrolling,2,0,1);
        fenetre(WINDOW_OUI_NON,0);
        break;



    case MENU_SCENARIO:
        fenetre(WINDOW_FULL);
        string+=" \n \n \n \n \n \n \n \n \n \n";
        getDialogueScenario(quete,&string);
        int var = string.afficherTexteDefilant(6,4,120,60,(momentScrolling2>>3)+34);
        if(var == 1)momentScrolling2++;
        else if(var == 2)nouvelleCategorie = 1;
        else momentScrolling2 = 0;

        break;



    case MENU_SORT :

        fenetre(WINDOW_FULL);

        int tailleColonne=0;
        int Ycase = 0;
        int Yafficher;
        int positionX[15]={0};
        int positionY[15]={0};

        if(modificationTouche == -1)string+="\002 ";
        getNomArbre(arbreCompetence,&string);
        if(modificationTouche == -1)string+=" \001";
        string.afficherMilieu(4,5,75);
        string.~String();
        for(int i = 0;i<nombreSort;i++)
            {
            int Xafficher = colonne[i]*15+6;
            if(tailleColonne == 0)for(int j = i;colonne[j] == colonne[i];tailleColonne++,j++);

            if(tailleColonne == 1)Yafficher = 23;
            if(tailleColonne == 2)Yafficher = 18+10*Ycase;
            if(tailleColonne == 3)Yafficher = 13+10*Ycase;
            Ycase++;
            if(Ycase == tailleColonne){Ycase =0;tailleColonne = 0;}
            if(heros.connaitSort(sort[i]))ML_rectangle(Xafficher,Yafficher,Xafficher+6,Yafficher+6,1+(modificationTouche == i),ML_BLACK,ML_WHITE);
            else ML_rectangle(Xafficher,Yafficher,Xafficher+6,Yafficher+6,1+(modificationTouche == i),ML_CHECKER,ML_WHITE);
            positionX[i]=Xafficher+3;
            positionY[i]=Yafficher+3;
            }
        int sortBase;
        for(int i = 1;i<=lien[0];i++)
            {
            sortBase = (lien[i]&0xF0)>>4;
            if(heros.connaitSort(sort[sortBase]))ML_line(positionX[lien[i]&0xF]-4,positionY[lien[i]&0xF],positionX[sortBase]+4,positionY[sortBase],ML_BLACK);
            //else ML_line(positionX[lien[i]&0xF]-4,positionY[lien[i]&0xF],positionX[sortBase]+4,positionY[sortBase],ML_CHECKER);
            }
        fenetre(WINDOW_FULL,0);

        fenetre(WINDOW_DESCRIPTION_SORT);
        if(modificationTouche != -1)
            {
            string+=getNomSort(sort[modificationTouche]);
            string+="\ncout :";
            string+=getCoutSort(sort[modificationTouche])&0xF;
            string+="\nniv. :";
            string+=(getCoutSort(sort[modificationTouche])&0xF0)>>4;
            string+="\n ";
            }
        else
            {
           getNomArbre(arbreCompetence,&string);
            string+="\nsorts arbre : ";
            int i = 0;
            for(int j =0;j<nombreSort;j++)if(heros.connaitSort(sort[j]))i++;
            string+=i;
            string+="\nnb sort :";
            i = 0;
            for(int j =0;j<NOMBRE_SORT;j++)if(heros.connaitSort(j))i++;
            string+=i;
            string+="\nnb PC :";
            string+=heros.getPointCompetence();
            }
        string.afficherBoite(81,5,120,40,momentScrolling,10,4);


        fenetre(WINDOW_DESCRIPTION_SORT,0);

        string.~String();
        if(nouvellePrecision == PAS_POINT_COMPETENCE)string+="vous n'avez pas de point de competence disponible !";
        else if(nouvellePrecision == PAS_DISPONIBLE)string+="vous n'avez pas debloque ses sorts parents !";
        else if(modificationTouche !=-1)getDescriptionSort(sort[modificationTouche],&string);
        else getDescriptionArbre(arbreCompetence,&string);
        //string+="inflige [A] en cercle autour de vous texte vraiment trop long pour tester le scroll mais vreimnef vzoei srg";//getDescriptionSort(modificationTouche);

        fenetre(WINDOW_LITLLE_DIALOGUE);
        if(momentScrolling2>0x40000)momentScrolling2 = 0;
        int retour = string.afficherTexteDefilant(6,45,122,60,(momentScrolling2 & MASQUE_TEXTE_SCROLLING)>>1);
        if(retour == 1)momentScrolling2++;
        else if(retour == 2)momentScrolling2+=0x1000;
        else momentScrolling2 = 0;

        fenetre(WINDOW_LITLLE_DIALOGUE,0);
        break;

    case MENU_OPTIONS :
        fenetre(WINDOW_FULL);
        string +="Que voulez vous faire ?\nchanger les touches\nchanger l'interface in-game\nchanger l'icone d'attente\nchanger la police d'ecriture\nchanger les fenetres\nchanger le zoom et la camera\nchanger la vitesse de dialogue";
        string.afficherMenuDeroulant(6,6,120,58,menuY+1,momentScrolling,8,1);
        fenetre(WINDOW_FULL,0);
        break;

    case MENU_OPTIONS_ICONE:
        fenetre(WINDOW_FULL);
        string +="Quelle icone voulez vous?\n1\n2\n3\n4\n5\n6";
        string.afficherMenuDeroulant(6,6,120,58,menuY+1,momentScrolling,6,1);
        fenetre(WINDOW_FULL,0);
        ML_rectangle(120,0,128,8,0,ML_WHITE,ML_WHITE);
        for(int i = 0;i<(frame&0x1F);i++)afficherIcone(i&15);
        setFps(8);
        break;

    case MENU_OPTIONS_FENETRE:
        fenetre(WINDOW_FULL);
        string+="Quelle fenetre voulez vous?\n1\n2\n3\n4\n5";
        string.afficherMenuDeroulant(6,6,120,58,menuY+1,momentScrolling,5,1);
        fenetre(WINDOW_FULL,0);
        break;

    case MENU_OPTIONS_FONT:
        fenetre(WINDOW_FULL);
        string+="Quelle police voulez vous?\n1\n2\n3\n4\n5\nscrolling doux : ";
        if(Options::getDouxScrolling())string+="ON";
        else string+="OFF";
        string.afficherMenuDeroulant(6,6,120,58,menuY+1,momentScrolling,6,1);
        fenetre(WINDOW_FULL,0);
        break;

    case MENU_OPTIONS_VITESSE:
        fenetre(WINDOW_FULL);
        string+="Quelle vitesse de dialogue voulez vous?\nx1\nx2\nx3\nx4\nNombre de FPS voulu (dans la limite des capacites de la machine)\n128\n64\n42\n32\n25\n21";
        string.afficherMenuDeroulant(6,6,120,58,menuY+1,momentScrolling,12,1);
        fenetre(WINDOW_FULL,0);
        break;

    case MENU_OPTIONS_ZOOM:
        fenetre(WINDOW_FULL);
        string+="zoom :\n fixe\n zoom en couloir\n intelligant";
        string+="camera :\n fixe\n vers l'avant\n intelligant";
        /*Szoom.afficherRetour(6,6);
        Scamera.afficherRetour(70,6);
        fleche.afficher(6+64*menuX,6*menuY+12);*/
        fenetre(WINDOW_FULL,0);
        break;

    case MENU_PERSONNAGE:
        fenetre(WINDOW_FULL);
        heros.afficherEcranPersonnage();
        fenetre(WINDOW_FULL,0);

        break;

   /* case MENU_ENCYCLOPEDIE_BASE:
        fenetre(WINDOW_FULL);
        string+="quelle encyclopedie voulez vous voir?\nmonstres\nobjets\nsorts\nlieux";
        string.afficherMenuDeroulant(6,6,124,58,menuY+1,momentScrolling,5,1);
        fenetre(WINDOW_FULL,0);
        break;*/
case MENU_ENCYCLOPEDIE_BASE:
    case MENU_ENCYCLOPEDIE_MONSTRE_BASE:

        fenetre(WINDOW_FULL);
        fenetre(WINDOW_ENCYCLOPEDIE_LISTE);
        afficherDescriptionEtreVivant(menuY,74,5);
        for(int i = 0;i<16;i++){getNomEnnemi(i,&string);string+="\n";}
        string.afficherMenuDeroulant(6,6,70,58,menuY,momentScrolling,16);
        fenetre(WINDOW_ENCYCLOPEDIE_LISTE,0);
        break;

    case MENU_OPTIONS_MAP_TOUCHE:
        fenetre(WINDOW_FULL);
        unsigned char categorie[9][20]={"lancer un sort","attaquer","ouvrir un menu","modifier la camera","avancer","valider","retour/changer dir.","attendre"};
        unsigned char nomMenu[23][20]={"rien","menu principal","encyclopedie","inventaire","sortileges","heros","options","sauvegarder","quitter","ency. monstres","ency. lieux","ency. sorts","equipement","sortie urgence","modifier touches","modifier interface","modifier icone","modifier police","modifier fenetre","modifier zoom"};
        unsigned char nomCamera[8][20]={"deplacement gauche","deplacement droit","deplacement haut","deplacement bas","zoom *2","zoom *4","zoom /2","zoom /4",};
        unsigned char nomDirection[4][7]={"bas","gauche","haut","droite"};
        string+="modifier la fonction d'une touche :\nquelle touche (exe -> la touche) :";
        if(modificationTouche > -1)string+=nomTouche[modificationTouche];
        string+="\nnouveau type :";
        if(modificationTouche > -1)string+=categorie[nouvelleCategorie];
        string+="\nprecisions :";
        if(modificationTouche > -1)
            {
            if(nouvelleCategorie == 0)string+=getNomSort(nouvellePrecision);
            //else if(nouvelleCategorie == 1)getNomObjet(nouvellePrecision,&string);
            else if(nouvelleCategorie == 2)string+=nomMenu[nouvellePrecision];
            else if(nouvelleCategorie == 3)string+=nomCamera[nouvellePrecision];
            else if(nouvelleCategorie == 4)string+=nomDirection[nouvellePrecision];
            else string+="il faut vraiment des precisions? :p";
            }
        string+="\nvalider";
        string.afficherMenuDeroulant(6,6,120,58,menuY+1,momentScrolling,5,1);
        fenetre(WINDOW_FULL,0);


        break;

    case MENU_CHOIX_DESTINATION:
        fenetre(WINDOW_FULL);
        string+="Dans quel lieu voulez vous aller?\n";
        for(int i = 0;i<NOMBRE_LIEUX;i++){getNomLieux(i,&string);string+="\n";}
        string.afficherMenuDeroulant(6,6,120,58,menuY+1,momentScrolling,NOMBRE_LIEUX+1,1);
        fenetre(WINDOW_FULL,0);
        break;



    case MENU_AUBERGE:

        if(dialogueEnCours != -1)nouvelleCategorie++;
        else nouvelleCategorie--;

        if(nouvelleCategorie == 0){menu=MENU_DIALOGUE;dialogueEnCours = 0xFF;}

        if(ML_CONTRAST_NORMAL-nouvelleCategorie <ML_CONTRAST_MIN)
            {
            heros.nuitAuberge(dialogueEnCours);
            dialogueEnCours = -1;
            }

        ML_set_contrast(ML_CONTRAST_NORMAL-nouvelleCategorie);

        break;

    case MENU_ACHAT_AUBERGE:

        fenetre(WINDOW_DIALOGUE);
        fenetre(WINDOW_OUI_NON);
        string+="payer ";
        string+=dialogueEnCours;
        string+=" PO pour dormir ?";
        string.afficherDialogue(dialogueScrolling);
        string.~String();
        string+="Oui\nNon";
        string.afficherMenuDeroulant(81,19,124,33,menuY,momentScrolling,2,0,1);


        fenetre(WINDOW_DIALOGUE,0);
        fenetre(WINDOW_OUI_NON,0);
    break;


    case MENU_ACHAT_FORGERON:

        fenetre(WINDOW_ENCYCLOPEDIE_LISTE);
        fenetre(WINDOW_INVENTAIRE_ICONE);
        fenetre(WINDOW_INVENTAIRE_AUTRE);
        for(int i = 1;i<NOMBRE_OBJET;i++){getNomObjet(i,&string);string+="\n";}

        
        string.afficherMenuDeroulant(5,5,58,60,dialogueEnCours,momentScrolling,NOMBRE_OBJET-1,0,1);
        string.~String();



        if(menuX == 0)
            {
            getPrecisionObjet(dialogueEnCours+1,precisionObjet);
            getDescriptionObjet(dialogueEnCours+1,precisionObjet,string);
            if(momentScrolling2>0x40000)momentScrolling2 = 0;
            retour = string.afficherTexteDefilant(69,32,124,60,(momentScrolling2&0xFFF)>>1);
            if(retour == 1)momentScrolling2++;
            else if(retour == 2)momentScrolling2+=0x1000;
            else momentScrolling2 = 0;
            }
        else
            {
            string+="acheter\nretour";
            string.afficherMenuDeroulant(69,32,124,60,menuY,momentScrolling,2);
            }

        string.~String();
        string+=getCoutObjet(dialogueEnCours+1);
        string+=" PO";

        afficherSpriteObjet(dialogueEnCours+1,77,5,16);
        string.afficher(94,5);
        fenetre(WINDOW_ENCYCLOPEDIE_LISTE,0);
        fenetre(WINDOW_INVENTAIRE_ICONE,0);
        fenetre(WINDOW_INVENTAIRE_AUTRE,0);

        break;

    case MENU_DIALOGUE:



        fenetre(WINDOW_DIALOGUE);
        getDialogue(dialogueEnCours,&string);

        int result = string.afficherDialogue(dialogueScrolling);

        if(result == 1)dialogueScrolling+=Options::getVitesse()+1;
        if(result == 0 && menuOk)dialogueScrolling+=Options::getVitesse()+1;
        if(result == 2 && menuOk)
            {
            menu>>=8;
            if(dialogueEnCours == 2){menu = MENU_AUBERGE;dialogueEnCours =0; }
            if(dialogueEnCours == 4){menu = MENU_ACHAT_AUBERGE;dialogueEnCours = 4;}
            if(dialogueEnCours == 5 || dialogueEnCours == 6){menu= MENU_ACHAT_FORGERON;}
            }
        break;

    case MENU_FIN_DONJON:
        string+="Vous avez termine le donjon !\n ";
        string+="\nXP gagnee :";
        string+=gainFinDonjon;
        string+="\nXP de comp. :";

        string+=heros.getXPCompetence();
        string+="/";
        string+=heros.getXPCompetenceNextLevel(heros.getLevelCompetence());
        fenetre(WINDOW_FULL);
        string.afficherRetour(5,5);
        ML_rectangle(10,50,10+heros.getPourcentageXPCompetence(),54,0,ML_BLACK,ML_BLACK);

        break;

    case MENU_GAME_OVER:
        fenetre(WINDOW_FULL);
        string+="Vous etes mort.\nLe monde a oublie votre nom.";
        string.afficherWordWrap(5,5,124);
        break;

    case 0:break;
    default :fenetre(WINDOW_FULL);string+="menu inexistant ! numero ";string+=lequel;string.afficherWordWrap(6,6,124);
    }
}




void Donjon::input()
{

unsigned char touches[50] = {
K_F1,K_F2,K_F3,K_F4,K_F5,K_F6,
K_SHIFT,K_OPTN,K_VARS,K_MENU,
K_LEFT,K_UP,K_RIGHT,K_DOWN,
K_ALPHA,K_SQUARE,K_POW,K_EXIT,
K_XT,K_LOG,K_LN,K_SIN,
K_COS,K_TAN,K_FRAC,K_FD,
K_LPAR,K_RPAR,K_COMMA,K_STORE,
K_7,K_8,K_9,K_DEL,
K_AC,K_4,K_5,K_6,//AC a un probleme on dirait...
K_MULT,K_DIV,K_1,K_2,
K_3,K_PLUS,K_MINUS,K_0,
K_DP,K_EXP,K_PMINUS,K_EXE};


char delta[4][2]={{0,1},{-1,0},{0,-1},{1,0}};
unsigned char caseX = heros.getX()/TAILLE_MAX;
unsigned char caseY = heros.getY()/TAILLE_MAX;
int nextY;
int nextX;

int flag = 1;
for(int i = 0;i<50;i++)if(key_down(touches[i]))flag = 0;
if(flag)
    {
    if(checkTouche)modificationDirection = 0;
    checkTouche = 0;
    }
for(int i = 0;i<50;i++)
    {
    if(key_down(touches[i]))
        {
        if((configurationTouche[i] & RACCOURCI_SORT))
            {
            if(!checkTouche && !menu)
                {
                if(heros.lancerSort(configurationTouche[i] & RACCOURCI_ARG_SORT,etreVivant,nombreEtreVivant))tourActuel = TOUR_ENNEMI;
                checkTouche = 1;
                return;
                }
            }

        else if(configurationTouche[i]&RACCOURCI_OBJET  && !menu)
            {
            nextX =caseX+delta[heros.getDirection()][0];
            nextY=caseY+delta[heros.getDirection()][1];
            int flag = 1;
            for(int j = 0;j<nombreEnnemi;j++)
                {
                if((ennemi[j].getX()/TAILLE_MAX)==nextX && (ennemi[j].getY()/TAILLE_MAX)==nextY)
                    {
                    heros.attaquer(&ennemi[j],-1);
                    checkTouche = 1;
                    
                    flag = 0;
                    }
                }
            if(flag)heros.attaquer(0,-1);
            tourActuel = TOUR_ENNEMI;

                //todo : utiliser objet
            return;
            }
        else if(configurationTouche[i]&RACCOURCI_MENU)
            {
            menuOk=0;
            menuRetour=0;
            if(!menu)menu = configurationTouche[i]&RACCOURCI_ARG_MENU;
            return;
            }
        else if(configurationTouche[i]&RACCOURCI_CAMERA  && !menu)
            {
            if((configurationTouche[i]&RACCOURCI_ZOOM)&&!checkTouche)
                {
                if(configurationTouche[i]&RACCOURCI_ZOOM_PLUS){zoomDefault <<=1+configurationTouche[i]&(RACCOURCI_ZOOM_FACTOR);zoomDefault=max(1,zoomDefault);}
                else zoomDefault >>=1+(configurationTouche[i]&RACCOURCI_ZOOM_FACTOR);
                zoomDefault = max(min(zoomDefault,32),0);
                checkTouche = 1;
                }
            else
                {
                int dep = configurationTouche[i]&RACCOURCI_ARG_AVANCER;
                cameraX+=delta[dep][0];
                cameraY+=delta[dep][1];
                }
            }
        else if(configurationTouche[i]&RACCOURCI_AVANCER )
            {
            if((menu&MENU_ACTIF_MASQUE)==MENU_SORT)nouvellePrecision = 0;
            int dep = configurationTouche[i]&RACCOURCI_ARG_AVANCER;
            if(dep <0 || dep>4)Sleep(5000);
            if(menu)
                {
                if(!checkTouche)
                    {
                    momentScrolling = 0;
                    if((menu&MENU_ACTIF_MASQUE)!=MENU_SCENARIO)momentScrolling2 = 0;
                    if(menuX || delta[dep][0]!=-1)menuX+=delta[dep][0];
                    if(menuY || delta[dep][1]!=-1)menuY+=delta[dep][1];
                    checkTouche = 1;
                    }
                }
            else if(modificationDirection)
                {
                heros.changeDirection(dep);
                checkTouche=1;
                }
            else
                {
                nextX =caseX+delta[dep][0];
                nextY=caseY+delta[dep][1];
                int col = collisionHeros(nextX,nextY);
                if(col == -1)heros.changeDirection(dep);
                if(col == 0){deplacement(&heros,dep);tourActuel = TOUR_ENNEMI;return;}
                else if(col == 1 && !checkTouche)
                    {
                    int flag = 1;
                    for(int j = 0;j<nombreEnnemi;j++)
                        {
                        if((ennemi[j].getX()/TAILLE_MAX)==nextX && (ennemi[j].getY()/TAILLE_MAX)==nextY)
                            {
                            heros.attaquer(&ennemi[j],dep);
                            String temp("ennemi n");
                            temp+=j;
                            //log(temp.getStr(),LOG_DEBUG);
                            checkTouche = 1;
                            tourActuel = TOUR_ENNEMI;
                            flag = 0;
                            }
                        }
                    if(flag)heros.changeDirection(dep);
                    return;
                    }
                }

            }
        else if(configurationTouche[i] == RACCOURCI_ATTENDRE  && !menu)
            {
            tourActuel = TOUR_ENNEMI;
            return;
            }
        else if(configurationTouche[i] == RACCOURCI_RETOUR && !checkTouche)
            {
            if(menu){menuRetour = 1;checkTouche = 1;}
            else modificationDirection = 1;

            return;
            }
        else if(configurationTouche[i] == RACCOURCI_VALIDER  && !checkTouche)
            {
            if(menu)menuOk = 1;
            else parler();

            checkTouche = 1;
            return;
            }

        }
    }
}



void Donjon::parler()
{
char delta[4][2]={{0,1},{-1,0},{0,-1},{1,0}};

int viseeX = heros.getX()/TAILLE_MAX + delta[heros.getDirection()][0];
int viseeY = heros.getY()/TAILLE_MAX + delta[heros.getDirection()][1];
for(int i = 0;i<nombreAllie;i++)
    {
    if(allie[i].getX()/TAILLE_MAX == viseeX && allie[i].getY()/TAILLE_MAX == viseeY)
        {
        menu<<=8;
        menu|=MENU_DIALOGUE;
        dialogueEnCours = allie[i].getNumDialogue();
        dialogueScrolling = 0;
        menuOk = 0;
        allie[i].changeDirection(heros.retournement());
        return;
        }
    }
}


void Donjon::reglerZoom()
{
tailleSprite=zoomDefault;
int option = Options::getZoom();
if(option == 1)
	{
	if((quelleCase(heros.getX()/TAILLE_MAX,heros.getY()/TAILLE_MAX)&MASQUE_ID)==SALLE)tailleSprite>>=1;
	}

tailleSprite = max(min(tailleSprite,16),1);
}


void Donjon::afficherEtreVivant(EtreVivant* etreVivant)
{
etreVivant->afficher(fenetreX,fenetreY,cameraX,cameraY,tailleSprite);
}


void Donjon::afficherSortEtreVivant(EtreVivant* etreVivant)
{
etreVivant->afficherSort(fenetreX,fenetreY,cameraX,cameraY,tailleSprite);
}


void Donjon::afficherInfoEtreVivant(EtreVivant* etreVivant)
{
etreVivant->afficherInfo(fenetreX,fenetreY,cameraX,cameraY,tailleSprite);
}



/********************

le reste des fonctions (on doit manger tous ses restes)

********************/


void Donjon::demarrerDonjon(int lequel)
{
int nombreEtageT[NOMBRE_LIEUX]={3,6,10,12,15,255};
tailleX = 42;
tailleY = 42;
etage=0;
nombreEtage = nombreEtageT[lequel];
ville = 0;
numeroDonjon = lequel;
genererEtage();

}


int Donjon::getNiveauHeros()
{
return heros.getLevelCompetence();
}

Donjon::Donjon()
{

init();
}

int Donjon::getPourcentQuete()
{
return quete*quete*2+quete*10;
}


void Donjon::init()
{
tempsJoue=0;
framePasse=0;
codeKonami = 0;
resetDemande = 0;
quete = 0;
unsigned char HUDT[20]={2,0,0,2,0,6,2,0,12,2,0,18,0,32,32,32,36,46,3,1};
for(int i = 0;i<20;i++)HUD[i]=HUDT[i];
momentScrolling2 = 0;
modificationDirection= 0;
tailleFenetreY=64;
tailleFenetreX=92;
fenetreX = 36;
fenetreY = 0;
heros.init();
checkTouche = 0;
zoomDefault = 16;
ville = 1;
genererEtage();
tourActuel = HEROS;
menu =MENU_CHOIX_RACE;
menuOk=0;
menuRetour=0;
momentScrolling=0;
arbreCompetence = 0;
menuX = 0;
modificationTouche = -1;
nouvelleCategorie = 0;
nouvellePrecision=0;
unsigned char raccourci[50]=
{
0x0E,0x0C,0,0,0,0,
1,0,0,0x21,
0x05,0x06,0x7,0x04,
0x02,0,0,0x28,
0,0,0,0,
0,0,0,0,
0,0,0,0,
0x87,0,0,0,
0x21,0x84,0x85,0x86,
0,0,0x81,0x82,
0x83,0,0,0x80,
0,0,0,0x03,
};


for(int i = 0;i<50;i++)configurationTouche[i]=raccourci[i];
}

void Donjon::deplacement(EtreVivant* etreVivant,char direction)
{
char delta[4][2]={{0,1},{-1,0},{0,-1},{1,0}};
int caseX = etreVivant->getX()/TAILLE_MAX;
int caseY = etreVivant->getY()/TAILLE_MAX;
int nextCaseX = caseX+delta[direction][0];
int nextCaseY = caseY+delta[direction][1];

int caseActuelle =etreVivant->getX()/TAILLE_MAX+(etreVivant->getY()/TAILLE_MAX)*tailleX;

if((map[caseActuelle]&MASQUE_ID)==PORTE_OUVERTE)map[caseActuelle]=PORTE_FERMEE;//si on quitte la case, on ferme la porte
if((quelleCase(nextCaseX,nextCaseY)&MASQUE_ID)==PORTE_FERMEE)map[nextCaseX+nextCaseY*tailleX]=PORTE_OUVERTE;
if(((quelleCase(nextCaseX,nextCaseY)&MASQUE_ID) != MUR) && !(quelleCase(nextCaseX,nextCaseY)&MASQUE_ETRE_VIVANT) || key_down(K_LN))
    {
    etreVivant->deplacement(direction);
    map[caseX+caseY*tailleX] &=MASQUE_N_ETRE_VIVANT;
    map[nextCaseX+nextCaseY*tailleX] |=MASQUE_ETRE_VIVANT;

    }
else etreVivant->changeDirection(direction);
}


void Donjon::genererEtage()
{
if(!ville)
    {
    if(etage == nombreEtage)
        {
        menu<<=8;
        menu+=MENU_FIN_DONJON;
        gainFinDonjon=heros.getLevel()*etage*3;
        heros.finDonjon();
        if(numeroDonjon == quete)
            {
            menu<<=8;
            menu+=MENU_SCENARIO;
            quete++;
            if(quete == 6)writeFile("shadow","end",(unsigned char*)&menu,1);
            }
        }
    else
        {
        launchChargement(etage);
        etage++;
        genererLabyrinthe(map,tailleX,tailleY,5,8);
        nombreEnnemi = 10;
        for(int i = 0;i<nombreEnnemi;i++)ennemi[i].init(map,tailleX,tailleY,etage);

        nombreObjet = 6;
        for(int i = 0;i<nombreObjet;i++)objet[i].init(map,tailleX,tailleY,etage);
        nombreAllie = 0;
        endChargement();
        }
    }
else
    {
    nombreEnnemi = 0;
    nombreObjet = 0;
    tailleX = 19;
    tailleY = 11;
    unsigned char mapT[50*50]=
        {
        0,5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
        0,3,3,0,3,3,3,3,0,3,3,3,0,3,3,3,3,3,0,
        0,3,3,2,3,3,3,3,0,3,3,3,0,3,3,3,3,3,0,
        0,3,3,0,0,0,2,0,0,3,3,3,0,3,3,3,3,3,0,
        0,3,3,3,3,3,3,3,3,3,3,3,2,3,3,3,3,3,0,
        0,3,3,3,3,3,3,3,3,3,3,3,0,3,3,3,3,3,0,
        0,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,
        0,0,0,0,0,3,3,3,3,3,3,3,0,3,3,3,3,3,0,
        0,3,3,3,0,3,3,3,3,3,3,3,0,3,3,3,3,3,0,
        0,3,3,3,2,3,3,3,3,3,3,3,2,3,3,3,3,3,0,
        0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        };
    for(int i = 0;i<tailleX*tailleY;i++)map[i]=mapT[i];
    int apparition[10][10]=
    {
    {0},
    {1},
    {0,1}
    };
nombreAllie = 0;
    for(int i = 0;i<3;i++)
        {
        if(!apparition[i][quete])
            {
            nombreAllie++;
            allie[i].init(i,quete);
            }
        }
    }
heros.nouvelEtage(map,tailleX,tailleY,ville);
int compteur = 1;
for(int i = 0;i<nombreEnnemi;i++,compteur++)etreVivant[compteur]=&ennemi[i];
for(int i = 0;i<nombreAllie;i++,compteur++)etreVivant[compteur]=&allie[i];
nombreEtreVivant=1+nombreAllie+nombreEnnemi;


etreVivant[0]=&heros;
}


unsigned char Donjon::quelleCase(int X,int Y)
{
if(key_down(K_LN))return SALLE;
if(X<0 || Y<0 || X>=tailleX || Y>=tailleY)return SALLE;
return map[X+Y*tailleX];
}


int Donjon::collisionHeros(int X,int Y)
{
if(key_down(K_LN))return 0;
if((quelleCase(X,Y)&MASQUE_ID) == MUR)return -1;
if(quelleCase(X,Y)&MASQUE_ETRE_VIVANT)return 1;
return 0;
}


int Donjon::memoire(int action,unsigned char numeroFichierT)
{
unsigned char tailleHud = 20;
unsigned char taille50 = 50*4;
numeroFichier = numeroFichierT;
String fichier("SHADOW");
fichier+=numeroFichier;
Sauvegarde sauvegarde(action,5000,fichier.getStrU(),(unsigned char*)"SAV");

sauvegarde.addInt(tempsJoue);

heros.memoire(sauvegarde);

sauvegarde.addUChar(nombreEnnemi);
for(int i = 0;i<nombreEnnemi;i++)ennemi[i].memoire(sauvegarde);
sauvegarde.addUChar(nombreAllie);

int compteur = 1;
for(int i = 0;i<nombreEnnemi;i++,compteur++)etreVivant[compteur]=&ennemi[i];
for(int i = 0;i<nombreAllie;i++,compteur++)etreVivant[compteur]=&allie[i];
nombreEtreVivant=1+nombreAllie+nombreEnnemi;


sauvegarde.addUChar(nombreObjet);
for(int i = 0;i<nombreObjet;i++)objet[i].memoire(sauvegarde);

sauvegarde.addUChar(tailleX);
sauvegarde.addUChar(tailleY);
unsigned char tailleMap = 200;//tailleX*tailleY;
for(int i = 0;i*200<tailleX*tailleY;i++)sauvegarde.addTab(&map[i*200],tailleMap);
sauvegarde.addUChar(etage);
sauvegarde.addInt(fenetreX);
sauvegarde.addInt(fenetreY);
sauvegarde.addUChar(tailleFenetreX);
sauvegarde.addUChar(tailleFenetreY);
sauvegarde.addInt(ville);
sauvegarde.addUChar(vision);
sauvegarde.addInt(tourActuel);
sauvegarde.addUChar(nombreEtage);
sauvegarde.addInt(quete);
sauvegarde.addTab(HUD,tailleHud);
sauvegarde.addTab((unsigned char*)configurationTouche,taille50);
int retour = sauvegarde.end();
tourActuel = TOUR_HEROS;
if(menu == MENU_CHOIX_RACE)menu = 0;
/*
ennemi[0].debug();
etreVivant[1]->debug();
*/

if(tempsJoue == 0)init();
return retour;
}


int Donjon::getSecondeJouee()
{
return tempsJoue;
}


void Donjon::startGame()
{
if(ville)genererEtage();
}
