#ifndef DONJON_H
#define DONJON_H

#include "PNJ.h"
#include "ennemi.h"
#include "etreVivant.h"
#include "heros.h"
#include "objet.h"
#include "element.h"
#include "allie.h"


//et c'est partit pour la (tres) longue liste des define :p
#define DONJON_TAILLE_MAX 64
#define DONJON_ETAGE_MAX 64
#define DONJON_ENNEMI_MAX 15
#define DONJON_ALLIE_MAX 10
#define DONJON_OBJET_MAX 10

#define MASQUE_ID 0x1F
#define MASQUE_VISION 0xC0
#define MASQUE_ETRE_VIVANT 0x20

//N pour not ou non
#define MASQUE_N_ID 0xE0
#define MASQUE_N_VISION 0x3F
#define MASQUE_N_ETRE_VIVANT 0xDF

#define VISIBLE 0x80
#define BROUILLARD 0xC0
#define INVISIBLE 0x40

#define TAILLE_MAX 16

#define RACCOURCI_SORT 0x80    //1xxxxxxx => 0->127
#define RACCOURCI_OBJET 0x40   //01xxxxxx => 0->63
#define RACCOURCI_MENU 0x20    //001xxxxx => 0->31
#define RACCOURCI_CAMERA 0x08  //00001yxx => x=0->3 y=0/1
#define RACCOURCI_AVANCER 0x04 //000001xx => 0->3
#define RACCOURCI_VALIDER 0x03 //00000011
#define RACCOURCI_RETOUR 0x02  //00000010
#define RACCOURCI_ATTENDRE 0x01//00000001
#define RACCOURCI_RIEN 0x00    //00000000

#define RACCOURCI_ZOOM 0x04
#define RACCOURCI_ZOOM_PLUS 0x02
#define RACCOURCI_ZOOM_FACTOR 0x01

#define RACCOURCI_ARG_SORT 0x7F
#define RACCOURCI_ARG_OBJET 0x3F
#define RACCOURCI_ARG_MENU 0x1F
#define RACCOURCI_ARG_CAMERA 0x07
#define RACCOURCI_ARG_AVANCER 0x03

#define MENU_PRINCIPAL 0x01
#define MENU_ENCYCLOPEDIE_BASE 0x02
#define MENU_INVENTAIRE_ITEM 0x03
#define MENU_SORT 0x04
#define MENU_PERSONNAGE 0x05
#define MENU_OPTIONS 0x06
#define MENU_SAUVER 0x07
#define MENU_QUITTER 0x08
#define MENU_ENCYCLOPEDIE_MONSTRE_BASE 0x09
#define MENU_ENCYCLOPEDIE_LIEU 0x0A
#define MENU_ENCYCLOPEDIE_SORT 0x0B
#define MENU_ENCYCLOPEDIE_OBJET 0x0C

#define MENU_INVENTAIRE_EQUIPEMENT 0x0D
#define MENU_SORTIE_SECOURS 0x0E

#define MENU_OPTIONS_MAP_TOUCHE 0x11
#define MENU_OPTIONS_LAYOUT 0x12
#define MENU_OPTIONS_ICONE 0x13
#define MENU_OPTIONS_FONT 0x14
#define MENU_OPTIONS_FENETRE 0x15
#define MENU_OPTIONS_ZOOM 0x16
#define MENU_OPTIONS_VITESSE 0x17

#define MENU_ACHAT_FORGERON 0xF5
#define MENU_AUBERGE 0xF6
#define MENU_ACHAT_AUBERGE 0xF7
#define MENU_CHOIX_RACE 0xF8
#define MENU_SCENARIO 0xF9
#define MENU_GAME_OVER 0xFA
#define MENU_ACHAT_SORT 0xFB
#define MENU_ENCYCLOPEDIE_MONSTRE_DETAIL 0xFC
#define MENU_FIN_DONJON 0xFD
#define MENU_DIALOGUE 0xFE
#define MENU_CHOIX_DESTINATION 0xFF

#define MENU_ACTIF_MASQUE 0x00FF

#define MASQUE_TEXTE_SCROLLING 0x00FFF
#define MASQUE_FIN_TEXTE_SCROLLING 0xFF000

#define NOMBRE_ARBRE 4
#define NOMBRE_SORT 50
#define NOMBRE_OBJET 28
#define NOMBRE_LIEUX 6

#define PAS_POINT_COMPETENCE 1
#define PAS_DISPONIBLE 2


#define POTION 0
#define EPEE 1
#define ARGENT 2

#define SOIN_PV 0
#define SOIN_PM 1
#define D_DEGAT 2
#define D_BOUCLIER 3
#define D_MAGIQUE 4
#define D_EXECUTION 5

class Donjon
{

    public :

        Donjon();
        void init();
        void afficherMap();
        void afficherEtreVivant(EtreVivant* etreVivant);
        void afficherSortEtreVivant(EtreVivant* etreVivant);
        void afficherInfoEtreVivant(EtreVivant* etreVivant);
        void refreshBrouillard();
        unsigned char quelleCase(int X,int Y);
        void input();
        void deplacement(EtreVivant* etreVivant,char direction);
        int startFrame();
        int collisionHeros(int X,int Y);
        void reglerZoom();
        void genererEtage();
        void tour();
        void gererMenu();
        void actionMenu(unsigned char lequel);
        void afficherMenu(unsigned char lequel);
        void afficherMiniCarte(int X,int Y,int tailleXT,int tailleYT);
        void demarrerDonjon(int lequel);
        void parler();
        int memoire(int action,unsigned char fichier);
        void endFrame(int FPS);
        int getSecondeJouee();
        int getPourcentQuete();
        int getNiveauHeros();
        void startGame();

    private :

        unsigned char vision;
        unsigned int frame;

        int fenetreX;
        int fenetreY;

        unsigned char tailleFenetreX;
        unsigned char tailleFenetreY;
        bool checkTouche;
        int zoomDefault;
        int cameraX;
        int cameraY;
        int tourActuel;
        unsigned char nombreEtage;
        unsigned int seed[DONJON_ETAGE_MAX];

        unsigned char map[DONJON_TAILLE_MAX*DONJON_TAILLE_MAX];
        unsigned char tailleX;
        unsigned char tailleY;

        unsigned char tailleSprite;

        unsigned char nombreEnnemi;
        Ennemi ennemi[DONJON_ENNEMI_MAX];

        unsigned char nombreAllie;
        Allie allie[DONJON_ALLIE_MAX];

        unsigned char nombreObjet;
        Objet objet[DONJON_OBJET_MAX];

        unsigned char nombreEtreVivant;
        EtreVivant* etreVivant[DONJON_ALLIE_MAX+DONJON_ENNEMI_MAX+1];

        Heros heros;
        unsigned int menu;//le unsigned permet de retenir 4 niveaux de menu
        bool menuRetour;
        bool menuOk;
        unsigned char menuX;
        unsigned char menuY;

        unsigned char etage;
        int momentScrolling;
        int dialogueScrolling;

        int modificationTouche;
        int nouvelleCategorie;
        int nouvellePrecision;
        int configurationTouche[50];
        int momentScrolling2;
        unsigned char arbreCompetence;
        int erreur;

        int ville;
        int modificationDirection;
        int dialogueEnCours;
        int gainFinDonjon;
        int quete;
        unsigned char HUD[20];
        bool resetDemande;
        int tempsJoue;
        int framePasse;
        unsigned char numeroFichier;
        unsigned char numeroDonjon;
        unsigned char codeKonami;
};

#endif
