extern "C"
{
#include "fxlib.h"
#include "LibText.h"
#include "usefull.h"
#include "math.h"

}

#include "etreVivant.h"
#include "generateur.h"
#include "MonochromeLib.h"
#include "donjon.h"
#include "PNJ.h"
#include "etreVivant.h"
#include "heros.h"
#include "graphisme.h"
#include "string.h"

/************************************

Classe mere des PNJ et du heros.
Elle organise tout ce qui est sort et degat, vu que c'est commun a tous les etre vivants

************************************/


/*********************************

fonctions generales

**********************************/

int EtreVivant::subirDegat(int puissance,int type,int attaqueEnnemi)
{
if(!getVivant())return 0;
int resistance;
if(type == PHYSIQUE)resistance = attaqueEnnemi-caracteristiques[VIGUEUR];
else resistance = attaqueEnnemi-caracteristiques[MENTAL];
int pourcentage = abs(resistance);
if(resistance>=0)puissance=(resistance+10)*puissance/10;
else puissance = puissance*10/(abs(resistance)+10);


puissance*=multiplicateurDegat;
puissance/=100;

if(degatPrisDepuis == 1)degatPris += puissance;
else degatPris = puissance;
degatPrisDepuis = 1;
if(bouclier>0)
    {
    bouclier-=puissance;
    if(bouclier<0){pv+=bouclier;bouclier = 0;}
    }
else pv-=puissance;
if(pv<1)mort();
return puissance;
}


void EtreVivant::attaquer(EtreVivant* ennemi,char directionT)
{
sortEnCours = 1;
typeSortEnCours = ATK_NORMALE;
animationSortEnCours = 1;
if(directionT != -1)direction = directionT;
if(ennemi != 0)
    {
    effetArme(ennemi);
    if(!ennemi->getVivant())victoireEnnemi(ennemi);
    }
}

void EtreVivant::effetArme(EtreVivant* ennemi)
{
//fonction virtuelle pour les attaques
}


void EtreVivant::victoireEnnemi(EtreVivant* ennemi)
{
//fonction virtuelle pour le heros (ou un PNJ)
}


void EtreVivant::deplacement(unsigned char directionT)
{
direction = directionT;
positionX+=VITESSE_MARCHE*delta[direction][0];
positionY+=VITESSE_MARCHE*delta[direction][1];

}


bool EtreVivant::tourEnCours()
{
if((positionX&15) || (positionY&15))return 1;
if(sortEnCours)return 1;
return 0;
}


void EtreVivant::frame()
{
if(degatPrisDepuis){degatPrisDepuis++;if(degatPrisDepuis == 0)degatPrisDepuis++;}
if(degatPrisDepuis>9)degatPrisDepuis=0;
if(sortEnCours == 0)
    {
    if((positionX&15) || (positionY&15))
        {
        positionX+=VITESSE_MARCHE*delta[direction][0];
        positionY+=VITESSE_MARCHE*delta[direction][1];
        }
    }
else
    {
    sortEnCours++;
    if(animationSortEnCours == 1)//animation d'attaque
        {
        if(sortEnCours <4)
            {
            positionX+=VITESSE_FRAPPE*delta[direction][0];
            positionY+=VITESSE_FRAPPE*delta[direction][1];
            }
        else
            {
            positionX-=VITESSE_FRAPPE*delta[direction][0];
            positionY-=VITESSE_FRAPPE*delta[direction][1];
            }

        if(sortEnCours == 5)sortEnCours = 0;
        }
    if(animationSortEnCours == 2 || animationSortEnCours == 3)
        {
        if(sortEnCours == 8)sortEnCours = 0;
        }
    else if(animationSortEnCours >3)
        {
        if(sortEnCours == 8)sortEnCours = 0;
        }
    }
}


int EtreVivant::retournement()
{
return (direction+2)&3;
}



int EtreVivant::getDirection()
{
return direction;
}


void EtreVivant::changeDirection(int Tdirection)
{
direction = Tdirection;
}
void EtreVivant::afficher(int fenetreX,int fenetreY,int cameraX,int cameraY,unsigned char tailleSprite)
{
if(getVivant() == 0)return;
if(sortEnCours)return;
int spriteX = (positionX-cameraX)/(TAILLE_MAX/tailleSprite)+fenetreX;
int spriteY =(positionY-cameraY)/(TAILLE_MAX/tailleSprite)+fenetreY;

afficherSpriteEtreVivant(IDsprite,direction,positionX,positionY,spriteX,spriteY,tailleSprite);
}


void EtreVivant::afficherInfo(int fenetreX,int fenetreY,int cameraX,int cameraY,unsigned char tailleSprite)
{
int spriteX = (positionX-cameraX)/(TAILLE_MAX/tailleSprite)+fenetreX;
int spriteY =(positionY-cameraY)/(TAILLE_MAX/tailleSprite)+fenetreY;
if(degatPrisDepuis>0)
    {
    String degat(degatPris);
    degat.afficher(spriteX+tailleSprite/2-1,spriteY-degatPrisDepuis/(TAILLE_MAX/tailleSprite)-4,1);
    }
}



void EtreVivant::passeTour()
{
doitPasserTour = 1;
}

void EtreVivant::faiblesse()
{
multiplicateurDegat = 150;
}

void EtreVivant::resistance()
{
multiplicateurDegat = 50; 
}

/**********************************

fonctions de set, jeu et match !

**********************************/


void EtreVivant::memoire(Sauvegarde& sauvegarde)
{
Element::memoire(sauvegarde);
unsigned char temp = 8*4;
sauvegarde.addUChar(vivant);
sauvegarde.addInt(level);
sauvegarde.addInt(experience);
sauvegarde.addInt(camp);
sauvegarde.addInt(direction);
sauvegarde.addUChar(IDsprite);
sauvegarde.addInt(sortEnCours);

sauvegarde.addTab((unsigned char*)caracteristiques,temp);

sauvegarde.addInt(degatPhysiqueMin);
sauvegarde.addInt(degatPhysiqueMax);
sauvegarde.addInt(pv);
sauvegarde.addInt(bouclier);
sauvegarde.addInt(pm);

}

void EtreVivant::mort()
{

vivant = 0;
}


EtreVivant::EtreVivant()
{
init();
}


void EtreVivant::init()
{
multiplicateurDegat = 100;
doitPasserTour =0 ;
bouclier = 0;
Element::init();
sortEnCours=0;
animationSortEnCours=0;
typeSortEnCours=0;
vivant = 1;
level = 1;
}


void EtreVivant::debug()
{
ML_clear_vram();
String temp(positionX);
temp+=" ";
temp+=positionY;
temp+=" ";
temp+=pv;
temp.afficher(0,0,1);
ML_display_vram();
Sleep(5);

}

/**********************************

fonctions de get, aussi courte que ta *SBAF* TA GUEULE !

**********************************/


int EtreVivant::getVivant()
{
return vivant;
}


int EtreVivant::getLevel()
{
return level;
}
