#ifndef ETREVIVANT_H
#define ETREVIVANT_H

#include "element.h"
#define HEROS 1
#define NEUTRE 0
#define ENNEMI -1

#define BAS 0
#define GAUCHE 1
#define HAUT 2
#define DROITE 3

#define VITESSE_MARCHE 2
#define VITESSE_FRAPPE 3

#define PHYSIQUE 1
#define MAGIQUE 2

#define ID_SORT_BASE 2
#define ATK_NORMALE 1

#define MASQUE_SORT_TYPE 0xE000
#define MASQUE_SORT_CAC_ZONE 0x1C00
#define MASQUE_SORT_CAC_ACTIVATION_CONTRECOUPS 0x0300
#define MASQUE_SORT_CAC_CONTRECOUPS 0x00C0
#define MASQUE_SORT_CAC_DEGAT 0x0030
#define MASQUE_SORT_CAC_EFFET_ENNEMI 0x000C
#define MASQUE_SORT_CAC_EFFET_LANCEUR 0x0003

#define MASQUE_SORT_COUT_NIVEAU 0xF0
#define MASQUE_SORT_COUT_MANA 0x0F


#define PV 0
#define PM 1
#define FORCE 2
#define VIGUEUR 3
#define INTELLIGENCE 4
#define MENTAL 5
#define CHANCE 6
#include "sauvegarde.h"
class EtreVivant: public Element
{

public :

    EtreVivant();
    int subirDegat(int puissance,int type,int attaqueEnnemi);
    void lancerSort(unsigned char lequel,EtreVivant** etrevivant,int nombreEtreVivant);
    void afficher(int fenetreX,int fenetreY,int cameraX,int cameraY,unsigned char tailleSprite);

	void init();
    void deplacement(unsigned char directionT);
    bool tourEnCours();
    void frame();
    void attaquer(EtreVivant* ennemi,char directionT);
	void mort();
	int getVivant();
    void afficherInfo(int fenetreX,int fenetreY,int cameraX,int cameraY,unsigned char tailleSprite);
    void afficherSort(int fenetreX,int fenetreY,int cameraX,int cameraY,unsigned char tailleSprite);
    virtual void victoireEnnemi(EtreVivant* ennemi);
    int getLevel();
    void ennemiToucheParSort(unsigned char zone,int& nombreVerification,int* XaVerifier,int* YaVerifier,int caseX = -1,int caseY = -1);
    void changeDirection(int direction);
    int getDirection();
    int retournement();
    void memoire(Sauvegarde& sauvegarde);
    void debug();
    void passeTour();
    void faiblesse();
    void resistance();
    virtual void effetArme(EtreVivant* ennemi);

protected :

    unsigned char vivant;
    int level;
    int experience;
    int camp;
    int direction;
    unsigned char IDsprite;
    int sortEnCours;
    int typeSortEnCours;
    int animationSortEnCours;

    int degatPris;
    int degatPrisDepuis;

    int caracteristiques[8];
    int degatPhysiqueMin;
    int degatPhysiqueMax;

    int pv;
    int bouclier;
    int pm;
    int multiplicateurDegat;
    int doitPasserTour;

};

#endif
