extern "C"
{
#include "fxlib.h"
#include "LibText.h"
#include "usefull.h"
#include "math.h"
}

#include "generateur.h"
#include "MonochromeLib.h""
#include "donjon.h"


/************************************

Fichier s'occupant de la generation de tout et n'importe quoi, mais surtout du donjon

************************************/


//obtient la distance entre deux lignes
int getDistance(int x1,int taille1,int x2,int taille2)
{
if(x2 >x1 && x2<(x1+taille1))return 0;
if(((x2+taille2) >x1 )&& ((x2+taille2)<(x1+taille1)))return 0;
if(x2<x1 && x2+taille2 >x1+taille1)return 0;
return min(abs(x1-x2+taille2),abs(x2-x1+taille1))+1;
}

//trouve dans quelle salle se situe le point
int quelleSalle(unsigned char* sallesX,unsigned char* sallesY,unsigned char* sallesTailleX,unsigned char* sallesTailleY,int nombreSalle,int X,int Y)
{
for(int i =0;i<nombreSalle;i++)
    {
    if(X>=sallesX[i] && X<sallesX[i]+sallesTailleX[i] && Y>=sallesY[i] && Y<sallesY[i]+sallesTailleY[i])return i;
    }
return -1;
}



//on relie deux portes ensemble
void relierPoint(unsigned char* map,unsigned char* sallesX,unsigned char* sallesY,unsigned char* sallesTailleX,unsigned char* sallesTailleY,int tailleX,int nombreSalle,int pointDebutX,int pointDebutY,int pointFinX,int pointFinY,int salleDebut,int salleFin,unsigned int* voisins)
{
int a = pointDebutX+pointDebutY*tailleX;
int b = pointFinX+pointFinY*tailleX;
int start = a;
int end = b;

if(pointDebutX == pointFinX)
    {
    for(;a!= b;a+=tailleX*((b-a)/abs(b-a)))
        {
        int endroit = quelleSalle(sallesX,sallesY,sallesTailleX,sallesTailleY,nombreSalle,a%tailleX,a/tailleX);
        if(endroit !=-1)
            {
            if(voisins[endroit] &(1<<salleDebut))start = a;
            if(voisins[endroit] &(1<<salleFin))end = a;
            }
        }
    for(a = pointDebutX+pointDebutY*tailleX;a!=b;a+=tailleX)
        {
        int endroit = quelleSalle(sallesX,sallesY,sallesTailleX,sallesTailleY,nombreSalle,a%tailleX,a/tailleX);
        if(endroit !=-1)
            {
            voisins[endroit]=voisins[endroit] |(1<<salleDebut);
            voisins[endroit]=voisins[endroit] |(1<<salleFin);
            }
        }
    for(a = start;a!=end;a+=tailleX)
        {
        if(map[a%(tailleX*tailleX)]==MUR)map[a%(tailleX*tailleX)]=COULOIR;
        }
    }

else if(pointDebutY == pointFinY)
    {
    for(;a!= b;a+=((b-a)/abs(b-a)))
        {
        int endroit = quelleSalle(sallesX,sallesY,sallesTailleX,sallesTailleY,nombreSalle,a%tailleX,a/tailleX);
        if(endroit !=-1)
            {
            if(voisins[endroit] &(1<<salleDebut))start = a;
            if(voisins[endroit] &(1<<salleFin))end = a;
            }
        }
    for(a = pointDebutX+pointDebutY*tailleX;a!=b;a++)
        {
        int endroit = quelleSalle(sallesX,sallesY,sallesTailleX,sallesTailleY,nombreSalle,a%tailleX,a/tailleX);
        if(endroit !=-1)
            {
            voisins[endroit]=voisins[endroit] |(1<<salleDebut);
            voisins[endroit]=voisins[endroit] |(1<<salleFin);
            }
        }
    for(a = start;a!=end;a++)
        {
        if(map[a%(tailleX*tailleX)]==MUR)map[a%(tailleX*tailleX)]=COULOIR;
        }
    }
else//si les points sont en diagonale, on doit faire un coude
    {

    relierPoint(map,sallesX,sallesY,sallesTailleX,sallesTailleY,tailleX,nombreSalle,pointDebutX,pointDebutY,pointDebutX,pointFinY,salleDebut,salleFin,voisins);
    if(pointDebutX>pointFinX)relierPoint(map,sallesX,sallesY,sallesTailleX,sallesTailleY,tailleX,nombreSalle,pointFinX,pointFinY,pointDebutX,pointFinY,salleFin,salleDebut,voisins);
    else relierPoint(map,sallesX,sallesY,sallesTailleX,sallesTailleY,tailleX,nombreSalle,pointDebutX,pointFinY,pointFinX,pointFinY,salleDebut,salleFin,voisins);
    a = pointDebutX+pointFinY*tailleX;
    if(map[a]==MUR)map[a]=COULOIR;
    }
}

void placerPort(unsigned char* map,int tailleX,int point)
{
if(map[point+1] == COULOIR || map[point-1]==COULOIR || map[point+tailleX]==COULOIR || map[point-tailleX]==COULOIR)map[point]=PORTE_FERMEE;
}



//genere un niveau du donjon (algo  ameliorer)
void genererLabyrinthe(unsigned char* map,int tailleX,int tailleY,int tailleSalleMax,int nombreSalle)
{
while(1)
    {
    unsigned char sallesX[MAX_SALLE] = {0};
    unsigned char sallesY[MAX_SALLE] = {0};
    unsigned char sallesTailleX[MAX_SALLE] = {0};
    unsigned char sallesTailleY[MAX_SALLE] = {0};
    unsigned char nombreConnexion[MAX_SALLE] = {0};

    int distance[MAX_SALLE]={0};
    int distanceX[MAX_SALLE]={0};
    int distanceY[MAX_SALLE]={0};

    int best;

    unsigned char porteBaseX=0;
    unsigned char porteBaseY=0;

    unsigned char porteFinX=0;
    unsigned char porteFinY=0;
    unsigned int voisins[MAX_SALLE]={0};

    unsigned char tailleVoulueX=0;
    unsigned char tailleVoulueY=0;
    unsigned char Xvoulu=0;
    unsigned char Yvoulu=0;

    for(int i = 0;i<tailleX*tailleY;i++)map[i]=MUR;

    for(int i = 0;i<nombreSalle;i++)//On place les pieces au hasard dans le donjon
        {
        int flag = 1;
        while(flag)
            {
            tailleVoulueX = 3+min((random(sqrt(tailleSalleMax))+1)*(random(sqrt(tailleSalleMax))+1),tailleSalleMax-3);//Genere des salles ni trop grandes, ni trop petites
            tailleVoulueY = 3+min((random(sqrt(tailleSalleMax))+1)*(random(sqrt(tailleSalleMax))+1),tailleSalleMax-3);
            Xvoulu = random(tailleX-tailleVoulueX-1)+1;
            Yvoulu = random(tailleY-tailleVoulueY-1)+1;
            flag=0;
            for(int j = Xvoulu-2;j<Xvoulu+tailleVoulueX+2;j++)
                for(int k = Yvoulu-2;k<Yvoulu+tailleVoulueY+2;k++)
                    if(map[j+k*tailleX] != MUR)flag=1;//Si il y a conflit avec une autre salle
            }

        for(int j = Xvoulu;j<Xvoulu+tailleVoulueX;j++)
                for(int k = Yvoulu;k<Yvoulu+tailleVoulueY;k++)
                    map[j+k*tailleX] =SALLE;//On peut installer la salle

        sallesX[i] = Xvoulu;
        sallesY[i] = Yvoulu;
        sallesTailleX[i] = tailleVoulueX;
        sallesTailleY[i] = tailleVoulueY;//On retient chaque piece du donjon (pour les couloirs)
        }



    for(int i = 0;i<nombreSalle;i++)//Et on les relies
        {

        best = -1;

        for(int j = 0;j<nombreSalle;j++)//Pour chaque salle, on trouve la plus proche
            {
            if(j != i)
                {
                distanceX[j] = getDistance(sallesX[j],sallesTailleX[j],sallesX[i],sallesTailleX[i]);
                distanceY[j] = getDistance(sallesY[j],sallesTailleY[j],sallesY[i],sallesTailleY[i]);
                distance[j] = sqrt(distanceX[j]*distanceX[j] + distanceY[j]*distanceY[j]);
                }
            }

        for(int j = 0;j<nombreSalle;j++)
            {
            if(j != i && nombreConnexion[j]<4 && !(voisins[i]&(1<<j)) ) if(distance[j]<distance[best] || best == -1)best = j;//on trouve la salle la plus proche repondant aux criteres
            }
        if(best>-1 && best != i)
            {

            if(distanceX[best] == 0)//Si la piece est directement en bas ou en haut
                {
                if(sallesX[best]<=sallesX[i]+sallesTailleX[i] && sallesX[best]>sallesX[i])porteBaseX = random(min(sallesTailleX[best],sallesTailleX[i]-sallesX[best]+sallesX[i]))+sallesX[best];
                else porteBaseX = random(min(sallesTailleX[i],sallesTailleX[best]-sallesX[i]+sallesX[best]))+sallesX[i];
                porteBaseY = sallesY[i]-1+(sallesTailleY[i]+1)*(sallesY[i]<sallesY[best]);
                porteFinX =porteBaseX;
                porteFinY=sallesY[best]-1+(sallesTailleY[best]+1)*(sallesY[i]>sallesY[best]);

                int start = min(porteBaseX+porteBaseY*tailleX,porteFinX+porteFinY*tailleX);
                int end = max(porteBaseX+porteBaseY*tailleX,porteFinX+porteFinY*tailleX);

                if(porteBaseX+porteBaseY*tailleX == start)relierPoint(map,sallesX,sallesY,sallesTailleX,sallesTailleY,tailleX,nombreSalle,start%tailleX,start/tailleX,end%tailleX,end/tailleX,i,best,voisins);
                else relierPoint(map,sallesX,sallesY,sallesTailleX,sallesTailleY,tailleX,nombreSalle,start%tailleX,start/tailleX,end%tailleX,end/tailleX,best,i,voisins);
                placerPort(map,tailleX,start);
                placerPort(map,tailleX,end);
                }
            else if(distanceY[best] == 0)//Si la piece est directementa gauche ou a droite
                {
                if(sallesY[best]<=sallesY[i]+sallesTailleY[i] && sallesY[best]>sallesY[i])porteBaseY = random(min(sallesTailleY[best],sallesTailleY[i]-sallesY[best]+sallesY[i]))+sallesY[best];
                else porteBaseY = random(min(sallesTailleY[i],sallesTailleY[best]-sallesY[i]+sallesY[best]))+sallesY[i];
                porteBaseX = sallesX[i]-1+(sallesTailleX[i]+1)*(sallesX[i]<sallesX[best]);
                porteFinY =porteBaseY;
                porteFinX=sallesX[best]-1+(sallesTailleX[best]+1)*(sallesX[i]>sallesX[best]);

                int start = min(porteBaseX+porteBaseY*tailleX,porteFinX+porteFinY*tailleX);
                int end = max(porteBaseX+porteBaseY*tailleX,porteFinX+porteFinY*tailleX);

                if(porteBaseX+porteBaseY*tailleX == start)relierPoint(map,sallesX,sallesY,sallesTailleX,sallesTailleY,tailleX,nombreSalle,start%tailleX,start/tailleX,end%tailleX,end/tailleX,i,best,voisins);
                else relierPoint(map,sallesX,sallesY,sallesTailleX,sallesTailleY,tailleX,nombreSalle,start%tailleX,start/tailleX,end%tailleX,end/tailleX,best,i,voisins);

               placerPort(map,tailleX,start);
                placerPort(map,tailleX,end);
                }
            else//Si la piece est en diagonale
                {
               // if(random(2))
                    {
                    porteBaseX=random(sallesTailleX[i])+sallesX[i];
                    porteBaseY=sallesY[i]-1+(1+sallesTailleY[i])*(sallesY[best]+sallesTailleY[best]>sallesY[i]);

                    porteFinY=random(sallesTailleY[best])+sallesY[best];
                    porteFinX=sallesX[best]-1+(1+sallesTailleX[best])*(sallesX[best]+sallesTailleX[best]<sallesX[i]);
                    }
                int start = min(porteBaseX+porteBaseY*tailleX,porteFinX+porteFinY*tailleX);
                int end = max(porteBaseX+porteBaseY*tailleX,porteFinX+porteFinY*tailleX);

                if(porteBaseX+porteBaseY*tailleX == start)relierPoint(map,sallesX,sallesY,sallesTailleX,sallesTailleY,tailleX,nombreSalle,start%tailleX,start/tailleX,end%tailleX,end/tailleX,i,best,voisins);
                else relierPoint(map,sallesX,sallesY,sallesTailleX,sallesTailleY,tailleX,nombreSalle,start%tailleX,start/tailleX,end%tailleX,end/tailleX,best,i,voisins);

                placerPort(map,tailleX,start);
                placerPort(map,tailleX,end);
                }

            nombreConnexion[best]++;
            nombreConnexion[i]++;
            voisins[i]=voisins[i]|(1<<best);
            voisins[best]=voisins[best]|(1<<i);
            }
        }
    int flag = 1;
    for(int i = 1;i<nombreSalle && flag;i++)//on vrifie que le donjon est valide
        {
        int secondFlag = 0;
        for(int j =0;j<i;j++)if(voisins[i]&(1<<j))secondFlag=1;
        if(!secondFlag)flag=0;
        }
    if(flag)break;
    }

int j;
do{
int positionX = random(tailleX)*TAILLE_MAX;
int positionY = random(tailleY)*TAILLE_MAX;
j = positionX/TAILLE_MAX+positionY*tailleX/TAILLE_MAX;
}
while((map[j]&MASQUE_N_VISION) != SALLE);
map[j] = ESCALIER_SUIVANT;

for(int i = 0;i<tailleX*tailleY;i++)map[i] = map[i] | INVISIBLE;
}
