 extern "C"
{
#include "fxlib.h"
#include "LibText.h"
#include "usefull.h"
#include "math.h"
}

#include "generateur.h"
#include "MonochromeLib.h"
#include "donjon.h"
#include "PNJ.h"
#include "ennemi.h"
#include "etreVivant.h"
#include "log.h"
#include "heros.h"
#include "donnees.h"
#include "graphisme.h"
#include "string.h"
#include "options.h"


/************************************

La classe du personnage principal

************************************/



void Heros::nouvelEtage(unsigned char* map,unsigned char tailleX,unsigned char tailleY,unsigned char ville)
{
if(ville)
{
positionX = 16;
positionY = 16;
direction = BAS;
return ;
}
int j;
do
    {
    positionX = random(tailleX)*TAILLE_MAX;
    positionY = random(tailleY)*TAILLE_MAX;
    j = positionX/TAILLE_MAX+positionY*tailleX/TAILLE_MAX;
    }
while((map[j]&MASQUE_N_VISION) != SALLE);

map[j] =(map[j]&MASQUE_N_ETRE_VIVANT) |MASQUE_ETRE_VIVANT;
}

void Heros::init()
{
pointCompetence = 0;
for(int i = 0;i<300;i++)sortConnu[i]=0;
levelCompetence=0;
XPCompetence =0;
EtreVivant::init();

positionX = 32;
positionY = 32;
IDsprite = 0;
direction = BAS;

experience=0;
level =1;
refreshCara();
pv = caracteristiques[PV];
pm = caracteristiques[PM];
inventaire[0]=255;
inventaire[1]=7;
armeEquipee = 7;
tailleInventaire =2;
choixObjet = 0;
}

int Heros:: getCDV()
{
return 2;
}

void Heros::refreshCara()
{
if(experience>=10)
    {
    level++;
    experience = 0;
    log("vous gagnez un niveau !",LOG_INFO);
    pv+=(caracteristiquesBase[PV]+9)*3/10;
    pm+=(caracteristiquesBase[PM]+9)/10;
    }
int mult = (9+level);
for(int i = 0;i<7;i++)caracteristiques[i] = caracteristiquesBase[i]* mult/10;
caracteristiques[PV]*=3;
}


int Heros::getXPSuivant()
{
return 10-experience;
}

void Heros::utiliserObjet(int objet)
{

unsigned char precision[6];
getPrecisionObjet(inventaire[objet],precision);
if(precision[0] == POTION)
    {
    if(precision[2]== SOIN_PV)pv+=caracteristiques[PV]*precision[3]/100;
    if(precision[2]== SOIN_PM)pm+=caracteristiques[PM]*precision[3]/100;
    precisionInventaire[objet]--;
    if(pv>caracteristiques[PV])pv = caracteristiques[PV];
    if(pv>caracteristiques[PM])pm = caracteristiques[PM];
    }
else if(precision[0] == EPEE)armeEquipee = inventaire[objet];

}

void Heros::gererInventaire(unsigned char& menuX,unsigned char& menuY,bool& ok,int& menuScrolling,int& menuScrolling2)
{
fenetre(WINDOW_ENCYCLOPEDIE_LISTE);
fenetre(WINDOW_INVENTAIRE_ICONE);
fenetre(WINDOW_INVENTAIRE_AUTRE);


if(menuY>=tailleInventaire && !menuX)menuY = tailleInventaire-1;
if(menuX && menuY>2)menuY = 2;
if(ok)
    {
    if(!menuX)menuX = 1;
    else
        {
        if(menuY == 2)menuX =0;
        else if(menuY == 1){precisionInventaire[choixObjet]--;}
        else if(menuY == 0){utiliserObjet(choixObjet);}
        if(!tailleInventaire)tailleInventaire=1;
        optimiserInventaire();
        if(choixObjet>=tailleInventaire)choixObjet =tailleInventaire-1;
        menuX = 0;
        menuY = choixObjet;
        }
    }
if(!menuX)choixObjet= menuY;
if(inventaire[choixObjet] >200)menuX =0;

String Sfleche("\001");
String Sdescription("");
unsigned char precision[6];
getPrecisionObjet(inventaire[menuY],precision);
getDescriptionObjet(inventaire[menuY],precision,Sdescription);
String Sinventaire("");
String SinventairePrecision("");
String choix("utiliser\nlacher\nretour");
for(int i = 0;i<tailleInventaire;i++)
    {
    getNomObjet(inventaire[i],&Sinventaire);
    Sinventaire+="\n";
    }
for(int i = 0;i<tailleInventaire;i++)
    {
    if(precisionInventaire[i] != 1)SinventairePrecision+=precisionInventaire[i];
    if(inventaire[i] == armeEquipee)SinventairePrecision+="E";
    SinventairePrecision+=" \n";
    }

Sinventaire.afficherMenuDeroulant(5,5,52,58,choixObjet,menuScrolling,tailleInventaire);
SinventairePrecision.afficherMenuDeroulant(53,5,70,58,choixObjet,menuScrolling,tailleInventaire,0,0);
if(!menuX)
    {

    if(menuScrolling2>0x40000)menuScrolling2 = 0;
    int retour = Sdescription.afficherTexteDefilant(69,31,124,60,(menuScrolling2&0xFFF)>>1);
    if(retour == 1)menuScrolling2++;
    else if(retour == 2)menuScrolling2+=0x1000;
    else menuScrolling2 = 0;


    }


else choix.afficherMenuDeroulant(77,33,124,60,menuY,menuScrolling,3);
afficherSpriteObjet(inventaire[choixObjet],77,5,16);



fenetre(WINDOW_ENCYCLOPEDIE_LISTE,0);
fenetre(WINDOW_INVENTAIRE_ICONE,0);
fenetre(WINDOW_INVENTAIRE_AUTRE,0);
}







int Heros::lancerSort(unsigned char lequel,EtreVivant** etrevivant,int nombreEtreVivant)
{

unsigned char cout = getCoutSort(lequel);
if(((cout&MASQUE_SORT_COUT_NIVEAU)>>4)>level)
	{
    log("niveau insuffisant !",LOG_WARNING);
    return 0;
	}
if((cout&MASQUE_SORT_COUT_MANA)>pm)
    {
    log("mana insuffisant !",LOG_WARNING);
    return 0;
	}
if(!connaitSort(lequel))
    {
    log("Sort non-appris !",LOG_WARNING);
    return 0;
    }

EtreVivant::lancerSort(lequel, etrevivant, nombreEtreVivant);

String lanceSort("vous lancez ");
lanceSort+=getNomSort(lequel);
log(lanceSort.getStr(),LOG_VERBOSE);
return 1;
}

void Heros::victoireEnnemi(EtreVivant* ennemi)
{
int gain =ennemi->getLevel()-getLevel()+3;
if(gain<=0)return;
String gainXP("vous gagnez ");
gainXP+=gain;
gainXP+=" XPs";
log(gainXP.getStr(),LOG_INFO);
experience+=gain;
}

void Heros::afficherHUD(int X,int Y,int tailleX,int tailleY,unsigned char* argument)
{

String string("pv ");
if(argument[0]>1)
    {
    string += pv;
    if(argument[0] > 2)
        {
        string+="/";
        string+=caracteristiques[PV];
        }
    }
if(argument[0])string.afficher(argument[1],argument[2]);

string.~String();
string+="pm ";
if(argument[3]>1)
    {
    string += pm;
    if(argument[3] >2)
        {
        string+="/";
        string+=caracteristiques[PM];
        }
    }
if(argument[3])string.afficher(argument[4],argument[5]);


string.~String();
string+="next ";
string += getXPSuivant();
if(argument[6])string.afficher(argument[7],argument[8]);

string.~String();
string+="bou ";
string += bouclier;
if(argument[9])string.afficher(argument[10],argument[11]);
}



int Heros::getXPCompetence()
{
return XPCompetence;
}

int Heros::recevoirXPCompetence()
{
XPCompetence++;
if(XPCompetence == getXPCompetenceNextLevel(getLevelCompetence()))
    {
    levelCompetence++;
    pointCompetence++;
    XPCompetence = 0;
    return 1;
    }
return 0;
}

int Heros::getPourcentageXPCompetence()
{
return XPCompetence*100/getXPCompetenceNextLevel(getLevelCompetence());
}

int Heros::getXPCompetenceNextLevel(int lequel)
{
return (1+lequel)*10;
}


void Heros::apprendreSort(int lequel)
{
sortConnu[lequel]=1;
//sortConnu[lequel<<3]|=1<<(lequel&7);
pointCompetence--;
}


int Heros::getLevelCompetence()
{
return levelCompetence;
}


void Heros::afficherEcranPersonnage()
{
String multiplicateurEntier((level+9)/10);
String multiplicateurDecimal((level+9)%10);

String multiplicateurEntierPV(((level+9)*3)/10);
String multiplicateurDecimalPV(((level+9)*3)%10);

String multiplicateur(multiplicateurEntier.getStr());
String multiplicateurPV(multiplicateurEntierPV.getStr());
String etoile("*");
String point(":");
String egal("=");
int Xbase = 18;
if((level+9)%10)
    {
    multiplicateur+=",";multiplicateur+=multiplicateurDecimal.getStr();
    multiplicateurPV+=",";multiplicateurPV+=multiplicateurDecimalPV.getStr();
    }

char nomCara[7][20] = {"PV Max","PM Max","force","vigueur","intel.","mental","chance"};
//afficherHUD(60,6,0,0);
for(int i = 0;i<7;i++)
    {
    String temp1(nomCara[i]);temp1.afficher(6,Xbase+6*i);
    point.afficher(36,Xbase+6*i);
    String temp2(caracteristiquesBase[i]);temp2.afficher(42,Xbase+6*i);
    etoile.afficher(52,Xbase+1+6*i);
    if(i)multiplicateur.afficher(58,Xbase+6*i);
    else multiplicateurPV.afficher(58,Xbase+6*i);
    egal.afficher(72,Xbase+6*i);
    String temp3(caracteristiques[i]);temp3.afficher(78,Xbase+6*i);
    }
String niveau ="niveau : ";
niveau+=level;
niveau.afficher(7,7);
}


void Heros::choixRace(int choix)
{
unsigned char caracteristiqueT[11][7]=
        {
        {10,10,10,10,10,10,10},
        {12,9,12,11,9,8,9},
        {8,12,8,9,12,12,9},
        {11,8,12,12,7,8,12},
        {9,12,12,8,12,8,9},
        {11,10,10,12,8,12,7},
        {11,9,9,11,9,9,12},
        {13,5,13,11,5,9,12},
        {12,12,12,12,12,12,12},
        {13,13,13,13,13,13,13},
        {15,15,15,15,15,15,15}
        };

for(int i = 0;i<7;i++)caracteristiquesBase[i]=caracteristiqueT[choix][i];
refreshCara();
pv = caracteristiques[PV];
pm = caracteristiques[PM];
}


int Heros::payer(int cout)
{
optimiserInventaire();
if(inventaire[1] != 0)return 0;
if(precisionInventaire[1]<cout)return precisionInventaire[1];
else precisionInventaire[1]-=cout;
optimiserInventaire();
return -1;
}

void Heros::nuitAuberge(int cout)
{
if(payer(cout) != -1)payer(payer(cout));
refreshCara();
pv = caracteristiques[PV];
pm = caracteristiques[PM];
}

void Heros::ramasser(Objet* objet)
{
objet->ramasser();
recevoirObjet(objet->getID());

optimiserInventaire();
}


void Heros::recevoirObjet(int ID)
{
inventaire[tailleInventaire]=ID;
precisionInventaire[tailleInventaire]=1;
tailleInventaire++;   
}


void Heros::optimiserInventaire()
{
unsigned char nouvelOrdre[TAILLE_INVENTAIRE] = {255};
unsigned char nouvelOrdrePrecision[TAILLE_INVENTAIRE] = {1};
unsigned char position = 1;
int tailleMax = 0;
for(int i = 1;i<tailleInventaire;i++)
    {
    int best = -1;
    for(int j = 1 ;j<tailleInventaire;j++)
        {
        if(precisionInventaire[j])
            {
            if(best == -1)best = j;
            if(inventaire[best]>inventaire[j])best = j;
            }
        }

    if(best != -1)
        {
        int flag = 0;
        for(int j = 1;j<position;j++)
            {
            if(nouvelOrdre[j] == inventaire[best] && nouvelOrdrePrecision[j] < 120)
                {
                nouvelOrdrePrecision[j]+=precisionInventaire[best];
                flag = 1;
                }
            }
        if(!flag)
            {
            nouvelOrdre[position]=inventaire[best];
            nouvelOrdrePrecision[position]=precisionInventaire[best];
            position++;
            }
        precisionInventaire[best] = 0;
        }
    }

tailleInventaire = position;//max(tailleMax+1,position);
for(int i = 0;i<tailleInventaire;i++)
    {
    inventaire[i]=nouvelOrdre[i];
    precisionInventaire[i]=nouvelOrdrePrecision[i];
    }

}

int Heros::getPointCompetence()
{
return pointCompetence;
}


bool Heros::connaitSort(unsigned char lequel)
{
return sortConnu[lequel];
return sortConnu[lequel<<3]&(1<<(lequel&7));
}

void Heros::memoire(Sauvegarde& sauvegarde)
{
EtreVivant::memoire(sauvegarde);
unsigned char tailleCara = 24;
unsigned char tailleSort = NOMBRE_SORT;
sauvegarde.addTab(inventaire,tailleInventaire);
sauvegarde.addTab(precisionInventaire,tailleInventaire);
sauvegarde.addTab((unsigned char*)caracteristiquesBase,tailleCara);
sauvegarde.addTab(sortConnu,tailleSort);
sauvegarde.addInt(argent);
sauvegarde.addInt(pointCompetence);
sauvegarde.addInt(levelCompetence);
sauvegarde.addInt(XPCompetence);

}


void Heros::effetArme(EtreVivant* ennemi)
{
unsigned char precision[6];
getPrecisionObjet(armeEquipee,precision);
if(precision[1]>level){precision[3]=1;precision[4]=2;}//on verifie le niveau du heros
int degat = ennemi->subirDegat(random(precision[4]-precision[3]+1)+precision[3],PHYSIQUE,caracteristiques[FORCE]);

if(precision[2] == D_BOUCLIER)bouclier+=degat*precision[5]/100;
if(precision[2] == D_EXECUTION && !ennemi->getVivant())bouclier+=degat*precision[5]/100;

if(precision[2] == D_MAGIQUE)
    {
    precision[3]=precision[3]*precision[5]/100;
    precision[4]=precision[4]*precision[5]/100;
    ennemi->subirDegat(random(precision[4]-precision[3]+1)+precision[3],MAGIQUE,caracteristiques[INTELLIGENCE]);
    }
}

void Heros::finDonjon()
{
level = 1;
experience = 0;
pv = pv*100/caracteristiques[PV];
pm = pm*100/caracteristiques[PM];
refreshCara();
pv = pv*caracteristiques[PV]/100;
pm = pm*caracteristiques[PM]/100;
if(pv<1)pv = 1;
bouclier = 0;
}


