#include "options.h"
extern "C"
{
#include "LibText.h"
}

/************************************

Classe abstraite pour la gestion des options

************************************/

/************************************

Pour le stockage des options; cela reste local au fichier, car les fonctions get et set sont pas faites pour les chiens

************************************/

static unsigned char stockageOptions[3] = {0,0,0x19};



/************************************

Fonctions get, pour obtenir le choix d'options

************************************/


int Options::getIcone()
{
return stockageOptions[0]&0xF;
}

int Options::getFenetre()
{
return (stockageOptions[0]&0xF0)>>4;
}

int Options::getFont()
{
return stockageOptions[1]&0x0F;
}

int Options::getCamera()
{
return stockageOptions[1]&0x30;
}

int Options::getZoom()
{
return stockageOptions[1]&0xC0;
}

unsigned char Options::getLargeurFont()
{
unsigned char temp[9] ={0x3,0x3,0x5,0x5,0x5,0x6,0x6,0x6,0x6};
return temp[Options::getFont()];
}

unsigned char Options::getHauteurFont()
{
unsigned char temp[9] ={0x5,0x5,0x7,0x7,0x5,0x7,0x7,0x7,0x7};
return temp[Options::getFont()];
}


int Options::getVitesse()
{
return (stockageOptions[2] & 0x6)>>1;
}

bool Options::getDouxScrolling()
{
return stockageOptions[2]&1;
}

int Options::getFPS()
{
return (stockageOptions[2]&0x38)>>3;
}

/************************************

Fonction set, pour definir le choix d'options

************************************/


void Options::setFPS(unsigned char lequel)
{
stockageOptions[2] =(stockageOptions[2]&0xC7)|(lequel<<3);
}


void Options::setVitesse(unsigned char lequel)
{
stockageOptions[2] =(stockageOptions[2]&0xF9)|(lequel<<1);
}


void Options::setDouxScrolling(bool choix)
{
stockageOptions[2] = (stockageOptions[2]&0xFE)|choix;
}

void Options::setCamera(unsigned char lequel)
{
stockageOptions[1] = (stockageOptions[1]&0xCF)|(lequel<<4);
}

void Options::setZoom(unsigned char lequel)
{
stockageOptions[1] = (stockageOptions[1]&0x3F)|(lequel<<6);
}

void Options::setIcone(unsigned char lequel)
{
stockageOptions[0] =(stockageOptions[0]&0xF0)|lequel;
}

void Options::setFenetre(unsigned char lequel)
{
stockageOptions[0] =(stockageOptions[0]&0xF)|(lequel<<4);
}



void Options::setFont(unsigned char lequel)
{
Txt_Quit();
Txt_Init(1<<lequel);
stockageOptions[1] =(stockageOptions[1]&0xF0)|lequel;
}
