extern "C"
{
#include "fxlib.h"
#include "LibText.h"
#include "usefull.h"
#include "math.h"
}

#include "generateur.h"
#include "MonochromeLib.h"
#include "donjon.h"
#include "PNJ.h"
#include "ennemi.h"
#include "etreVivant.h"
#include "heros.h"
#include "graphisme.h"
#include "string.h"
#include "donnees.h"

#define ZONE_DEVANT 0
#define ZONE_LIGNE_TROIS_DEVANT 1
#define ZONE_LIGNE_TROIS_DIAGO 2
#define ZONE_CARRE_TROIS 3
#define ZONE_CARRE_CINQ 4
#define ZONE_LIGNE_CARRE_TROIS 5
#define ZONE_CASE_UN_DISTANCE 6
#define ZONE_LOSANGE_CINQ_TROIS_DISTANCE 7
#define ZONE_CONE_DEUX_SOI_INCLUS 8
#define ZONE_LIGNE_DIAGO_TROIS_DISTANCE 9
#define ZONE_CONE_UN 0xA
#define ZONE_VOISIN_DIRECT 0xB
#define ZONE_CARRE_INCLUS_TROIS 0xC

#define ZONE_LIGNE_UN_ENNEMI 0xF

#define MASQUE_SORT_MAGIQUE_ZONE  0x1E00
#define MASQUE_SORT_MAGIQUE_MIN   0x01F0
#define MASQUE_SORT_MAGIQUE_MAX   0x000C
#define MASQUE_SORT_MAGIQUE_EFFET 0x0003


/*******************************************************************************************

ce fichier contient tout ce qui concerne les sorts, car il s'agit de grosses fonctions.
pour eviter de surcharger le fichier etreVivant, elles ont ete mises ici ;)

*******************************************************************************************/

void EtreVivant::ennemiToucheParSort(unsigned char zone,int& nombreVerification,int* XaVerifier,int* YaVerifier,int caseX,int caseY)
{

if(caseX == -1)caseX = positionX/TAILLE_MAX;
if(caseY == -1) caseY = positionY/TAILLE_MAX;

XaVerifier[0]=caseX+delta[direction][0];
YaVerifier[0]=caseY+delta[direction][1];

switch(zone)
    {

    case ZONE_LIGNE_UN_ENNEMI:


    case ZONE_LIGNE_TROIS_DEVANT:
        XaVerifier[1]=caseX+delta[direction][0]*2;
        YaVerifier[1]=caseY+delta[direction][1]*2;
        XaVerifier[2]=caseX+delta[direction][0]*3;
        YaVerifier[2]=caseY+delta[direction][1]*3;
        nombreVerification=3;
        break;

    case ZONE_CARRE_INCLUS_TROIS:
        for(int i = 0;i<3;i++)for(int j = 0;j<3;j++,nombreVerification++){XaVerifier[nombreVerification]=caseX+j-1;YaVerifier[nombreVerification]=caseY+i-1;}
        break;
    case ZONE_CARRE_TROIS:
        for(int i = 0;i<3;i++)for(int j = 0;j<3;j++,nombreVerification++)if(i != 1 || j !=1){XaVerifier[nombreVerification]=caseX+j-1;YaVerifier[nombreVerification]=caseY+i-1;}else nombreVerification--;
        break;

    case ZONE_CARRE_CINQ:
        for(int i = 0;i<5;i++)for(int j = 0;j<5;j++)if(i != 2 || j !=2){XaVerifier[i*5+j]=caseX+j-2;YaVerifier[i*5+j]=caseY+i-2;}
        nombreVerification=24;
        break;



    case ZONE_CASE_UN_DISTANCE:
        XaVerifier[0]=caseX+delta[direction][0]*2;
        YaVerifier[0]=caseY+delta[direction][1]*2;
        break;

    case ZONE_LOSANGE_CINQ_TROIS_DISTANCE:
        caseX+=delta[direction][0]*3;
        caseY+=delta[direction][1]*3;
        nombreVerification=0;
        for(int i = -2;i<=2;i++)
            {
            for(int j = -(2-abs(i));j<=2-abs(i);j++)
                {
                nombreVerification++;
                XaVerifier[nombreVerification]=caseX+i;
                YaVerifier[nombreVerification]=caseY+j;
                }
            }

        break;

    case ZONE_CONE_DEUX_SOI_INCLUS:
        XaVerifier[0]=caseX;
        YaVerifier[0]=caseY;
        for(int i = 0;i<3;i++){XaVerifier[1+i]=caseX+delta[direction][0]+delta[direction][1]*(1-i);YaVerifier[1+i]=caseY+delta[direction][1]+delta[direction][0]*(1-i);}
        for(int i = 0;i<5;i++){XaVerifier[5+i]=caseX+delta[direction][0]*2+delta[direction][1]*(2-i);YaVerifier[5+i]=caseY+delta[direction][1]*2+delta[direction][0]*(2-i);}
        nombreVerification=9;
        break;

    case ZONE_LIGNE_DIAGO_TROIS_DISTANCE:

        caseX+=delta[direction][0]*2;
        caseY+=delta[direction][1]*2;

        XaVerifier[0]=caseX+delta[direction][0];
        YaVerifier[0]=caseY+delta[direction][1];

        //pas de break ici, c'est normal :p
    case ZONE_LIGNE_TROIS_DIAGO:
        XaVerifier[1]=caseX+delta[direction][0]+delta[direction][1];
        YaVerifier[1]=caseY+delta[direction][1]+delta[direction][0];
        XaVerifier[2]=caseX+delta[direction][0]-delta[direction][1];
        YaVerifier[2]=caseY+delta[direction][1]-delta[direction][0];
        nombreVerification=3;
        break;


    case ZONE_CONE_UN://TODO !!
    break;

    case ZONE_VOISIN_DIRECT:
        for(nombreVerification = 0;nombreVerification<4;nombreVerification++)
            {
            XaVerifier[nombreVerification]=caseX+delta[nombreVerification][0];
            YaVerifier[nombreVerification]=caseY+delta[nombreVerification][1];
            }
        break;

    default :break;
	}
}



void EtreVivant::lancerSort(unsigned char lequel,EtreVivant** etreVivant,int nombreEtreVivant)
{
int cibles[4];
int nombreCible = 0;
int nombreVerification=1;
int XaVerifier[25];
int YaVerifier[25];
int caseX = positionX/TAILLE_MAX;
int caseY = positionY/TAILLE_MAX;
unsigned short effet = getEffetSort(lequel);
unsigned char cout = getCoutSort(lequel);
int degatMax = 2;
int degatMin = 1;


typeSortEnCours = ID_SORT_BASE+lequel;
sortEnCours = 1;
animationSortEnCours = getAnimationSort(lequel);

pm-=(cout&MASQUE_SORT_COUT_MANA);



if((effet & MASQUE_SORT_TYPE) == 0)//sort de CAC
    {
    int effetEnnemi = (effet&MASQUE_SORT_CAC_EFFET_ENNEMI)>>2;
    if(effetEnnemi == 3)direction = retournement();//on se retourne
    int zone = (effet & MASQUE_SORT_CAC_ZONE)>>10;
    ennemiToucheParSort(zone-2*(zone==5)-(zone == 4),nombreVerification,XaVerifier,YaVerifier);

    for(int i = 0;i<nombreVerification;i++)
        for(int j = 0;j<nombreEtreVivant;j++)
            if(etreVivant[j]->getX()/TAILLE_MAX == XaVerifier[i] && etreVivant[j]->getY()/TAILLE_MAX == YaVerifier[i] && etreVivant[j]->getVivant())
                {
                cibles[nombreCible]=j;
                nombreCible++;
                }

    unsigned char nombreEffet = (((effet&MASQUE_SORT_CAC_DEGAT)>>4)+1)/2;

    if(zone < 4)
        for(int i =0;i<nombreCible;i++)
            for(int k = 0;k<nombreEffet;k++)effetArme(etreVivant[cibles[i]]);
            //etreVivant[cibles[i]]->subirDegat(random(degatMax-degatMin+1)+degatMin,PHYSIQUE,caracteristiques[FORCE]);


    else //ce code pourrait etre automatise avec un deuxieme tableau, mais comme il n'y en a que 3, je pense que cela ne vaut pas le coup
        {
        if(nombreCible)
            {
            int first = random(nombreCible);
            int second = random(nombreCible);
            int third = random(nombreCible);
            if(nombreCible>1)
                {
                while(second == first)second = random(nombreCible);
                for(int k = 0;k<nombreEffet;k++)effetArme(etreVivant[cibles[first]]);
                for(int k = 0;k<nombreEffet;k++)effetArme(etreVivant[cibles[second]]);
                if(zone == 5 && nombreCible>2)
                    {
                    while(third == first || third == second)third = random(nombreCible);
                    for(int k = 0;k<nombreEffet;k++)effetArme(etreVivant[cibles[third]]);
                    //etreVivant[cibles[third]]->subirDegat(random(degatMax-degatMin+1)+degatMin,PHYSIQUE,caracteristiques[FORCE]);
                    nombreCible=3;
                    }
                else nombreCible=2;
                }
            else for(int k = 0;k<nombreEffet;k++)effetArme(etreVivant[cibles[0]]);

            first = cibles[first];
            second = cibles[second];
            third = cibles[third];

            cibles[0]=first;
            cibles[1]=second;
            cibles[2]=third;
            }
        }
    if(nombreCible == 0)return;
    int activationContrecoups = (effet&MASQUE_SORT_CAC_ACTIVATION_CONTRECOUPS)>>8;
    int ennemiVivant = etreVivant[cibles[0]]->getVivant();
    if(activationContrecoups ==1 || (activationContrecoups == 2 && !ennemiVivant) || (activationContrecoups == 3 && ennemiVivant))
        {
        int typeContrecoups = (effet&MASQUE_SORT_CAC_CONTRECOUPS)>>6;
        if(!typeContrecoups)effetArme(this);
          //  subirDegat(random(degatPhysiqueMax-degatPhysiqueMin+1)+degatPhysiqueMin,PHYSIQUE,caracteristiques[FORCE]);
        if(typeContrecoups==1)passeTour();
        if(typeContrecoups==2)faiblesse();//TODO subir 50 degat en plus
        }


    int effetLanceur= (effet&MASQUE_SORT_CAC_EFFET_LANCEUR);

    if(effetEnnemi == 1)etreVivant[cibles[0]]->faiblesse();//TODO ennemi subit 50 degat en plus
    if(effetEnnemi == 2)etreVivant[cibles[0]]->passeTour();

    if(effetLanceur == 1)resistance();//TODO lanceur 50 resistance en plus
    if(effetLanceur == 2);//TODO rejoue si victoire
    if(effetLanceur == 3);//TODO met le joueur derriere l'ennemi

    for(int i = 0;i<nombreCible;i++)if(!etreVivant[cibles[i]]->getVivant())victoireEnnemi(etreVivant[cibles[i]]);
    }


if((effet & MASQUE_SORT_TYPE)>>13 == 1)//sort de degat magique
    {
    int zone = (effet & MASQUE_SORT_MAGIQUE_ZONE)>>9;
    if(zone !=ZONE_LIGNE_CARRE_TROIS)ennemiToucheParSort(zone,nombreVerification,XaVerifier,YaVerifier);
    else
        {
        ennemiToucheParSort(ZONE_LIGNE_TROIS_DEVANT,nombreVerification,XaVerifier,YaVerifier);
        for(int i = 0;i<nombreVerification;i++)
        for(int j = 0;j<nombreEtreVivant;j++)
            if(etreVivant[j]->getX()/TAILLE_MAX == XaVerifier[i] && etreVivant[j]->getY()/TAILLE_MAX == YaVerifier[i] && etreVivant[j]->getVivant())
                {
                cibles[nombreCible]=j;
                nombreCible++;
                }
        nombreVerification=0;
        if(nombreCible)
            {
            nombreCible = 0;
            ennemiToucheParSort(ZONE_CARRE_INCLUS_TROIS,nombreVerification,XaVerifier,YaVerifier,etreVivant[cibles[0]]->getX()/TAILLE_MAX,etreVivant[cibles[0]]->getY()/TAILLE_MAX);
            }
        }

    for(int i = 0;i<nombreVerification;i++)
        for(int j = 0;j<nombreEtreVivant;j++)
            if(etreVivant[j]->getX()/TAILLE_MAX == XaVerifier[i] && etreVivant[j]->getY()/TAILLE_MAX == YaVerifier[i] && etreVivant[j]->getVivant())
                {
                cibles[nombreCible]=j;
                nombreCible++;
                }


    degatMax = ((effet&MASQUE_SORT_MAGIQUE_MAX)>>1)+2;
    degatMin = (effet&MASQUE_SORT_MAGIQUE_MIN)>>4;

    if(zone == ZONE_LIGNE_UN_ENNEMI && nombreCible)nombreCible = 1;

    int effetSup = effet&3;//la flemme de faire un define

    int degatInflige = 0;
    for(int i =0;i<nombreCible;i++)
        degatInflige+=etreVivant[cibles[i]]->subirDegat(random(degatMax)+degatMin,MAGIQUE,caracteristiques[INTELLIGENCE]);
    if(effetSup == 3)bouclier+=degatInflige;
    }

}



void EtreVivant::afficherSort(int fenetreX,int fenetreY,int cameraX,int cameraY,unsigned char tailleSprite)
{
if(!sortEnCours)return;
int spriteX = (positionX-cameraX)/(TAILLE_MAX/tailleSprite)+fenetreX;
int spriteY =(positionY-cameraY)/(TAILLE_MAX/tailleSprite)+fenetreY;

afficherSpriteEtreVivant(IDsprite,direction,positionX,positionY,spriteX,spriteY,tailleSprite);

if(animationSortEnCours == 2)
    {
    int Xbase = (8+(positionX+delta[direction][0]*sortEnCours*3+delta[direction][1]*sortEnCours*3)-cameraX)/(TAILLE_MAX/tailleSprite)+fenetreX;
    int Ybase = (8+(positionY+delta[direction][0]*sortEnCours*3+delta[direction][1]*sortEnCours*3)-cameraY)/(TAILLE_MAX/tailleSprite)+fenetreY;

    int Xfin = (8+(positionX+delta[direction][0]*sortEnCours*3-delta[direction][1]*sortEnCours*3)-cameraX)/(TAILLE_MAX/tailleSprite)+fenetreX;
    int Yfin = (8+(positionY+delta[direction][1]*sortEnCours*3-delta[direction][0]*sortEnCours*3)-cameraY)/(TAILLE_MAX/tailleSprite)+fenetreY;

    ML_rectangle(Xbase+1,Ybase+1,Xfin,Yfin,0,ML_BLACK,ML_BLACK);
    }
else if(animationSortEnCours == 3)
    {
    int Xbase = (8+(positionX+sortEnCours*3)-cameraX)/(TAILLE_MAX/tailleSprite)+fenetreX;
    int Ybase = (8+(positionY+sortEnCours*3)-cameraY)/(TAILLE_MAX/tailleSprite)+fenetreY;

    int Xfin = (8+(positionX-sortEnCours*3)-cameraX)/(TAILLE_MAX/tailleSprite)+fenetreX;
    int Yfin = (8+(positionY-sortEnCours*3)-cameraY)/(TAILLE_MAX/tailleSprite)+fenetreY;

    ML_rectangle(Xbase+1,Ybase+1,Xfin,Yfin,2,ML_BLACK,ML_TRANSPARENT);
    }
else if(animationSortEnCours == 6)
    {
    ML_line(spriteX+tailleSprite/2,spriteY+tailleSprite/2,spriteX+tailleSprite/2+delta[direction][0]*tailleSprite*3,spriteY+tailleSprite/2+delta[direction][1]*tailleSprite*3,ML_BLACK);
    }
}
